* TSBrowse testing superheaders

#define _VIDEO_CH
#define _DDE_CH

#include "fivewin.ch"
#include "TSBrowse.ch"

#define CLR_PINK   nRGB( 255, 128, 128)
#define CLR_NBLUE  nRGB( 128, 128, 192)

Static oWnd

//--------------------------------------------------------------------------//

Function Main()

   Local oBmp

   DEFINE BITMAP oBmp FILE "..\bitmaps\Cover.bmp" OF oWnd

   DEFINE WINDOW oWnd TITLE "Super Headers with TSBrowse" ;
          COLORS CLR_BLACK, CLR_BLUE ;
          MENU BuildMenu()

   SET MESSAGE OF oWnd CLOCK DATE KEYBOARD NOINSET

   If "FWH" $ FWVERSION .or. "FiveWin 2.2" $ FWVERSION .or. "FiveWin 2.3" $ FWVERSION
      ACTIVATE WINDOW oWnd MAXIMIZED ;
               ON PAINT DrawBitmap( hDC, oBmp:hBitMap, ;
                        ( oWnd:nHeight() / 2 ) - ( oBmp:nHeight() / 2 ) - 50, ;
                        ( oWnd:nWidth() / 2 ) - ( oBmp:nWidth() / 2 ) )
   Else
      ACTIVATE WINDOW oWnd MAXIMIZED ;
               ON PAINT DrawBitmap( hDC, oBmp:hBmpPal, ;
                        ( oWnd:nHeight() / 2 ) - ( oBmp:nHeight() / 2 ) - 50, ;
                        ( oWnd:nWidth() / 2 ) - ( oBmp:nWidth() / 2 ) )
   EndIf

   DbCloseAll()
   
   Release Objects oBmp

Return nil

//--------------------------------------------------------------------------//

Static Function BuildMenu()

   Local oMenu

   MENU oMenu
      MENUITEM "TSBrowse"
         MENU
            MENUITEM "Super Columns" ACTION fSuperCol()
            MENUITEM "BitMaps" ACTION fSuperBit()
         ENDMENU
      MENUITEM "&Exit" ACTION oWnd:End()
      MENUITEM "&Help" ACTION WinExec( "Start ..\doc\Help.htm", 0 )
   ENDMENU

Return oMenu

//--------------------------------------------------------------------------//

Static Function fSuperCol()

   Local oDlg, oBrw, oFont, oFont1, xVar, ;
         aMeses := { "January", "February", "March", "April", "May", "June", ;
                     "July", "August", "September", "October", ;
                     "November", "December" }

   Field Code

   Use Products Shared New
   Index On Code To Products

   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0, -12
   DEFINE BITMAP oBmp FILE "Logo.bmp"

   DEFINE DIALOG oDlg FROM 0,0 TO 400, 500 PIXEL FONT oFont ;
          TITLE OemToAnsi( "Super Columns" )

   @0,0 BROWSE oBrw ALIAS "Products" CELLED SIZE 250, 200 PIXEL OF oDlg ;
        COLORS CLR_BLACK, CLR_NBLUE

   ADD COLUMN TO oBrw TITLE "Code" DATA Products->Code EDITABLE

   ADD COLUMN TO oBrw TITLE "Product" DATA Products->Descr EDITABLE

   For xVar := 1 To 12
      bData := &( "{ || Products->Unit" + LTrim( Str( xVar ) ) + "}" )
      ADD COLUMN TO oBrw TITLE "Quantity" DATA bData EDITABLE

      bData := &( "{ || Products->Import" + LTrim( Str( xVar ) ) + "}" )
      ADD COLUMN TO oBrw TITLE "Import" DATA bData EDITABLE
   Next

   nVar1 := 3
   For nVar2 := 1 To 12
      ADD SUPER HEADER TO oBrw FROM COLUMN nVar1 TO COLUMN ++nVar1 ;
          TITLE aMeses[ nVar2 ] FONT oFont
      ++nVar1
   Next

   oBrw:nFreeze := 2
   oBrw:nHeightCell += 1

   ACTIVATE DIALOG oDlg CENTERED VALID ( oFont:End(), .T. )

   DbCloseArea()

Return Nil


//--------------------------------------------------------------------------//

Static Function fSuperBit()

   Local oDlg, oBrw, oFont, oFont1, xVar, oBmp

   Field First, Last

   Use Employee Shared New
   Index On First+Last To Employee

   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0, -12
   DEFINE BITMAP oBmp FILE "..\bitmaps\Logo.bmp"

   DEFINE DIALOG oDlg FROM 0,0 TO 400, 500 PIXEL FONT oFont ;
          TITLE "Super Headers ( BitMaps ) "

   @0,0 BROWSE oBrw ALIAS "Employee" CELLED SIZE 250, 200 PIXEL OF oDlg ;
        COLORS CLR_BLACK, CLR_NBLUE

   oBrw:LoadFields( .T. )


   ADD SUPER HEADER TO oBrw FROM COLUMN 1 TO COLUMN 4 ;
       TITLE oBmp:hBmpPal BITMAP NOLINES

   ACTIVATE DIALOG oDlg CENTERED VALID ( oFont:End(), oBmp:End(), .T. )

   DbCloseArea()

Return Nil
