*-- PROGRAM FILE -------------------------------------------------------
*  Application: Addon for FiveWin
*  Description: TBtnGet - Colored TGet class with button
*    File Name: tbtnget.prg
*       Author: Ricardo Ramirez       Tester: Ricardo Ramirez
* Date created: 1998-01-01            Date updated: 2001-03-26
* Time created: 8:17:12PM             Time updated: 16:028:17M
*    Copyright: (c) 1998-2000 by Punto-Co
*
* $Id: BTNGET.C,v 1.4 2001/03/26 21:28:17 RRamirez Exp $
*
* Compliments of:
*  George Georguiev
*
* Adapted by Manuel Mercado for TSBrowse 2002/04/05
* Changes are commented with "// TSBrowse"
* The Class Name changes to "TSBtnGet" to avoid conflicts with other applications
*
*-----------------------------------------------------------------------

#include "FiveWin.ch"

#define GWL_STYLE         -16
#define GWL_EXSTYLE       -20
#define DS_3DLOOK           4
#define SM_CYVSCROLL       20

#define WM_NCHITTEST      132  // 0x0084   // TSBrowse added

Extern TBtnDown, GetBtn     // TSBrowse added
Static nsLastKey            // TSBrowse added

CLASS TSBtnGet FROM TGet

   DATA   bAction, cResName, oBtn, lBtnORBmp
   DATA   nClrPFoText, nClrPFoPane, nClrDef
   DATA   nBmpWidth, bTmpValid
   DATA   lRightLeftExit AS LOGICAL INIT .F. // TSBrowse added
   DATA   lReturn        AS LOGICAL INIT .F. // TSBrowse added
   DATA   nFireKey                           // TSBrowse added
   DATA   lFixCaret                          // TSBrowse added
   DATA   nClrFocuText, nClrFocuPane


   METHOD ClassName() INLINE "TGET"

   METHOD New( nRow, nCol, bSetGet, oWnd, nWidth, nHeight, cPict, ;
               bValid, nClrFore, nClrBack, oFont, lDesign, oCursor, ;
               lPixel, cMsg, lUpdate, bWhen, lCenter, lRight, bChanged,;
               lReadOnly, lPassword, lNoBorder, nHelpId, cResName, ;
               bAction, lSpinner, bUp, bDown, bMin, bMax, nBmpWidth ) ;
               CONSTRUCTOR

   METHOD ReDefine( nId, bSetGet, oWnd, nHelpId, cPict, bValid, ;
               nClrFore, nClrBack, oFont, oCursor, cMsg, lUpdate, ;
               bWhen, bChanged, lReadOnly, lSpinner, bUp, bDown, bMin, ;
               bMax, cResName, bAction ) CONSTRUCTOR

   METHOD Default()
   METHOD Initiate( hDlg ) INLINE Super:Initiate( hDlg ), ::Default()
   METHOD SetIniClr()

   METHOD GetDlgCode( nLastKey )             // TSBrowse added
   METHOD GotFocus()                         // TSBrowse added
   METHOD _GotFocus( hCtlLost )              // TSBrowse added
   METHOD KeyDown( nKey, nFlags)             // TSBrowse added
   METHOD KeyChar( nKey, nFlags)             // TSBrowse added
   METHOD HandleEvent( nMsg, nWParam, nLParam )     // TSBrowse added
   METHOD LostFocus( hCtlFocus )             // TSBrowse added
   METHOD lValid()                           // TSBrowse added
   METHOD RButtonDown( nRow, nCol, nFlags )  // TSBrowse added
   METHOD Spinner( bUp, bDown, bMin, bMax )  // TSBrowse added

END CLASS

METHOD New( nRow, nCol, bSetGet, oWnd, nWidth, nHeight, cPict, bValid,;
            nClrFore, nClrBack, oFont, lDesign, oCursor, lPixel, cMsg,;
            lUpdate, bWhen, lCenter, lRight, bChanged, lReadOnly,;
            lPassword, lNoBorder, nHelpId, cResName, bAction, lSpinner,;
            bUp, bDown, bMin, bMax, nBmpWidth ) CLASS TSBtnGet

   Super:New( nRow, nCol, bSetGet, oWnd, nWidth, nHeight, cPict, ;
            bValid, nClrFore, nClrBack, oFont, lDesign, oCursor, ;
            lPixel, cMsg, lUpdate, bWhen, lCenter, lRight, bChanged, ;
            lReadOnly, lPassword, lNoBorder, nHelpId, lSpinner,;
            bUp, bDown, bMin, bMax )

   DEFAULT nBmpWidth := 16         // TSBrowse

//   ::nStyle := nOr( ::nStyle, ES_MULTILINE )   // TSBrowse

   ::bAction   := bAction
   ::cResName  := cResName
   ::lBtnORBmp := .F.
   ::nBmpWidth := nBmpWidth
   ::SetIniClr()

Return Self

METHOD ReDefine( nId, bSetGet, oWnd, nHelpId, cPict, bValid, nClrFore,;
                 nClrBack, oFont, oCursor, cMsg, lUpdate, bWhen, ;
                 bChanged, lReadOnly, lSpinner, bUp, bDown, bMin, ;
                 bMax, cResName, bAction, nBmpWidth ) CLASS TSBtnGet

   Super:ReDefine( nId, bSetGet, oWnd, nHelpId, cPict, bValid, ;
                 nClrFore, nClrBack, oFont, oCursor, cMsg, lUpdate, ;
                 bWhen, bChanged, lReadOnly, lSpinner, bUp, bDown, ;
                 bMin, bMax )

   DEFAULT nBmpWidth := 16      // TSBrowse

   ::nStyle    := nOr( ::nStyle, ES_MULTILINE )
   ::bAction   := bAction
   ::cResName  := cResName
   ::lBtnORBmp := .F.
   ::nBmpWidth := nBmpWidth

   ::SetIniClr()

   SetWindowLong( ::hWnd, GWL_STYLE, nOr( GetWindowLong( ::hWnd, GWL_STYLE ) , ES_MULTILINE ) )

Return Self

METHOD Default() CLASS TSBtnGet
   local nRectLen, l3Dlook
   Local nTop, nLeft, nWidth, nHeight

   IF empty( ::bAction )
      Return Nil
   ENDIF

   //MSGINFO( GetWindowLong( ::oWnd:hWnd, GWL_STYLE ))

   IF !lAnd( GetWindowLong( ::hWnd, GWL_STYLE ), ES_MULTILINE )
      //MsgStop("Sorry, but you need to define the ID " + ltrim( str( ::nId ) ) + " as MULTILINE ")
   endif

   if lAnd( GetWindowLong( ::hWnd, GWL_STYLE ) , ES_MULTILINE )
      //MsgInfo("Si soy")
   else
      //MsgInfo("no soy")
   Endif

   //SetWindowLong( ::hWnd, GWL_EXSTYLE, nOr( GetWindowLong( ::hWnd, GWL_EXSTYLE ) , ES_MULTILINE ) )

   nRectLen := ::nBmpWidth + 4

   l3Dlook := lAnd( GetWindowLong( ::oWnd:hWnd, GWL_STYLE ), DS_3DLOOK )

   IF lAnd( GetWindowLong( ::oWnd:hWnd, GWL_STYLE ), DS_3DLOOK )
      If empty( ::cResName )
         nLeft   := ::nWidth() - 16
         nWidth  := 12
      else
         nLeft   := ::nWidth() - 18   // TSBROWSE 
         nWidth  := 18                // TSBROWSE
      endif
      nTop    := 0
      nHeight := ::nHeight() - 4
   else
      IF empty( ::cResName )
         nLeft   := ::nWidth() - 15
         nWidth  := 14
      Else
         nLeft   := ::nWidth() - 20  // TSBROWSE
         nWidth  := 20               // TSBROWSE
      ENDIF
      nTop    := 1
      nHeight := ::nHeight() - 2
   ENDIF

   IF empty( ::cResName )
      nRectLen -= 9
   endif

   if ::oVScroll != Nil
      nLeft  -= GetSysMetrics( SM_CYVSCROLL )
      nLeft++
   endif

   ::oBtn := TBtnDown():New( nTop, nLeft, nWidth, nHeight, ;
                 ::cResName,, ::cResName,, {|| ;
                 eval( ::bAction, Self ), Self:SetFocus()  }, ;        // TSBrowse
                 Self,"",, .F., .F.,"", ,, , .f. ) 

//   ::bKeyDown        := { | nKey | IIF( nKey == VK_F2, ;  // TSBrowse
//                            eval( ::bAction ), "" ) }     // TSBrowse

   ::oBtn:bGotFocus  := {|| ::bTmpValid := ::bValid, ::bValid := nil, ;
                            ::oWnd:nLastKey := 0 }
   ::oBtn:bLostFocus := {|| ::bValid := ::bTmpValid }

   GetBtn( ::hWnd, nRectLen )

Return Nil

METHOD SetIniClr() CLASS TSBtnGet

   ::nClrFocuText := ::nClrText // nRGB(0,0,0)        // TSBrowse 
   ::nClrFocuPane := ::nClrPane // nRGB(243,250,200)  // TSBrowse
   ::nClrPFoText   := ::nClrText
   ::nClrPFoPane   := ::nClrPane
   //
   ::bGotFocus  := {|| ::SetColor( ::nClrFocuText, ::nClrFocuPane) }
   ::bLostFocus := {|| ::SetColor( ::nClrPFoText  , ::nClrPFoPane  ) }

Return Self

// Next Methods were added by Manuel Mercado for TSBrowse

* ============================================================================
* METHOD TSBtnGet:GetDlgCode() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GetDlgCode( nLastKey,nFlags ) CLASS TSBtnGet

Return DLGC_WANTALLKEYS

* ============================================================================
* METHOD TSBtnGet:GotFocus() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GotFocus() CLASS TSBtnGet

   If ! ::lDrag
      ::oGet:KillFocus()   // to properly initialize internal status
      ::oGet:SetFocus()
      ::DispText()
      ::oGet:Pos = ::nPos
      ::SetPos( ::nPos )
      CallWindowProc( ::nOldProc, ::hWnd, WM_SETFOCUS )

      If ::lFixCaret != Nil .and. ::lFixCaret
         DestroyCaret()
         CreateCaret( ::hWnd, 0, 6, ::nGetChrHeight() )
         ShowCaret( ::hWnd )
      Else
         DestroyCaret()
         If Set( _SET_INSERT )
            CreateCaret( ::hWnd, 0, 6, ::nGetChrHeight() )
         Else
            CreateCaret( ::hWnd, 0, 2, ::nGetChrHeight() )
         EndIf
         ShowCaret( ::hWnd )
      Endif
   Else
      HideCaret( ::hWnd )
   Endif

   ::lReturn := .F.
   ::nLastKey := nsLastKey := 0
   ::_GotFocus()

Return 0

* ============================================================================
* METHOD TSBtnGet:_GotFocus() Version 6.0 Apr/5/2002
* ============================================================================

METHOD _GotFocus( hCtlLost ) CLASS TSBtnGet

   ::lFocused       = .T.
   ::oWnd:nResult   = Self
   ::oWnd:oCtlFocus = Self
   ::oWnd:hCtlFocus = ::hWnd
   ::SetMsg( ::cMsg )

   If ::lDrag
      ::ShowDots()
   Endif

   If ::bGotFocus != nil
      Return Eval( ::bGotFocus, Self, hCtlLost )
   Endif

Return Nil

* ============================================================================
* METHOD TSBtnGet:KeyDown() Version 6.0 Apr/5/2002
* ============================================================================

METHOD KeyDown( nKey, nFlags ) CLASS TSBtnGet

   Default ::nFireKey := VK_F5

   ::nLastKey = nsLastKey := ::oWnd:oWnd:nLastKey := nKey

   IF nKey = VK_DOWN .OR. nKey = VK_UP .OR. nKey = VK_RETURN .OR.;
      (::lRightLeftExit .AND. (nKey = VK_LEFT .OR. nKey = VK_RIGHT))

      If ::lValid()

         ::oWnd:GoPrevCtrl( ::hWnd )

         If ::bKeyDown != Nil
            Eval( ::bKeyDown, nKey, nFlags)
         Endif

         Return 0

      Else
         nsLastKey := 0
         ::DispText()
         ::oGet:Pos = ::nPos
      Endif

      Return Nil

   ElseIf nKey == ::nFireKey
      ::lReturn := .T.
      ::oBtn:Click()
      Return 0

   Elseif nKey == VK_INSERT .and. ! GetKeyState( VK_SHIFT ) .and. ;
          ! GetKeyState( VK_CONTROL )

      Set( _SET_INSERT, ! Set( _SET_INSERT ) )

      If ::lFixCaret == Nil .or. ! ::lFixCaret
         DestroyCaret()
         If Set( _SET_INSERT )
            CreateCaret( ::hWnd, 0, 6, ::nGetChrHeight() )
         Else
            CreateCaret( ::hWnd, 0, 2, ::nGetChrHeight() )
         EndIf
         ShowCaret( ::hWnd )
      EndIf

      Return 0

   Endif

RETURN Super:KeyDown( nKey, nFlags )

* ============================================================================
* METHOD TSBtnGet:KeyChar() Version 6.0 Apr/5/2002
* ============================================================================

METHOD KeyChar(nKey,nFlags) CLASS TSBtnGet

   Local nHi, nLo
   Local lAccept
   Local bKeyAction := SetKey( nKey )
   Local nDefButton

   ::nLastKey := nsLastKey := nKey

   If bKeyAction != nil .and. lAnd( nFlags, 16777216 ) // function Key
      Eval( bKeyAction, ProcName( 4 ), ProcLine( 4 ), Self )
      return 0         // Already processed, API do nothing
   EndIf

   If ::lReadOnly
      If nKey == VK_ESCAPE
         ::oWnd:End()
      EndIf
      Return 0
   EndIf

   Do Case
      Case nKey == VK_BACK       // Already processed at KeyDown
           Return 0

      // case nKey == VK_ESCAPE
      //     return 0

      Case nKey == VK_TAB .and. GetKeyState( VK_SHIFT )
           Return 0

      Case nKey == VK_TAB .or. nKey == VK_RETURN
           Return 0

      Case nKey >= 32 .and. nKey < 256
           ::GetSelPos( @nLo, @nHi )
           // Delete selection
           If nHi != nLo
              ::GetDelSel( nLo, nHi )
              ::EditUpdate()
           EndIf
           If ::oGet:Type == "N" .and. ;
              ( Chr( nKey ) == "." .or. Chr( nKey ) == "," )
              ::oGet:ToDecPos()
           Else
              If ::bChange != nil
                 lAccept = Eval( ::bChange, nKey, nFlags, Self )
                 If ValType( lAccept ) == "L" .and. ! lAccept
                    return 0
                 EndIf
              EndIf
              If Set( _SET_INSERT )             // many thanks to HMP
                 ::oGet:Insert( Chr( nKey ) )
              Else
                 ::oGet:Overstrike( Chr(nKey) )
              End
           EndIf
           If ::oGet:Rejected()
              MessageBeep( -1 )
           Else
              ::EditUpdate()
           EndIf

   EndCase

Return 0

* ============================================================================
* METHOD TSBtnGet:LostFocus() Version 6.0 Apr/5/2002
* ============================================================================

METHOD LostFocus( hCtlFocus ) CLASS TSBtnGet

   If ! ( nsLastKey == VK_RETURN .or.nsLastKey == VK_DOWN .or. ;
          nsLastKey == VK_RIGHT .or. nsLastKey == VK_UP .or. ;
          nsLastKey == VK_RETURN .or. nsLastKey == VK_LEFT )

      If hCtlFocus != ::oBtn:hWnd .and. ! ::lReturn
         ::nLastKey := VK_ESCAPE
         ::SendMsg( WM_KEYDOWN, VK_ESCAPE )
         Return Nil
      Else
         ::lReturn := .T.
      EndIf

   EndIf

   ::SetMsg()
   ::oGet:SetFocus()

   If ! ::oGet:BadDate .and. ! ::lReadOnly .and. ;
      ( ::oGet:changed .or. ::oGet:unTransform() <> ::oGet:original )
      ::oGet:Assign()     // for adjust numbers
      ::oGet:UpdateBuffer()
   EndIf

   ::DispText()

   If ! ::oGet:BadDate
      ::oGet:KillFocus()
   Else
      ::oGet:Pos = 1
   EndIf

Return Nil

* ============================================================================
* METHOD TSBtnGet:lValid() Version 6.0 Apr/5/2002
* ============================================================================

METHOD lValid() CLASS TSBtnGet

   Local lRet := .t.

   ::oGet:Assign()
   ::oGet:UpdateBuffer()

   If ::oGet:BadDate
      Tone( 100, 3 )
      Return .F.
   Else
      If ValType( ::bValid ) == "B"
         lRet := Eval( ::bValid, ::Value()  )
      Endif
   Endif

Return lRet

* ============================================================================
* METHOD TSBtnGet:RButtonDown() Version 6.0 Apr/5/2002
* ============================================================================

METHOD RButtonDown( nRow, nCol, nFlags ) CLASS TSBtnGet

   Local oMenu, oClp, nLo, nHi, aMsg

   #ifdef _SPANISH_
      aMsg := { "&Deshacer","Cor&tar","&Copiar","&Pegar","&Borrar", ;
                "&Seleccionar Todo" }
   #else
      aMsg := { "&Undo","Cu&t","&Copy","&Paste","&Delete", ;
                "Select &All" }
   #endif

   ::GetSelPos( @nLo, @nHi )

   If GetFocus() != ::hWnd
      ::SetFocus()
      SysRefresh()
      If GetFocus() != ::hWnd
         Return Nil
      Endif
   Endif

   DEFINE CLIPBOARD oClp OF Self FORMAT TEXT

   If ::bRClicked != nil
      Return Eval( ::bRClicked, nRow, nCol, nFlags )
   Endif

   MENU oMenu POPUP
      If ::lReadOnly .or. ::GetText() == cValToChar( ::oGet:Original )
         MENUITEM aMsg[ 1 ] ACTION ::UnDo() disabled
      Else
         MENUITEM aMsg[ 1 ] ACTION ::UnDo()
      Endif

      SEPARATOR

      If ::lReadOnly .or. nLo == nHi
         MENUITEM aMsg[ 2 ]  ACTION ::Cut() disabled
      Else
         MENUITEM aMsg[ 2 ]  ACTION ::Cut()
      Endif

      If nLo != nHi
         MENUITEM aMsg[ 3 ] ACTION ::Copy()
      Else
         MENUITEM aMsg[ 3 ] ACTION ::Copy() disabled
      Endif

      If ! Empty( oClp:GetText() ) .and. !::lReadOnly
         MENUITEM aMsg[ 4 ] ACTION ::Paste()
      Else
         MENUITEM aMsg[ 4 ] ACTION ::Paste() DISABLED
      Endif

      If ::lReadOnly .or. nLo == nHi
         MENUITEM aMsg[ 5 ] action nil disabled
      Else
         MENUITEM aMsg[ 5 ] ACTION If( nHi != nLo,;
                ( ::GetDelSel( nLo, nHi ), ::EditUpdate() ),)
      Endif

      SEPARATOR
      MENUITEM aMsg[ 6 ] ACTION ::SelectAll()
   ENDMENU

   ACTIVATE POPUP oMenu AT nRow - 60, nCol OF Self

Return 0


* ============================================================================
* METHOD TSBtnGet:Spinner() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Spinner( bUp, bDown, bMin, bMax ) CLASS TSBtnGet

   ::bMin := bMin
   ::bMax := bMax

   DEFINE SCROLLBAR ::oVScroll VERTICAL OF Self

   DEFAULT bUp   := {|| Self++ } , ;
           bDown := {|| Self-- }

   ::oVScroll:bGoUp   := {|| If( GetFocus() != ::hWnd, ::SetFocus(), Nil ), ;
                             Eval( bUp, Self ) }
   ::oVScroll:bGoDown := {|| If( GetFocus() != ::hWnd, ::SetFocus(), Nil ), ;
                             Eval( bDown, Self ) }

Return Nil

* ============================================================================
* METHOD TSBtnGet:HandleEvent() Version 6.0 Apr/5/2002
* ============================================================================

METHOD HandleEvent( nMsg, nWParam, nLParam ) CLASS TSBtnGet
// just used for some testings

Return Super:HandleEvent( nMsg, nWParam, nLParam )

