/***************************************************************

This file contains the special C routines used by TSBrowse Class
Last update: April 5th, 2002

***************************************************************/

#include <WinTen.h>   /* set your own path if needed */
#include <Windows.h>
#include <ClipApi.h>  /* set your own path if needed */
#include <StdLib.h>

#define COLOR_INACTIVECAPTIONTEXT 19

static void MaskRegion( HDC hDC, RECT * rct, COLORREF cTrColor ,
		        			   COLORREF cBackColor ) ;

void WndBoxDraw( HDC, LPRECT, HPEN, HPEN, int, BOOL ) ;
void DrawCheck( HDC, LPRECT, HPEN, int, BOOL ) ;

extern void DrawBitmap( HDC, HBITMAP, WORD wCol, WORD wRow, WORD wWidth,
                        WORD wHeight, DWORD dwRaster ) ;

static void GoToPoint( HDC, int, int ) ;

static void DegradColor( HDC, RECT *, COLORREF, COLORREF ) ;

//---------------------------------------------------------------------------//

#ifndef __HARBOUR__
CLIPPER TSDrawCell( PARAMS ) // ( hWnd, hDC, nRow, nColumn , nWidth ,
                             //   uData, nAlign , nClrFore, nClrBack ,
                             //   hFont, nBitmap, nHeightCell,
                             //   b3DLook, nLineStyle, nClrLine, nHeadFoot,
                             //   nHeightHead, nHeightFoot, hHeightSuper,
                             //   lAdjBmpl, lMultiLine, nVAlign, nVertText,
                             //   nClrTo, lDegrad, hBrush )
#else
   HARBOUR HB_FUN_TSDRAWCELL( PARAMS )
#endif
{
   HWND hWnd        = (HWND) _parni( 1 ) ;
   HDC  hDC         = (HDC) _parni( 2 ) ;
   int  nRow        = _parni( 3 ) ;
   int  nColumn     = _parni( 4 ) ;
   int  nWidth      = _parni( 5 ) ;
   LPSTR cData      = _parc( 6 )  ;
   int  nLen        = _parclen( 6 ) ;
   UINT nAlign      = _parni( 7 ) ;
   COLORREF clrFore = _parnl( 8 ) ;
   COLORREF clrBack = _parnl( 9 ) ;
   HFONT hFont      = (HFONT) _parni( 10 ) ;
   int nBitMap      = _parni( 11 ) ;
   int nHeightCell  = _parni( 12 ) ;
   BOOL b3DLook     = _parl( 13 ) ;
   int nLineStyle   = _parni( 14 ) ;
   COLORREF clrLine = _parnl( 15 ) ;
   int nHeadFoot    = _parni( 16 ) ;
   int nHeightHead  = _parni( 17 ) ;
   int nHeightFoot  = _parni( 18 ) ;
   int nHeightSuper = _parni( 19 ) ;
   HBITMAP hBitMap  = (HBITMAP) _parni( 6 ) ;  // redefine parm 6 as possible bitmap
   BOOL bAdjBmp     = _parl( 20 ) ;
   BOOL bMultiLine  = _parl( 21 ) ;
   int nVAlign      = _parni( 22 ) ;
   int nVertText    = _parni( 23 ) ;
   COLORREF clrTo   = _parnl( 24 ) ;
   BOOL bDegrad     = _parl( 25 ) ;
   HBRUSH wBrush    = (HBRUSH) _parnl( 26 ) ;
   BOOL b3DInv      = ( ISLOGICAL( 27 ) ? ! _parl( 27 ) : FALSE ) ;
   BOOL b3D         = ( ISLOGICAL( 27 ) ? TRUE : FALSE ) ;
   COLORREF nClr3DL = _parnl( 28 ) ;
   COLORREF nClr3DS = _parnl( 29 ) ;

   BOOL bGrid       = ( nLineStyle > 0 ? TRUE : FALSE ) ;
   BOOL bHeader     = ( nHeadFoot == 1 ? TRUE : FALSE ) ;
   BOOL bFooter     = ( nHeadFoot == 2 ? TRUE : FALSE ) ;
   BOOL bSuper      = ( nHeadFoot == 3 ? TRUE : FALSE ) ;
   BOOL bChecked    = ( nVertText == 3 ? TRUE : FALSE ) ;
   BOOL bBrush      = ( wBrush > 0 ? TRUE : FALSE ) ;

   HFONT hOldFont ;
   BOOL bDestroyDC  = FALSE ;
   HPEN hGrayPen    = CreatePen( PS_SOLID, 1, clrLine );
   HPEN hWhitePen   = CreatePen( PS_SOLID, 1, GetSysColor( COLOR_BTNHIGHLIGHT ) ) ;  // GetStockObject( WHITE_PEN )

   RECT rct ;
   BITMAP bm ;
   int nTop, nLeft, nBkOld ;
   long lColor, lBkColor = GetBkColor( hDC ) ;

   if( ! hDC )
   {
      bDestroyDC = TRUE ;
      hDC = GetDC( hWnd ) ;
   }

   if( hFont )
      hOldFont = SelectObject( hDC, hFont ) ;

   GetClientRect( hWnd, &rct ) ;

   SetTextColor( hDC, clrFore ) ;
   SetBkColor( hDC, clrBack ) ;

   if( nRow == 0 )
      if( bHeader )
         rct.top = ( nHeightSuper - 1 );
      else
         rct.top = 0 ;
   else
      if ( bFooter )
      	rct.top = rct.bottom - nHeightFoot ;
      else
         rct.top = nHeightHead + nHeightSuper - 1 + ( nHeightCell * ( nRow - 1 ) );

   if( rct.top + nHeightCell <= rct.bottom )
   {
      rct.bottom = rct.top + ( bHeader ? nHeightHead :( bSuper ? nHeightSuper : nHeightCell ) ) ;

      /* Don't let left side go beyond rct.right of Client Rect. */
      if( nColumn - ( rct.right - rct.left ) <= 0 )
      {
         rct.left = nColumn ;

           /* if nWidth == -1 or -2, it indicates the last column so go to limit,
            Don't let right side go beyond rct.right of Client Rect. */
         if( ( nWidth >= 0 ) && ((rct.left + nWidth - rct.right) <= 0) )  // negative values have different meanings
            rct.right = rct.left + nWidth ;

         rct.right += ( ( ( ( bHeader && nHeightSuper == 0 ) || bSuper ) && b3DLook ) ? 1 : 2 ) ;

         if( ( nLineStyle == 5 || nLineStyle == 2 || nLineStyle == 0 ) && !bHeader )
         	rct.bottom += 1;

         if( ! bDegrad )
         	if( ! bBrush )
	            ExtTextOut( hDC, rct.left, rct.top, ETO_OPAQUE | ETO_CLIPPED, &rct, "", 0, 0  ) ;
            else
               FillRect( hDC, &rct, wBrush ) ;
         else
            DegradColor( hDC, &rct, clrBack, clrTo ) ;

         rct.left += 2 ;
         rct.right -= ( ( ( ( bHeader && nHeightSuper == 0 ) || bSuper ) && b3DLook ) ? 3 : 4 ) ;

         if( nLineStyle == 5 && !bHeader )
         	rct.bottom -= 1 ;

         if( nBitMap )
         {

            if( ! bAdjBmp )
            {
                GetObject( hBitMap, sizeof( BITMAP ), ( LPSTR ) &bm ) ;
                nTop = rct.top + ( ( rct.bottom - rct.top + 1 ) / 2 ) - ( bm.bmHeight / 2 ) - 1;

                switch( nAlign )
                {
                	case 0:
                  	nLeft = rct.left ;
                     break ;
                  case 1:
                     nLeft = rct.left + ( ( rct.right - rct.left + 1 ) / 2 ) - ( bm.bmWidth / 2 ) - 1 ;
                     break ;
                  case 2:
                  	nLeft = rct.right - ( bm.bmWidth + 1 ) ;
                     break ;
                }
            }
            else
            {
               nTop  = rct.top ;
               nLeft = rct.left ;
            }

            if( b3DLook )
               {
               if( bAdjBmp )
                  DrawBitmap( hDC, hBitMap,  rct.top + 1, rct.left - 1, \
                              rct.right - rct.left + 1, \
                              rct.bottom - rct.top - 1, 0 ) ;
               else
                  DrawBitmap( hDC, hBitMap, nTop, nLeft, 0, 0, 0 ) ;
               }
            else
               {
               if( bAdjBmp)
                  DrawBitmap( hDC, hBitMap,  rct.top, rct.left - 2, \
                              rct.right - rct.left + 3, \
                              rct.bottom - rct.top - 1, 0 ) ;
               else
                  DrawBitmap( hDC, hBitMap, nTop, nLeft, 0, 0, 0 ) ;
               }

            if( nBitMap == 1 )
            	if( ( lColor = GetPixel( hDC, nLeft + 1, nTop + 1 ) ) != lBkColor )
                	 MaskRegion( hDC, &rct, lColor, GetBkColor( hDC ) ) ;

         }
			else
         {
 	         if( nAlign == 0 )                     // extra space only on left alignment
	           rct.left += 2 ;

            if( nLineStyle == 5 && !bHeader )
            	rct.bottom -= 1;

            if( nVertText == 1 )
            {
               rct.right += ( 4 * nLen ) ;
               rct.bottom += 8 ;
         	}

            if( ( nVertText == 3 || nVertText == 4 ) )
            	DrawCheck( hDC, &rct, hWhitePen, nAlign, bChecked ) ;
            else
            {
               nBkOld = SetBkMode( hDC, TRANSPARENT ) ;

               if( b3D )
               {
                  rct.top    -= 1 ;
                  rct.left   -= 1 ;
                  rct.bottom -= 1 ;
                  rct.right  -= 1 ;

   					SetTextColor( hDC, b3DInv ? nClr3DS : nClr3DL ) ;
               	DrawText( hDC, cData, nLen, &rct, nAlign | ( nVAlign == 0 ? DT_TOP : \
   	            	       ( nVAlign == 2 ? DT_BOTTOM : DT_VCENTER ) )| \
								    ( bMultiLine && nVAlign < 2 ? 0 : DT_SINGLELINE ) | DT_NOPREFIX ) ;

                  rct.top    += 2 ;
                  rct.left   += 2 ;
                  rct.bottom += 2 ;
                  rct.right  += 2 ;

   					SetTextColor( hDC, b3DInv ? nClr3DL : nClr3DS ) ;
	               DrawText( hDC, cData, nLen, &rct, nAlign | ( nVAlign == 0 ? DT_TOP : \
   		                   ( nVAlign == 2 ? DT_BOTTOM : DT_VCENTER ) )| \
								    ( bMultiLine && nVAlign < 2 ? 0 : DT_SINGLELINE ) | DT_NOPREFIX ) ;

                  rct.top    -= 1 ;
                  rct.left   -= 1 ;
                  rct.bottom -= 1 ;
                  rct.right  -= 1 ;

   					SetTextColor( hDC, clrFore ) ;
            	   DrawText( hDC, cData, nLen, &rct, nAlign | ( nVAlign == 0 ? DT_TOP : \
   	         	          ( nVAlign == 2 ? DT_BOTTOM : DT_VCENTER ) )| \
								    ( bMultiLine && nVAlign < 2 ? 0 : DT_SINGLELINE ) | DT_NOPREFIX ) ;
               }
               else
	               DrawText( hDC, cData, nLen, &rct, nAlign | ( nVAlign == 0 ? DT_TOP : \
   		                   ( nVAlign == 2 ? DT_BOTTOM : DT_VCENTER ) )| \
								    ( bMultiLine && nVAlign < 2 ? 0 : DT_SINGLELINE ) | DT_NOPREFIX ) ;

               SetBkMode( hDC, nBkOld ) ;
            }

            if( nVertText == 1 )
            {
               rct.right -= ( 4 * nLen ) ;
            	rct.bottom -= 8 ;
         	}

 	         if( nAlign == 0 )
	           rct.left -= 2 ;

            if( nLineStyle == 5 && !bHeader )
            	rct.bottom +=1 ;
         }
         if( b3DLook )
         {
	         rct.left -= 2 ;
	         rct.right += 1 ;
            rct.bottom -= 1 ;

            if( bSuper )
            	rct.bottom -= 1 ;

           	bHeader = ( bSuper ? bSuper : bHeader ) ;

            if( ( nWidth != -2 ) && bGrid )   // -1 draw gridline in phantom column; -2 don't draw gridline in phantom column
               WndBoxDraw( hDC, &rct, hWhitePen, hGrayPen, nLineStyle, bHeader ) ;
         }
         else
         {
	         rct.top -= 1 ;
	         rct.left -= 3 ;
	         rct.right += 1 ;
	         rct.bottom -= 1;
            bHeader = ( bFooter ? bFooter : ( bHeader || bSuper ) ) ;

         	if( ( nWidth != -2 ) && bGrid )   // -1 draw gridline in phantom column; -2 don't draw gridline in phantom column
            	   WndBoxDraw( hDC, &rct, hGrayPen, hGrayPen, nLineStyle, bHeader ) ;

         }

      }
   }

   DeleteObject( hGrayPen ) ;
   DeleteObject( hWhitePen ) ;

	if( hFont )
      SelectObject( hDC, hOldFont ) ;

   if( bDestroyDC )
      ReleaseDC( hWnd, hDC ) ;
}

//---------------------------------------------------------------------------//

void WndBoxDraw( HDC hDC, RECT * rct, HPEN hPUpLeft, HPEN hPBotRit, int nLineStyle, \
                 BOOL bHeader )

{
   HPEN hOldPen = SelectObject( hDC, hPUpLeft ) ;
   HPEN hNull  = CreatePen( PS_NULL, 1, 0 );

   if ( nLineStyle < 5 )
   {
   	if ( !( bHeader ) && ( nLineStyle == 3 || nLineStyle == 5 ) )
			SelectObject( hDC, hNull );

      GoToPoint( hDC, rct->left, rct->bottom ) ;
      LineTo( hDC, rct->left, rct->top );

   	if ( !( bHeader ) && nLineStyle == 3 )
   		SelectObject( hDC, hPUpLeft );

   	if ( !( bHeader ) && ( nLineStyle == 2 || nLineStyle == 5 ) )
			SelectObject( hDC, hNull );

      LineTo( hDC, rct->right, rct->top );

   	SelectObject( hDC, hPBotRit );

   	if ( !( bHeader ) && ( nLineStyle == 2 || nLineStyle == 5 ) )
			SelectObject( hDC, hNull );

      GoToPoint( hDC, rct->left, rct->bottom );
      LineTo( hDC, rct->right, rct->bottom );

   	if ( !( bHeader ) && nLineStyle == 2 )
   		SelectObject( hDC, hPBotRit );

   	if ( !( bHeader ) && ( nLineStyle == 3 || nLineStyle == 5 ) )
			SelectObject( hDC, hNull );

      LineTo( hDC, rct->right, rct->top - 1 );
   }
   else
   {
   rct->top += 1;
   rct->left += 1;
   rct->bottom += 2 ;
   rct->right += 2;
   DrawFocusRect( hDC, rct );
   }

   SelectObject( hDC, hOldPen );
   DeleteObject( hNull );
}

//---------------------------------------------------------------------------//

#ifndef __HARBOUR__
   CLIPPER TSBrwScrol( PARAMS )  // l( hWnd, nDir, hFont, nHeightCell, nHeightHead,
                                 //    nHeightFoot, nHeightSuper )
#else
   HARBOUR HB_FUN_TSBRWSCROLL( PARAMS )
#endif
{
   HWND hWnd        = (HWND) _parni( 1 ) ;
   int wRows        = _parni( 2 ) ;
   HFONT hFont      = (HFONT) _parni( 3 ) ;
   int nHeightCell  = _parni( 4 ) ;
   int nHeightHead  = _parni( 5 ) ;
   int nHeightFoot  = _parni( 6 ) ;
   int nHeightSuper = _parni( 7 ) ;

   HFONT hOldFont;
   HDC hDC = GetDC( hWnd ) ;
   RECT rct;

   if( hFont )
      hOldFont = SelectObject( hDC, hFont );

   GetClientRect( hWnd, &rct );

   rct.top    += ( nHeightHead + nHeightSuper ) ;  // exclude heading from scrolling
   rct.bottom -= nHeightFoot ;                 // exclude footing from scrolling
   rct.bottom -= ( ( rct.bottom - rct.top + 1 ) % nHeightCell );  // exclude unused portion at bottom
   ScrollWindowEx( hWnd, 0, (int) -( nHeightCell * wRows ), 0, &rct, 0, 0, 0 );

   if( hFont )
      SelectObject( hDC, hOldFont );

   ReleaseDC( hWnd, hDC );
}

//----------------------------------------------------------------------------//

#ifndef __HARBOUR__
   CLIPPER TSBrwHScro( PARAMS )  // ll( hWnd, nCols, nLeft, nRight )
#else
   HARBOUR HB_FUN_TSBRWHSCROLL( PARAMS )
#endif
{
   HWND hWnd  = (HWND) _parni( 1 ) ;
   WORD wCols = _parni( 2 ) ;
   int nLeft  = _parni( 3 ) ;
   int nRight = _parni( 4 ) ;

   HDC hDC    = GetDC( hWnd ) ;
   RECT rct;

   GetClientRect( hWnd, &rct ) ;

   if ( nLeft )
      rct.left = nLeft ;

   if ( nRight )
      rct.right = nRight ;

   ScrollWindowEx( hWnd, wCols, 0, 0, &rct, 0, 0, 0 ) ;

   ReleaseDC( hWnd, hDC ) ;
}

//---------------------------------------------------------------------------//

static WORD near GetWindowRow( HWND hWnd, HDC hDC, WORD wGraphRow, HFONT hFont,
                               int nHeightCell, int nHeightHead, int nHeightFoot,
                               int nHeightSuper ) // -> wTextRow
{
   RECT  rct ;
   int   wRow ;
   BOOL  bDCDestroy = FALSE ;
   HFONT hOldFont ;

   if( ! hDC )
   {
      bDCDestroy = TRUE;
      hDC = GetDC( hWnd );
   }

   if( hFont )
      hOldFont = SelectObject( hDC, hFont );

   GetClientRect( hWnd, &rct );

   if( wGraphRow <= ( rct.top + nHeightHead + nHeightSuper ) )
      wRow = 0 ;
   else
      if( wGraphRow >= ( rct.bottom - nHeightFoot ) )
         wRow = -1 ;
      else
      {
         rct.top += ( nHeightHead + nHeightSuper ) ;
         wRow = ( ( wGraphRow - rct.top ) / nHeightCell ) + 1 ;
      }

   if( hFont )
      SelectObject( hDC, hOldFont );

   if( bDCDestroy )
      ReleaseDC( hWnd, hDC );

   return wRow;
}

//---------------------------------------------------------------------------//

#ifndef __HARBOUR__
   CLIPPER nTSBRow() // ( hWnd, hDC, nGraphRow, hFont, nHeightCell,
                     //   nHeightHead, nHeightFoot, nHeightSuper ) -> nTextRow
#else
   HARBOUR HB_FUN_NTSBROW( PARAMS )
#endif
{
   _retni( GetWindowRow( (HWND) _parni( 1 ), (HDC) _parni( 2 ), _parni( 3 ),
                         (HFONT) _parni( 4 ), _parni( 5 ), _parni( 6 ), _parni( 7 ),
                          _parni( 8 ) ) );
}

//---------------------------------------------------------------------------//

#ifndef __HARBOUR__
   CLIPPER aTSBrwPosR() // ect( hWnd, nRow, nCol, nWidth, hFont, nHeightCell,
                        //      nHeightHead, nHeightSuper )
#else
   HARBOUR HB_FUN_ATSBRWPOSRECT( PARAMS )
#endif
{
   HWND hWnd        = (HWND) _parni( 1 ) ;
   int wRow         = _parni( 2 ) ;
   int wCol         = _parni( 3 ) ;
   int wWidth       = _parni( 4 ) ;
   HFONT hFont      = (HFONT) _parni( 5 ) ;
   int wHeight      = _parni( 6 ) ;
   int nHeightHead  = _parni( 7 ) ;
   int nHeightSuper = _parni( 8 ) ;

   HDC hDC = GetDC( hWnd ) ;
   HFONT hOldFont ;
   int wMaxRight ;
   RECT rct ;

   if( hFont )
      hOldFont = SelectObject( hDC, hFont ) ;

   GetWindowRect( hWnd, &rct ) ;
   wMaxRight = rct.right;

   rct.top    += ( nHeightHead + nHeightSuper ) + ( wHeight * (wRow - 1) ) + 1 ;
   rct.bottom = rct.top + wHeight ;
   rct.left   += wCol ;
   rct.right  = rct.left + wWidth ;

   if( hFont )
      SelectObject( hDC, hOldFont ) ;

   ReleaseDC( hWnd, hDC ) ;

   _reta( 4 ) ;

   _storni( rct.top,    -1, 1 ) ;
   _storni( rct.left,   -1, 2 ) ;
   _storni( rct.bottom, -1, 3 ) ;
   _storni( ( wMaxRight <= rct.right ) ? wMaxRight - 18: rct.right, -1, 4 ) ;
}

//---------------------------------------------------------------------------//

#ifndef __HARBOUR__
   CLIPPER SBGetHeigh( PARAMS ) // t( hWnd, hFont, nTotal )
#else
   HARBOUR HB_FUN_SBGETHEIGHT( PARAMS )
#endif
{
   HWND  hWnd  = (HWND) _parni( 1 ) ;
   HFONT hFont = (HFONT) _parni( 2 ) ;
   int  iTotal = _parni( 3 )  ;

   TEXTMETRIC tm ;

   RECT  rct ;
   HDC   hDC = GetDC( hWnd ) ;
   HFONT hOldFont ;
   LONG  lTotHeight, lReturn ;

   if( iTotal < 2 )
   {
   	hOldFont = SelectObject( hDC, hFont ) ;
   	GetTextMetrics( hDC, &tm ) ;
   	SelectObject( hDC, hOldFont ) ;
   	ReleaseDC( hWnd, hDC ) ;
      lReturn = ( iTotal == 1 ? tm.tmAveCharWidth : tm.tmHeight ) ;
      _retnl( lReturn ) ;
   }
   else
   {
   	GetWindowRect( hWnd, &rct ) ;
      lTotHeight = rct.bottom - rct.top + 1 ;
   	ReleaseDC( hWnd, hDC ) ;
      _retnl( lTotHeight ) ;
	}
}

//----------------------------------------------------------------------------//

int GetSBRows( HWND hWnd, HDC hDC, HFONT hFont, int nHCell, int nHHead, \
               int nHFoot, int nHSuper )
{
   RECT rct ;
   int nRows ;
   BOOL bDCDestroy = FALSE ;
   HFONT hOldFont ;

   if( ! hDC )
   {
      bDCDestroy = TRUE ;
      hDC = GetDC( hWnd ) ;
   }

   if( hFont )
      hOldFont = SelectObject( hDC, hFont ) ;

   GetClientRect( hWnd, &rct ) ;

   rct.top    += ( nHHead + nHSuper ) ;
   rct.bottom -= nHFoot ;
   rct.bottom -= ( ( rct.bottom - rct.top + 1 ) % nHCell ) ;

   nRows = ( rct.bottom - rct.top + 1 ) / nHCell  ;

   if( hFont )
      SelectObject( hDC, hOldFont ) ;

   if( bDCDestroy )
      ReleaseDC( hWnd, hDC ) ;

   return nRows ;
}

//----------------------------------------------------------------------------//

#ifndef __HARBOUR__
   CLIPPER NSBROWS( PARAMS )  // ( hWnd, hDC, hFont, nHeightCell, nHeightHead,
                              //   nHeightFoot, nHeightSuper ) -> nRows
#else
   HARBOUR HB_FUN_NSBROWS( PARAMS )
#endif
{
   _retni( GetSBRows( ( HWND ) _parnl( 1 ), ( HDC ) _parnl( 2 ),
                      ( HFONT ) _parnl( 3 ), ( int ) _parni( 4 ),
                      ( int ) _parni( 5 ), ( int ) _parni( 6 ), _parni( 7 ) ) );
}

//----------------------------------------------------------------------------//

static void MaskRegion( HDC hDC, RECT * rct, COLORREF cTransparentColor,
                        COLORREF cBackgroundColor)
{
   HDC        hdcTemp, hdcObject, hdcBack, hdcMem;
   POINT      ptSize;
   COLORREF   cColor;
   HBITMAP    bmAndObject, bmAndBack, bmBackOld, bmObjectOld, bmAndTemp, bmTempOld,
              bmAndMem, bmMemOld ;
   HBRUSH     hBrush, hBrOld ;

   ptSize.x = rct->right - rct->left + 1 ;
   ptSize.y = rct->bottom - rct->top + 1 ;

   hBrush      = CreateSolidBrush(cBackgroundColor) ;

   hdcTemp     = CreateCompatibleDC(hDC) ;
   hdcObject   = CreateCompatibleDC(hDC) ;
   hdcBack     = CreateCompatibleDC(hDC) ;
   hdcMem      = CreateCompatibleDC(hDC) ;

   bmAndTemp   = CreateCompatibleBitmap( hDC, ptSize.x, ptSize.y ) ;
   bmAndMem    = CreateCompatibleBitmap( hDC, ptSize.x, ptSize.y ) ;
   bmAndObject = CreateBitmap(ptSize.x, ptSize.y, 1, 1, NULL ) ;
   bmAndBack   = CreateBitmap(ptSize.x, ptSize.y, 1, 1, NULL ) ;

   bmTempOld   = SelectObject( hdcTemp, bmAndTemp ) ;
   bmMemOld    = SelectObject( hdcMem, bmAndMem ) ;
   bmBackOld   = SelectObject( hdcBack, bmAndBack ) ;
   bmObjectOld = SelectObject( hdcObject, bmAndObject ) ;

   hBrOld      = SelectObject( hdcMem, hBrush ) ;

   BitBlt( hdcTemp, 0, 0, ptSize.x, ptSize.y, hDC, rct->left, rct->top, SRCCOPY ) ;

   SetMapMode( hdcTemp, GetMapMode( hDC ) ) ;

   cColor = SetBkColor(hdcTemp, cTransparentColor);

   BitBlt( hdcObject, 0, 0, ptSize.x, ptSize.y, hdcTemp, 0, 0, SRCCOPY ) ;

   SetBkColor( hdcTemp, cColor ) ;

   BitBlt( hdcBack, 0, 0, ptSize.x, ptSize.y, hdcObject, 0, 0, NOTSRCCOPY ) ;
   PatBlt( hdcMem, 0,0, ptSize.x, ptSize.y, PATCOPY ) ;
   BitBlt( hdcMem, 0, 0, ptSize.x, ptSize.y, hdcObject, 0, 0, SRCAND ) ;
   BitBlt( hdcTemp, 0, 0, ptSize.x, ptSize.y, hdcBack, 0, 0, SRCAND ) ;
   BitBlt( hdcMem, 0, 0, ptSize.x, ptSize.y, hdcTemp, 0, 0, SRCPAINT ) ;
   BitBlt( hDC, rct->left, rct->top, ptSize.x, ptSize.y, hdcMem, 0, 0, SRCCOPY ) ;

   DeleteObject( SelectObject( hdcMem, hBrOld ) ) ;
   DeleteObject( SelectObject( hdcTemp, bmTempOld ) ) ;
   DeleteObject( SelectObject( hdcMem, bmMemOld ) ) ;
   DeleteObject( SelectObject( hdcBack, bmBackOld ) ) ;
   DeleteObject( SelectObject( hdcObject, bmObjectOld ) ) ;
   DeleteDC( hdcMem ) ;
   DeleteDC( hdcBack ) ;
   DeleteDC( hdcObject ) ;
   DeleteDC( hdcTemp ) ;
}

//---------------------------------------------------------------------------//

#ifndef __HARBOUR__
   CLIPPER SBmpHeight( PARAMS ) // ( hBmp )
#else
   HARBOUR HB_FUN_SBMPHEIGHT( PARAMS ) // ( hBmp )
#endif
{
   HBITMAP hBmp  = (HBITMAP) _parni( 1 ) ;
   BITMAP bm ;

   GetObject( hBmp, sizeof( BITMAP ), ( LPSTR ) &bm ) ;

   _retni( bm.bmHeight ) ;
}

//---------------------------------------------------------------------------//

#ifndef __HARBOUR__
   CLIPPER SBmpWidth( PARAMS ) // ( hBmp )
#else
   HARBOUR HB_FUN_SBMPWIDTH( PARAMS )
#endif
{
   HBITMAP hBmp  = (HBITMAP) _parni( 1 ) ;
   BITMAP bm ;

   GetObject( hBmp, sizeof( BITMAP ), ( LPSTR ) &bm ) ;

   _retni( bm.bmWidth ) ;
}

//---------------------------------------------------------------------------//

#ifndef __HARBOUR__
   CLIPPER SBNoBlink( PARAMS ) // ( nColor1, nColor2)
#else
   HARBOUR HB_FUN_SBNOBLINK( PARAMS )
#endif
{
   COLORREF nColor1 = _parnl( 1 ) ;
   COLORREF nColor2 = _parnl( 2 ) ;

	int aiElem[2] ;
	DWORD aRgbVal[2] ;

	aiElem[0]  = COLOR_INACTIVECAPTION ;
	aRgbVal[0] = ( nColor1 ? nColor1 : GetSysColor( COLOR_ACTIVECAPTION ) ) ;
	aiElem[1]  = COLOR_INACTIVECAPTIONTEXT;
	aRgbVal[1] = ( nColor2 ? nColor2 : GetSysColor( COLOR_CAPTIONTEXT ) ) ;

   SetSysColors( 2, aiElem, aRgbVal ) ;

}

//---------------------------------------------------------------------------//

void DrawCheck( HDC hDC, LPRECT rct, HPEN hWhitePen, int nAlign, BOOL bChecked )
{
   RECT lrct ;
   HPEN hOldPen ;
   HBRUSH hOldBrush ;

   HBRUSH hGrayBrush  = CreateSolidBrush( RGB( 192, 192, 192 ) ) ;
   HBRUSH hWhiteBrush = CreateSolidBrush( RGB( 255, 255, 255 ) ) ;
   HPEN hBlackPen     = CreatePen( PS_SOLID, 1, RGB( 0, 0, 0 ) ) ;
   HPEN hLGrayPen     = CreatePen( PS_SOLID, 1, RGB( 192, 192, 192 ) ) ;
   HPEN hGrayPen      = CreatePen( PS_SOLID, 1, RGB( 128, 128, 128 ) ) ;

   hOldBrush = SelectObject( hDC, hGrayBrush ) ;

   lrct.top = rct->top + ( ( ( rct->bottom - rct->top + 1 ) / 2 ) - 8 );

   switch( nAlign )
   {
   	case 0:
     		lrct.left = rct->left ;
      	break ;
      case 1:
      	lrct.left = rct->left + ( ( rct->right - rct->left + 1 ) / 2 ) - 8 ;
      	break ;
      case 2:
     		lrct.left = rct->right - 16 ;
      	break ;
   }

   lrct.bottom = lrct.top + 16 ;
   lrct.right  = lrct.left + 16 ;

   lrct.left   -= 1 ;
   lrct.top    -= 1 ;
   lrct.right  += 1 ;
   lrct.bottom += 1 ;

   hOldPen = SelectObject( hDC, hBlackPen ) ;
   Rectangle( hDC, lrct.left, lrct.top, lrct.right, lrct.bottom ) ;

   lrct.left   += 1 ;
   lrct.top    += 1 ;
   lrct.right  -= 1 ;
   lrct.bottom -= 1 ;

   FillRect( hDC, &lrct, hGrayBrush ) ;

   lrct.top    += 2 ;
   lrct.left   += 2 ;
   lrct.right  -= 1 ;
   lrct.bottom -= 1 ;

   FillRect( hDC, &lrct, hWhiteBrush ) ;

   SelectObject( hDC, hOldBrush ) ;
   DeleteObject( hGrayBrush ) ;
   DeleteObject( hWhiteBrush ) ;

   lrct.right  -= 1 ;
   lrct.bottom -= 1 ;

   SelectObject( hDC, hGrayPen ) ;
   Rectangle( hDC, lrct.left, lrct.top, lrct.right, lrct.bottom ) ;

   lrct.top    += 1 ;
   lrct.left   += 1 ;
   lrct.right  -= 1 ;
   lrct.bottom -= 1 ;

   SelectObject( hDC, hBlackPen ) ;
   Rectangle( hDC, lrct.left, lrct.top, lrct.right, lrct.bottom ) ;

   lrct.top  += 1 ;
   lrct.left += 1 ;

   SelectObject( hDC, hWhitePen ) ;
   Rectangle( hDC, lrct.left, lrct.top, lrct.right, lrct.bottom ) ;

   lrct.top    += 1 ;
   lrct.right  -= 2 ;
   lrct.bottom -= 1 ;

   if( bChecked )
   {
      GoToPoint( hDC, lrct.right, lrct.top ) ;

   	SelectObject( hDC, hBlackPen ) ;

	   LineTo( hDC, lrct.right - 4 , lrct.bottom - 3 ) ;
   	LineTo( hDC, lrct.right - 6, lrct.bottom - 5 ) ;

      GoToPoint( hDC, lrct.right, lrct.top + 1) ;
   	LineTo( hDC, lrct.right - 4 , lrct.bottom - 2 ) ;
	   LineTo( hDC, lrct.right - 6, lrct.bottom - 4 ) ;

      GoToPoint( hDC, lrct.right, lrct.top + 2) ;
   	LineTo( hDC, lrct.right - 4 , lrct.bottom - 1 ) ;
	   LineTo( hDC, lrct.right - 6, lrct.bottom - 3 ) ;
   }

	SelectObject( hDC, hOldPen ) ;
   DeleteObject( hGrayPen ) ;
   DeleteObject( hLGrayPen ) ;
   DeleteObject( hBlackPen ) ;
}

//----------------------------------------------------------------------------//

static void GoToPoint( HDC hDC, int ix, int iy )
{
   POINT pt;

   #ifdef __FLAT__
      MoveToEx( hDC, ix, iy, &pt ) ;
   #else
      MoveTo( hDC, ix, iy );
   #endif
}

//---------------------------------------------------------------------------//

static void DegradColor( HDC hDC, RECT * rori, COLORREF cFrom, COLORREF cTo )
{
   int clr1r, clr1g, clr1b, clr2r, clr2g, clr2b ;
   signed int iEle, iRed, iGreen, iBlue ;
   int iTot = ( rori->bottom  - rori->top ) ;
   BOOL bDir ;
   RECT rct ;
   HBRUSH hOldBrush, hBrush ;

   rct.top = rori->top ;
   rct.left = rori->left ;
   rct.bottom = rori->bottom ;
   rct.right = rori->right ;

   clr1r = GetRValue( cFrom ) ;
   clr1g = GetGValue( cFrom ) ;
   clr1b = GetBValue( cFrom ) ;

   clr2r = GetRValue( cTo ) ;
   clr2g = GetGValue( cTo ) ;
   clr2b = GetBValue( cTo ) ;

   iRed   =  abs( clr2r - clr1r ) ;
   iGreen =  abs( clr2g - clr1g ) ;
   iBlue  =  abs( clr2b - clr1b ) ;

   iRed   = ( iRed < 0 ? 0 : ( iRed / iTot ) );
   iGreen = ( iGreen < 0 ? 0 : ( iGreen / iTot ) ) ;
   iBlue  = ( iBlue < 0 ? 0 : ( iBlue / iTot ) ) ;

   rct.bottom = rct.top + 1 ;

   hBrush = CreateSolidBrush( RGB( clr1r, clr1g, clr1b ) ) ;
   hOldBrush = SelectObject( hDC, hBrush ) ;
   FillRect( hDC, &rct, hBrush ) ;

   for( iEle = 1; iEle < iTot; iEle++ )
   {
      	bDir = ( clr2r >= clr1r ? TRUE : FALSE ) ;
         if( bDir )
      		clr1r += iRed ;
         else
         	clr1r -= iRed ;

         clr1r = ( clr1r < 0 ? 0 : clr1r > 255 ? 255 : clr1r ) ;

	      bDir = ( clr2g >= clr1g ? TRUE : FALSE  ) ;
         if( bDir )
   	   	clr1g += iGreen ;
         else
   	   	clr1g -= iGreen ;
         clr1g = ( clr1g < 0 ? 0 : clr1g > 255 ? 255 : clr1g ) ;

			bDir = ( clr2b >= clr1b ? TRUE : FALSE  ) ;
         if( bDir )
   	   	clr1b += iBlue ;
   		else
   	   	clr1b -= iBlue ;
         clr1b = ( clr1b < 0 ? 0 : clr1b > 255 ? 255 : clr1b ) ;

      SelectObject( hDC, hOldBrush ) ;
      DeleteObject( hBrush ) ;
      hBrush = CreateSolidBrush( RGB( clr1r, clr1g, clr1b ) ) ;
      SelectObject( hDC, hBrush ) ;
      FillRect( hDC, &rct, hBrush ) ;

      rct.top++ ;
      rct.bottom++ ;
   }
	SelectObject( hDC, hOldBrush ) ;
   DeleteObject( hBrush ) ;
}

//---------------------------------------------------------------------------//

#ifndef __HARBOUR__
   CLIPPER CHANGESYSC( PARAMS ) // OLORS( nItems, aItems, aColors )
#else
   HARBOUR HB_FUN_CHANGESYSCOLORS( PARAMS )
#endif
{
   int iEle, iItems = _parni( 1 ) ;
   int aiElemen[ 28 ] ;
   COLORREF alColors[ 28 ] ;

   for( iEle = 0 ; iEle <= ( iItems - 1 ) ; iEle++ )
   {
      aiElemen[ iEle ] = _parni( 2, ( iEle + 1 ) ) ;
      alColors[ iEle ] = _parnl( 3, ( iEle + 1 ) ) ;
   }

   SetSysColors( iItems, aiElemen, alColors ) ;
}
