* ============================================================================
* TSBrowse.PRG Version 6.1.2 1/31/2007 8:12AM (Modified by James Bott)
* ============================================================================

/* This Classs is a recapitulation of the code adapted by Luis Krause Mantilla,
   of FiveWin classes: TCBrowse, TWBrowse, TCColumn and Clipper Wrapers in C
   that support the visual Windows interface.

   Originally TCBrowse was a Sub-Class of TWBrowse, with this work, we have the
   new class "TSBrowse" that is no more a Sub-Class. Now, TSBrowse is an
   independent control that inherits directly from TControl class.

   My work has mainly consisted on putting pieces together with some extra from
      my own crop.

   Credits:
      Luis Krause Mantilla
      Selim Anter
      Stan Littlefield
      Marshall Thomas
      Eric Yang
      John Stolte
      Harry Van Tassell
      Martin Vogel
      Katy Hayes
      Jose Gimenez
      Hernan Diego Ceccarelli ( some ideas taked from his TWBrowse )
      Antonio Carlos Pantaglione ( Toninho@fwi.com.br )
      TSBtnGet is an adaptation of the Ricardo Ramirez TBtnGet Class
      Gianni Santamarina
      Ralph del Castillo
      FiveTech (original classes)

      Many thanks to all of them.

      Regards.

      Manuel Mercado.  February 17th, 2002

   Note: This program is supposed to be bilingual Spanish / English.
   Nota: Este programa se supone que ser bilinge Espaol / Ingles.

         En el archivo "Leeme.1ro" anexo, har la traduccin de estos
         comentarios para no cargar mucho el inicio del programa.

    Aqu vamos ! |  Here we go !...  */

//----------------------------------------------------------------------------//

#define _DDE_CH
#define _FOLDER_CH
#define _VIDEO_CH
#define _TREE_CH
#define _ODBC_CH

#include "Fivewin.ch"
#include "TSBrowse.ch"
#include "Report.ch"

#ifdef __XPP__
   #define Super ::TControl
   #define New   _New
   #xtranslate   _DbSkipper => DbSkipper
#EndIf

#ifdef __HARBOUR__
   #xtranslate   _DbSkipper => DbSkipper
#endif

// Windows 95 keyboard's "Context" key
// Tecla "Contexto" en el teclado Winsows 95
#define VK_CONTEXT         93

#define WM_SETFONT            48    // 0x30

// let's save DGroup space
// ahorremos espacio para DGroup
#define nsCol        asTSB[1]
#define nsWidth      asTSB[2]
#define nsOldPixPos  asTSB[3]
#define bCxKeyNo     asTSB[4]
#define bCmKeyNo     asTSB[5]
#define nGap			asTSB[6]

// api maximal vertical scrollbar position
#define MAX_POS 32767

// mouse wheel Windows message
#define WM_MOUSEWHEEL  522

#define GWL_EXSTYLE          -20

#define HKEY_CURRENT_USER 2147483649

Static asTSB  := { Nil, Nil, 0, Nil, Nil, 0 }
Static oEdit, nLapsus

//----------------------------------------------------------------------------//

CLASS TSBrowse FROM TControl

   CLASSDATA lRegistered AS LOGICAL

   CLASSDATA aProperties AS ARRAY ;
      INIT { "aColumns", "cVarName", "nTop", "nLeft", "nWidth", "nHeight" }

   CLASSDATA lVScroll, lHScroll

   DATA   aActions                                   // actions to be executed on header's click
   DATA   aArray        AS ARRAY                     // browsed array
   DATA   aBitmaps      AS ARRAY INIT {}             // array with bitmaps handles
   DATA   aDefault      AS ARRAY INIT {}             // default values in append mode
   DATA   aClipBoard                                 // used by RButtonDown method
   DATA   aColSizes, aColumns, aHeaders              // the core of TSBrowse
   DATA   aDefValue     AS ARRAY INIT {}             // for array in append mode
   DATA   aIcons        AS ARRAY INIT {}             // array with icons names
   DATA   aImages       AS ARRAY INIT {}             // array with bitmaps names
   DATA   aJustify                                   // compatibility with TWBrowse
   DATA   aMsg          AS ARRAY INIT {}             // multi languaje feature
   DATA   aKeyRemap     AS ARRAY INIT {}             // to prevalidate keys at KeyChar method
   DATA   aSelected                                  // selected items in select mode
   DATA   aSuperHead                                 // array with params of superheads

   DATA   bAddRec       AS CODEBLOCK INIT NIL        // custom function for adding record (with your own message)
   DATA   bBitMapH      AS CODEBLOCK INIT NIL        // bitmap handle
   DATA   bContext      AS CODEBLOCK INIT NIL        // evaluates windows keyboard context key
   DATA   bDelete       AS CODEBLOCK INIT NIL        // evaluated after user deletes a row with lCanDelete mode
   DATA   bFileLock     AS CODEBLOCK INIT NIL        // custom function for locking database (with your own message)
   DATA   bGoToPos      AS CODEBLOCK INIT NIL        // scrollbar block
   DATA   bIconDraw, bIconText                       // compatibility with TCBrowse
   DATA   bLastTag                                   // to restore index at GotFocus
   DATA   bLine, bSkip, bGoTop, bGoBottom, ;
          bLogicLen, bChange                         // navigation codeblocks
   DATA   bKeyNo                                     // logical position on indexed databases
   DATA   bOnDraw       AS CODEBLOCK INIT NIL        // evaluated in DrawSelect()
   DATA   bPostDel                                   // evaluated after record deletion
   DATA   bRecLock      AS CODEBLOCK INIT NIL        // custom function for locking record (with your own message)
   DATA   bScope        AS CODEBLOCK INIT NIL        // alias is scoped
   DATA   bSeekChange   AS CODEBLOCK INIT NIL        // used by seeking feature
   DATA   bSelected     AS CODEBLOCK INIT NIL        // to be evaluated in select mode
   DATA   bSetOrder     AS CODEBLOCK INIT NIL        // used by seeking feature
   DATA   bTagOrder     AS CODEBLOCK INIT NIL        // to restore index on GotFocus
   DATA   bUserKeys                                  // user code block to be evaluated
                                                     // with precedence into method
                                                     // KeyDown()

   DATA   cAlias                                     // data base alias or "ARRAY" or "TEXT_"
   DATA   cDriver                                    // RDD in use
   DATA   cField, uValue1, uValue2                   // SetFilter Params
   DATA   cOrderType                                 // index key type for seeking
   DATA   cPrefix                                    // used by TSBrowse search feature
   DATA   cSeek                                      // used by TSBrowse search feature

   DATA   hBmpCursor    AS NUMERIC                   // bitmap cursor for first column
   DATA   l3DLook       AS LOGICAL INIT .F. READONLY // internally control state of ::Look3D() in "Phantom" column
   DATA   lHitTop, lHitBottom, lCaptured, lMChange   // browsing flags
   DATA   lAppendMode   AS LOGICAL INIT .F. READONLY // automatic append flag
   DATA   lAutoCtx      AS LOGICAL                   // compatibility with TCBrowse
   DATA   lAutoEdit     AS LOGICAL INIT .F.          // activates continuous edition mode
   DATA   lAutoSkip     AS LOGICAL INIT .F.          // compatibility with TCBrowse
   DATA   lIconView     AS LOGICAL INIT .F.          // compatibility with TCBrowse
   DATA   lCellStyle    AS LOGICAL INIT .F.          // compatibility with TCBrowse
   DATA   lCanAppend    AS LOGICAL INIT .F. READONLY // activates auto append mode
   DATA   lCanDelete    AS LOGICAL INIT .F. HIDDEN   // activates delete capability
   DATA   lCanSelect    AS LOGICAL INIT .F.          // activates select mode
   DATA   lCellBrw      AS LOGICAL                   // celled browse flag
   DATA   lChanged      AS LOGICAL INIT .F. READONLY // field has changed indicator
   DATA   lClipMore     AS LOGICAL INIT .F.          // ClipMore RDD
   DATA   lColDrag      AS LOGICAL                   // TSBrowse dragging feature
   DATA   lConfirm      AS LOGICAL INIT .T. HIDDEN   // ask for user confirm to delete a row
   DATA   lDbfObj       AS LOGICAL INIT .F.          // using database objects
   DATA   lDescend      AS LOGICAL INIT .F.          // descending indexes
   DATA   lDrawHeaders  AS LOGICAL INIT .T.          // condition for headers drawing
   DATA   lDrawFooters                               // condition for footers drawing
   DATA   lEditing      AS LOGICAL INIT .F. READONLY // to avoid lost focus at editing time
   DATA   lFilterMode   AS LOGICAL INIT .F. READONLY // index based filters with NTX RDD
   DATA   lFirstFocus   AS LOGICAL INIT .T. HIDDEN   // controls some actions on init
   DATA   lFirstPaint   AS LOGICAL INIT .T. HIDDEN   // controls some actions on init
   DATA   lFixCaret     AS LOGICAL                   // oGet fix caret at editing time
   DATA   lFooting      AS LOGICAL                   // indicates footers can be drowed
   DATA   lGrasp        AS LOGICAL INIT .F. READONLY // used by drag & drop feature
   DATA   lGridLine     AS LOGICAL                   // does not apply to headers & footers
   DATA   lHasChanged   AS LOGICAL INIT .F.          // browsed data has changed flag for further actions
   DATA   lHasFocus     AS LOGICAL INIT .F.          // focused flag
   DATA   lIsDbf        AS LOGICAL INIT .F. READONLY // is database browsed
   DATA   lIsV22        AS LOGICAL INIT .F.          // true if oBmp:hBmpPal is not defined
   DATA   lLineDrag     AS LOGICAL                   // TSBrowse dragging feature
   DATA   lLockFreeze   AS LOGICAL                   // avoids cursor positioning on frozen columns
   DATA   lMoveCols     AS LOGICAL                   // Choose between moving or exchanging columns (::moveColumn() or ::exchange())
   DATA   lMyFont       AS LOGICAL INIT .F. READONLY // default TSBrowse's font was created
   DATA   lNoGrayBar    AS LOGICAL                   // don't show inactive cursor
   DATA   lNoHScroll    AS LOGICAL                   // disables horizontal scroll bar
   DATA   lNoLiteBar    AS LOGICAL                   // no cursor
   DATA   lNoMoveCols   AS LOGICAL INIT .F.          // avoids resize or move columns by the user
   DATA   lNoResetPos   AS LOGICAL INIT .T.          // prevents to reset record positio on gotfocus
   DATA   lNoVScroll    AS LOGICAL                   // disables vertical scroll bar
   DATA   lLogicDrop    AS LOGICAL                   // compatibility with TCBrowse
   DATA   lPageMode     AS LOGICAL INIT .F.          // paging mode flag
   DATA   lPainted      AS LOGICAL INIT .F. HIDDEN   // controls some actions on init
   DATA   lRePaint      AS LOGICAL                   // bypass paint if false
   DATA   lUndo         AS LOGICAL INIT .F.          // used by RButtonDown method
   DATA   lUpdated      AS LOGICAL INIT .F.          // replaces lEditCol return value
   DATA   lUpperSeek    AS LOGICAL INIT .T.          // controls if char expresions are seek in uppercase or not
   DATA   lSeek         AS LOGICAL INIT .T.          // activates TSBrowse seeking feature

   DATA   nAdjColumn    AS NUMERIC                   // column expands to flush table window right
   DATA   nCell         AS NUMERIC                   // actual column
   DATA   nClrHeadBack, nClrHeadFore                 // headers colors
   DATA   nClrFocuBack, nClrFocuFore                 // focused cell colors
   DATA   nClrEditBack, nClrEditFore                 // editing cell colors
   DATA   nClrFootBack, nClrFootFore                 // footers colors
   DATA   nClrSeleBack, nClrSeleFore                 // selected cell no focused
   DATA   nClrOrdeBack, nClrOrdeFore                 // order control column colors
   DATA   nClrLine                                   // grid line color
   DATA   nColOrder     AS NUMERIC                   // compatibility with TCBrowse
   DATA   nDragCol      AS NUMERIC                   // drag & drop  feature
   DATA   nFireKey                                   // key to start edition, defaults to VK_F2
   DATA   nFreeze       AS NUMERIC                   // 0,1,2.. freezes left most columns
   DATA   nHeightCell   AS NUMERIC INIT 0            // resizable cell height
   DATA   nHeightHead   AS NUMERIC INIT 0            //      "    header  "
   DATA   nHeightFoot   AS NUMERIC INIT 0            //      "    footer  "
   DATA   nHeightSuper  AS NUMERIC INIT 0            //      "    Superhead  "
   DATA   nIconPos                                   // compability with TCBrowse
   DATA   nKeyDown      AS NUMERIC INIT 0 HIDDEN     // Allows typing leters and numbers to begin cell editing !
   DATA   nKeyFlag      AS NUMERIC INIT 0 HIDDEN     // same
   DATA   nLastPainted  AS NUMERIC INIT 0 HIDDEN     // last painted nRow
   DATA   nLastPos      AS NUMERIC INIT 0 HIDDEN     // last record position before lost focus
   DATA   nLastnAt      AS NUMERIC INIT 0 HIDDEN     // last ::nAt value before lost focus
   DATA   nLineStyle                                 // user definable grid lines style
   DATA   nFirstKey     AS NUMERIC INIT 0 HIDDEN     // First logic pos in filtered databases
   DATA   nMaxFilter                                 // maximum number of records to count
                                                     // on index based filters
   DATA   nOffset       AS NUMERIC INIT 0 HIDDEN     // offset marker for text viewer
   DATA   nPhantom      AS NUMERIC INIT PHCOL_GRID   // controls drawing state for "Phantom" column (-1 or -2) inside ::Look3D()
   DATA   nPrevRec                                   // internally used to go previous record back
   DATA   nRowPos, nAt  AS NUMERIC INIT 0            // grid row positions
   DATA   nColPos       AS NUMERIC INIT 0            // grid column position
   DATA   nLen          AS NUMERIC INIT 0            // total number of browsed items
   DATA   nWheelScrollLines AS NUMERIC INIT 4        // number lines to scroll per mouse wheel movement

   DATA   oDbf          AS OBJECT                    // TDbf / TDatabase object
   DATA   oCtx          AS OBJECT READONLY           // context object
   DATA   oGet                                       // get object
   DATA   oItem                                      // tree item object used by SetoTree()
   DATA   oTree                                      // tree object
   DATA   oTxtFile      AS OBJECT                    // for text files browsing (TTxtFile() class)

   DATA   uLastTag                                   // last TagOrder before losing focus

   METHOD New( nRow, nCol, nWidth, nHeigth, bLine, aHeaders, ;
               aColSizes, oWnd, cField, uVal1, uVal2, bChange, ;
               bLDblClick, bRClick, oFont, oCursor, aColors, ;
               cMsg, lUpdate, cAlias, lPixel, bWhen, ;
               lDesign, bValid, lCellBrw, nStyle, bLClick, aActions ) CONSTRUCTOR

   METHOD ReDefine( nId, bLine, oDlg, aHeaders, aColSizes, cField, uVal1,;
                    uVal2, bChange, bLDblClick, bRClick, oFont,;
                    oCursor, nClrFore, nClrBack, cMsg, lUpdate,;
                    cAlias, bWhen, bValid, lCellBrw, bLClick ) CONSTRUCTOR

   METHOD AddColumn( oColumn )

   METHOD AddSuperHead( nFromCol, nToCol, uHead, nHeight, aColors, l3dLook, ;
                        uFont, lBitMap, lAdjust, lTransp, lGrid, nHAlign, ;
                        nVAlign )

   METHOD BeginPaint() INLINE If( ::lRepaint, Super:BeginPaint(), 0 )

   METHOD BugUp()      INLINE ::UpStable()

   METHOD ChangeFont( oFont, nColumn, nLevel )

   METHOD DbSkipper( nToSkip )

   METHOD Default()

   METHOD DeleteRow()

	METHOD DelColumn( nPos )

   METHOD Destroy()

   METHOD Display()

   METHOD DrawFooters() INLINE ::DrawHeaders()

   MESSAGE DrawIcon METHOD _DrawIcon( nIcon, lFocused )

   METHOD DrawIcons()

   METHOD DrawLine( nRow )

   METHOD DrawSelect()

   METHOD DrawSuper()

   METHOD DrawHeaders()

   METHOD EditExit( nKey, oGet, uTemp, bValid, nCombo )

   METHOD EndPaint()   INLINE If( ::lRePaint, Super:EndPaint(), ;
                                     ( ::lRePaint := .T., 0 ) )

   METHOD Exchange( nCol1, nCol2 )  INLINE ::SwitchCols( nCol1, nCol2), ;
                                           ::SetFocus()
	METHOD FreezeCol( lNext )

   METHOD GetColSizes() INLINE ;
          If( ValType( ::aColSizes ) == "A", ::aColSizes, Eval( ::aColSizes ) )

	METHOD GetColumn( nCol )

   METHOD GetDlgCode( nLastKey )

   METHOD GetRealPos( nRelPos )

   METHOD GoBottom()

   METHOD GoDown()

   METHOD GoEnd()

   METHOD GoHome()

   METHOD GoLeft()

   METHOD GoNext()

   METHOD GoPos( nNewRow, nNewCol )

   METHOD GoRight()

   METHOD GotFocus()

   METHOD GoTop()

   METHOD GoUp()

   METHOD HandleEvent( nMsg, nWParam, nLParam )

   METHOD HiliteCell( nCol, nColPix )

   METHOD HScroll( nWParam, nLParam )

   METHOD HThumbDrag( nNewCol )

   METHOD Init( hDlg ) INLINE ::Initiate( hDlg )

   METHOD Initiate( hDlg ) INLINE Super:Initiate( hDlg ), ::Default()

   METHOD InsColumn( nPos, oColumn )

   METHOD Inspect( cData )

   METHOD IsColVisible( nCol )

   METHOD IsColVis2( nCol )

   METHOD KeyChar( nKey, nFlags )

   METHOD KeyDown( nKey, nFlags )

   METHOD LButtonDown( nRowPix, nColPix, nKeyFlags )

   METHOD LButtonUp( nRowPix, nColPix, nKeyFlags )

   METHOD lCloseArea() INLINE ;
             If( ::lIsDbf .and. ! Empty( ::cAlias ), ;
                 ( ::cAlias )->( DbCloseArea() ), Nil ), ;
             If( ! Empty( ::cAlias ), ::cAlias := "",), .T.

   METHOD LDblClick( nRowPix, nColPix, nKeyFlags )

   METHOD lEditCol( nCol, uVar, cPicture, bValid, nClrFore, nClrBack )

   METHOD lIgnoreKey( nKey, nFlags )

   METHOD LoadFields( lEditable )

   METHOD Look3D( lOnOff, nColumn, nLevel, lPhantom )

   METHOD LostFocus( hCtlFocus )

   METHOD MButtonDown( nRow, nCol, nKeyFlags )

   METHOD MouseMove( nRowPix, nColPix, nKeyFlags )

   METHOD MoveColumn( nColPos, nNewPos )

   METHOD nAtCol( nColPix, lActual )

   METHOD nAtIcon( nRow, nCol )

   METHOD nColCount() INLINE Len( ::aColumns )

   METHOD nLogicPos()

   METHOD nRowCount() INLINE ;
          nSBRows( ::hWnd, 0, If( ::oFont != Nil, ::oFont:hFont, 0 ), ;
                   ::nHeightCell, If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
                   If( ::lFooting .and. ::lDrawFooters, ::nHeightFoot, 0 ), ;
                   ::nHeightSuper )

   METHOD nTSBRow( nRowPix ) INLINE ;
          nTSBRow( ::hWnd, ::hDC, If( nRowPix != nil, nRowPix, ::nRowPos * 14 ), ;
                   If( ::oFont != Nil, ::oFont:hFont, 0 ), ::nHeightCell, ;
                   ::nHeightHead, ::nHeightFoot, ::nHeightSuper )

   METHOD PageUp( nLines )

   METHOD PageDown( nLines )

   METHOD Paint()

   METHOD PanHome()

   METHOD PanEnd()

   METHOD PanLeft()

   METHOD PanRight()

   METHOD PostEdit( uTemp, nCol )

   METHOD RButtonDown( nRowPix, nColPix, nKeyFlags )

   MESSAGE RecCount METHOD _RecCount( uSeekValue )

   METHOD Report( cTitle, lPreview, oFont, nLang, cCaption, lModal )

   METHOD Reset()

   METHOD ResetBarPos( lInit )

   METHOD ResetSeek()

   METHOD ReSize( nSizeType, nWidth, nHeight )

   METHOD TSBrwScroll( nDir ) INLINE ;
          TSBrwScroll( ::hWnd, nDir, If( ::oFont != nil, ::oFont:hFont, 0 ), ;
                       ::nHeightCell, If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
                       If( ValType( ::lDrawFooters ) == "L" .and. ;
                           ::lDrawFooters , ::nHeightFoot, 0 ), ;
                           ::nHeightSuper )

   METHOD Seek( nKey )

   METHOD Set3DText( lOnOff, nColumn, nLevel, nClrLight, nClrShadow )

   METHOD SetAlign( nColumn, nLevel, nAlign )

   METHOD SetAppendMode( lMode )

   METHOD SetArray( aArray )

   METHOD SetBtnGet( nCol, cResName, bAction, nBmpWidth )

   METHOD SetColor( xColor1, xColor2, nColumn )

   METHOD SetColSize( nCol, nWidth )

   METHOD SetColumns( aData, aHeaders, aColSizes )

   METHOD SetDeleteMode( lOnOff, lConfirm, bDelete, bPostDel )

   METHOD SetHeaders( nHeight, aCols, aTitles, aAlign , al3DLook, aFonts, ;
                      aActions )

   METHOD SetContext( oCtx )      INLINE If( oCtx == nil, ;
                                           ::lAutoCtx := .F., ::oCtx := oCtx )

   METHOD SetData( nColumn, bData, aList )

   METHOD SetFilter( cField, uVal1, uVal2 )

   METHOD SetFont( oFont )

   METHOD SetIndexCols( aCols )

   METHOD SetoDBF( oDbf )

   METHOD SetOrder( nColumn )

   METHOD SetSelectMode( lOnOff, bSelected )

   METHOD SetSpinner( nColumn, lOnOff, bUp, bDown, bMin, bMax )

   METHOD SetTree( oTree )

   METHOD SetTxtFile( oTxtFile, cTitle, lOemToAnsi )

   METHOD ShowSizes()

   METHOD Skip( n )

   METHOD SwitchCols( nCol1, nCol2 )

	METHOD SyncChild( aoChildBrw, abAction )

   METHOD UpStable()

   METHOD Proper( cText )

   METHOD VertLine( nColPos, nColInit, nGapp )

   METHOD VScroll( nWParam, nLParam )

ENDCLASS

* ============================================================================
* METHOD TSBrowse:New() Version 6.0 Apr/5/2002
* ============================================================================

METHOD New( nRow, nCol, nWidth, nHeight, bLine, aHeaders, aColSizes, oWnd,;
            cField, uVal1, uVal2, bChange, bLDblClick, bRClick,;
            oFont, oCursor, aColors, cMsg, lUpdate, cAlias,;
            lPixel, bWhen, lDesign, bValid, lCellBrw, nStyle, bLClick,;
            aActions, nLineStyle ) CLASS TSBrowse

   Local aTmpColor := Array(15), oReg

   #ifdef __XPP__
      #undef New
   #EndIf

   If aColors != Nil
      Aeval(aColors, { | bColor, nEle | aTmpColor[ nEle ] := bColor } )
   EndIf

   Default nRow            := 0, ;
           nCol            := 0, ;
           nHeight         := 100, ;
           nWidth          := 100, ;
           oWnd            := GetWndDefault(), ;
           nLineStyle      := LINES_ALL

   Default aTmpColor[ 1 ]  := GetSysColor( COLOR_WINDOWTEXT ), ; // nClrText
           aTmpColor[ 2 ]  := GetSysColor( COLOR_WINDOW )    , ; // nClrPane
           aTmpColor[ 3 ]  := GetSysColor( COLOR_BTNTEXT )   , ; // nClrHeadFore
           aTmpColor[ 4 ]  := GetSysColor( COLOR_BTNFACE )   , ; // nClrHeadBack
           aTmpColor[ 5 ]  := GetSysColor( COLOR_CAPTIONTEXT ), ; // nClrForeFocu
           aTmpColor[ 6 ]  := GetSysColor( COLOR_ACTIVECAPTION ) // nClrFocuBack

   Default aTmpColor[ 7 ]  := GetSysColor( COLOR_WINDOWTEXT ), ; // nClrEditFore
           aTmpColor[ 8 ]  := GetSysColor( COLOR_WINDOW )    , ; // nClrEditBack
           aTmpColor[ 9 ]  := GetSysColor( COLOR_BTNTEXT )   , ; // nClrFootFore
           aTmpColor[ 10 ] := GetSysColor( COLOR_BTNFACE )   , ; // nClrFootBack
           aTmpColor[ 11 ] := CLR_HGRAY                      , ; // nClrSeleFore inactive focused
           aTmpColor[ 12 ] := CLR_GRAY                       , ; // nClrSeleBack inactive focused
           aTmpColor[ 13 ] := GetSysColor( COLOR_BTNTEXT )   , ; // nClrOrdeFore
           aTmpColor[ 14 ] := GetSysColor( COLOR_BTNFACE )   , ; // nClrOrdeBack
           aTmpColor[ 15 ] := GetSysColor( COLOR_BTNSHADOW )     // nClrLine

   Default lUpdate         := .F., ;
           cAlias          := Alias(), ;
           lPixel          := .F., ;
           lDesign         := .F., ;
           aColSizes       := {}, ;
           lCellBrw        := .F.

   Default nStyle := nOr( WS_CHILD, WS_BORDER, WS_VISIBLE, WS_TABSTOP, ;
                          If( lDesign, WS_THICKFRAME, 0 ) )

   #ifdef __XPP__
      DEFAULT cAlias := ""
   #EndIf

   ::cCaption    = ""
   ::nTop        = nRow * If( lPixel, 1, BRSE_CHARPIX_H ) // 14
   ::nLeft       = nCol * If( lPixel, 1, BRSE_CHARPIX_W )  //8
   ::nBottom     = ::nTop + nHeight - 1
   ::nRight      = ::nLeft + nWidth - 1
   ::oWnd        = oWnd
   ::lHitTop     = .F.
   ::lHitBottom  = .F.
   ::lFocused    = .F.
   ::lCaptured   = .F.
   ::lMChange    = .T.
   ::nRowPos     = 1
   ::nAt         = 1
   ::nColPos     = 1
   ::nStyle      = nStyle
   ::lAutoCtx    = .T.
   ::lRePaint    = .F.
   ::lNoHScroll  = .F.
   ::lNoVScroll  = .F.
   ::lNoLiteBar  = .F.
   ::lNoGrayBar  = .F.
   ::lLogicDrop  = .F.
   ::lColDrag    = .F.
   ::lLineDrag   = .F.
   ::nFreeze     = 0
   ::aColumns    = {}
   ::nColOrder   = 0
   ::cOrderType  = ""
   ::lFooting    = .F.
   ::nCell       = 1
   ::lCellBrw    = lCellBrw
   ::lMoveCols   = .F.
   ::lLockFreeze = .F.
   ::lGridLine   = .T.
   ::lCanAppend  = .F.
   ::lAppendMode = .F.
   ::aImages     = {}
   ::aBitmaps    = {}
   ::nId         = ::GetNewId()
   ::cAlias      = cAlias
   ::bLine       = bLine
   ::lAutoEdit   = .F.
   ::lAutoSkip   = .F.
   ::lIconView   = .F.
   ::lCellStyle  = .F.
   ::nIconPos    = 0
   ::lMChange    = .T.
   ::bChange     = bChange
   ::bLClicked   = bLClick
   ::bLDblClick  = bLDblClick
   ::bRClicked   = bRClick
   ::aHeaders    = aHeaders
   ::aColSizes   = aColSizes
   ::aJustify    = {}
   ::nLen        = 0
   ::lDrag       = lDesign
   ::lDesign     = lDesign
   ::lCaptured   = .F.
   ::oCursor     = oCursor
   ::cMsg        = cMsg
   ::lUpdate     = lUpdate
   ::bWhen       = bWhen
   ::bValid      = bValid
   ::aActions    = aActions
   ::nLineStyle  = nLineStyle
   ::aSelected   = {}
   ::aSuperHead  = {}
   ::lFixCaret   = .T.

   ::SetFilter( cField, uVal1, uVal2 )
   ::SetColor( , aTmpColor )

   If oFont == Nil
      DEFINE FONT oFont NAME "Arial" SIZE 0, -12
      ::lMyFont := .T.
   Else
      ::lMyFont := .F.
   EndIf

   #ifdef __XPP__
      DEFAULT ::lRegistered := .F.
   #EndIf

   ::Register( nOr( CS_VREDRAW, CS_HREDRAW, CS_DBLCLKS ) )

   If ( ::lIsV22 := CheckBmpPal() )
      ::bBitMapH := &( "{|oBmp|oBmp:hBitMap}" )
   Else
      ::bBitMapH := &( "{|oBmp|nLoWord(oBmp:hBmpPal)}" )
   EndIf

   If ! Empty( ::oWnd:hWnd )
      ::Create()
      If oFont != Nil
         ::SetFont( oFont )
      EndIf
      ::Default()
      ::lVisible = .T.
      oWnd:AddControl( Self )
   Else
      oWnd:DefControl( Self )
      If oFont != Nil
         ::SetFont( oFont )
      EndIf
      ::lVisible = .F.
   EndIf

   ::nHeightFoot := 0
   ::nHeightCell := ::nHeightHead :=  SBGetHeight( ::hWnd, ::oFont:hFont, 0 )

   ::lIsDbf := ! EmptyAlias( ::cAlias ) .and. ::cAlias != "ARRAY" .and. ;
                 ::cAlias != "TEXT_" .and. ::oTree == Nil

   ::aMsg := LoadMsg()

   If lDesign
      ::CheckDots()
   EndIf

   oReg:= Treg32():new( HKEY_CURRENT_USER,"Control Panel\Desktop")
   ::nWheelScrollLines := val( oReg:get("WheelScrollLines") )
   oReg:close()

Return Self

* ============================================================================
* METHOD TSBrowse:Redefine() Version 6.0 Apr/5/2002
* ============================================================================

METHOD ReDefine( nId, bLine, oDlg, aHeaders, aColSizes, cField, uVal1, uVal2,;
                 bChange, bLDblClick, bRClick, oFont, oCursor,;
                 aColors, cMsg, lUpdate, cAlias,;
                 bWhen, bValid, lCellBrw, bLClick,;
                 aActions, nLineStyle ) CLASS TSBrowse

   Local aTmpColor := Array(15), oReg

   If aColors != Nil
      Aeval(aColors, { | bColor, nEle | aTmpColor[ nEle ] := bColor } )
   EndIf

   Default oDlg            := GetWndDefault(), ;
           nLineStyle      := LINES_ALL

   Default aTmpColor[ 1 ]  := GetSysColor( COLOR_WINDOWTEXT ), ; // nClrText
           aTmpColor[ 2 ]  := GetSysColor( COLOR_WINDOW )    , ; // nClrPane
           aTmpColor[ 3 ]  := GetSysColor( COLOR_BTNTEXT )   , ; // nClrHeadFore
           aTmpColor[ 4 ]  := GetSysColor( COLOR_BTNFACE )   , ; // nClrHeadBack
           aTmpColor[ 5 ]  := GetSysColor( COLOR_HIGHLIGHTTEXT ), ; // nClrFocuFore
           aTmpColor[ 6 ]  := GetSysColor( COLOR_HIGHLIGHT )     // nClrFocuBack

   Default aTmpColor[ 7 ]  := GetSysColor( COLOR_WINDOWTEXT ), ; // nClrEditFore
           aTmpColor[ 8 ]  := GetSysColor( COLOR_WINDOW )    , ; // nClrEditBack
           aTmpColor[ 9 ]  := GetSysColor( COLOR_BTNTEXT )   , ; // nClrFootFore
           aTmpColor[ 10 ] := GetSysColor( COLOR_BTNFACE )   , ; // nClrFootBack
           aTmpColor[ 11 ] := CLR_HGRAY                      , ; // nClrSeleFore  NO focused
           aTmpColor[ 12 ] := CLR_GRAY                       , ; // nClrSeleBack  NO focused
           aTmpColor[ 13 ] := GetSysColor( COLOR_BTNTEXT )   , ; // nClrOrdeFore
           aTmpColor[ 14 ] := GetSysColor( COLOR_BTNFACE )   , ; // nClrOrdeBack
           aTmpColor[ 15 ] := GetSysColor( COLOR_BTNSHADOW )     // nClrLine

   Default lUpdate         := .F.,;
           cAlias          := Alias(),;
           aColSizes       := {},;
           lCellBrw        := .F.

   ::oWnd        = oDlg
   ::lHitTop     = .F.
   ::lHitBottom  = .F.
   ::lFocused    = .F.
   ::lCaptured   = .F.
   ::lMChange    = .T.
   ::nRowPos     = 1
   ::nAt         = 1
   ::nColPos     = 1
   ::lAutoCtx    = .T.
   ::lRePaint    = .F.
   ::lNoHScroll  = .F.
   ::lNoVScroll  = .F.
   ::lNoLiteBar  = .F.
   ::lNoGrayBar  = .F.
   ::lLogicDrop  = .F.
   ::lColDrag    = .F.
   ::lLineDrag   = .F.
   ::nFreeze     = 0
   ::aColumns    = {}
   ::nColOrder   = 0
   ::cOrderType  = ""
   ::lFooting    = .F.
   ::nCell       = 1
   ::lCellBrw    = lCellBrw
   ::lMoveCols   = .F.
   ::lLockFreeze = .F.
   ::lGridLine   = .T.
   ::lCanAppend  = .F.
   ::lAppendMode = .F.
   ::aImages     = {}
   ::aBitmaps    = {}
   ::nId         = nId
   ::cAlias      = cAlias
   ::bLine       = bLine
   ::lAutoEdit   = .F.
   ::lAutoSkip   = .F.
   ::lIconView   = .F.
   ::lCellStyle  = .F.
   ::nIconPos    = 0
   ::lMChange    = .T.
   ::bChange     = bChange
   ::bLClicked   = bLClick
   ::bLDblClick  = bLDblClick
   ::bRClicked   = bRClick
   ::aHeaders    = aHeaders
   ::aColSizes   = aColSizes
   ::aJustify    = {}
   ::nLen        = 0
   ::lDrag       = .F.
   ::lCaptured   = .F.
   ::oCursor     = oCursor
   ::cMsg        = cMsg
   ::lUpdate     = lUpdate
   ::bWhen       = bWhen
   ::bValid      = bValid
   ::aActions    = aActions
   ::nLineStyle  = nLineStyle
   ::aSelected   = {}
   ::aSuperHead  = {}
   ::lFixCaret   = .T.

   ::SetFilter( cField, uVal1, uVal2 )
   ::SetColor( , aTmpColor )

   ::Register( nOr( CS_VREDRAW, CS_HREDRAW, CS_DBLCLKS ) )

   oDlg:DefControl( Self )

   If oFont == Nil
      DEFINE FONT oFont NAME "Arial" SIZE 0, -12
      ::lMyFont := .T.
   Else
      ::lMyFont := .F.
   EndIf

   If ( ::lIsV22 := CheckBmpPal() )
      ::bBitMapH := &( "{|oBmp|oBmp:hBitMap}" )
   Else
      ::bBitMapH := &( "{|oBmp|nLoWord(oBmp:hBmpPal)}" )
   EndIf

   ::SetFont( oFont )

   ::nHeightFoot := 0
   ::nHeightCell := ::nHeightHead :=  SBGetHeight( ::hWnd, ::oFont:hFont, 0 ) + 1

   ::lIsDbf := ! EmptyAlias( ::cAlias ) .and. ::cAlias != "ARRAY" .and. ;
                 ::cAlias != "TEXT_" .and. ::oTree == Nil

   ::aMsg := LoadMsg()

   oReg:= Treg32():new( HKEY_CURRENT_USER,"Control Panel\Desktop")
   ::nWheelScrollLines := val( oReg:get("WheelScrollLines") )
   oReg:close()

Return Self

* ============================================================================
* METHOD TSBrowse:AddColumn() Version 6.0 Apr/5/2002
* ============================================================================

METHOD AddColumn( oColumn ) CLASS TSBrowse

   Local nHeight, nAt, cHeading, cRest, nOcurs

   If ! Empty( ::aColumns ) .and. ValType( ::aColumns[ 1 ]:cHeading ) == "C" .and. ;
      ::aColumns[ 1 ]:cHeading == "_Dummy"
      ::aColumns := {}
      ::aColSizes := {}
   EndIf

   If ::lDrawHeaders
      cHeading := If( Valtype( oColumn:cHeading ) == "B", ;
                      Eval( oColumn:cHeading ), oColumn:cHeading )

      If Valtype( cHeading ) == "C" .and. ( nAt := At( Chr( 13 ), cHeading ) ) > 0
         nOcurs := 1
         cRest := Substr( cHeading, nAt + 2 )

         While ( nAt := At( Chr( 13 ), cRest ) ) > 0
            nOcurs++
            cRest := Substr( cRest, nAt + 2 )
         EndDo

         nHeight := SBGetHeight( ::hWnd, If( oColumn:oFontHead != Nil, ;
                                             oColumn:oFontHead:hFont, ;
                                             ::oFont:hFont ), 0 )
         nHeight *= ( nOcurs + 1 )

         If ( nHeight + 1 ) > ::nHeightHead
            ::nHeightHead := nHeight + 1
         EndIf

      EndIf

   EndIf

   If ValType( oColumn:cFooting ) $ "CB"
      ::lDrawFooters := If( ::lDrawFooters == Nil, .T., ::lDrawFooters )
      ::lFooting := ::lDrawFooters

      cHeading := If( Valtype( oColumn:cFooting ) == "B", ;
                      Eval( oColumn:cFooting ), oColumn:cFooting )

      If Valtype( cHeading ) == "C" .and. ( nAt := At( Chr( 13 ), cHeading ) ) > 0
         nOcurs := 1
         cRest := Substr( cHeading, nAt + 2 )

         While ( nAt := At( Chr( 13 ), cRest ) ) > 0
            nOcurs++
            cRest := Substr( cRest, nAt + 2 )
         EndDo

         nHeight := SBGetHeight( ::hWnd, If( oColumn:oFontFoot != Nil, ;
                                             oColumn:oFontFoot:hFont, ;
                                             ::oFont:hFont ), 0 )
         nHeight *= ( nOcurs + 1 )

         If ( nHeight + 1 ) > ::nHeightHead
            ::nHeightFoot := nHeight + 1
         EndIf

      Else
         nHeight := SBGetHeight( ::hWnd, If( oColumn:oFontFoot != Nil, ;
                                             oColumn:oFontFoot:hFont, ;
                                             ::oFont:hFont ), 0 ) + 1
         If nHeight > ::nHeightFoot .and. ::lFooting
            ::nHeightFoot := nHeight
         EndIf

      EndIf

   EndIf

   AAdd( ::aColumns , oColumn )
   AAdd( ::aColSizes, oColumn:nWidth )

Return Self

* ============================================================================
* METHOD TSBrowse:AddSuperHead() Version 6.0 Apr/5/2002
* ============================================================================

Method AddSuperHead( nFromCol, nToCol, uHead, nHeight, aColors, l3dLook, ;
                     uFont, lBitMap, lAdjust, lTransp, ;
                     lNoLines, nHAlign, nVAlign ) CLASS TSBrowse

   Local hFont, cHeading, nAt, nLheight, nOcurs, cRest, nLineStyle, ;
         nClrText, nClrBack, nClrLine

   If Empty( ::aColumns )
      Return Nil
   EndIf

   Default lBitMap  := .F., ;
           lAdjust  := .F., ;
           l3DLook  := ::aColumns[ nFromCol ]:l3DLookHead, ;
           nHAlign  := DT_CENTER, ;
           nVAlign  := DT_CENTER, ;
           lTransp := .T.

   uFont := If( uFont != Nil, If( ValType( uFont ) == "O", uFont:hFont, ;
                uFont ), uFont )

   hFont := If( ValType( ::aColumns[ nFromCol]:oFontHead ) == "O", ;
                ::aColumns[ nFromCol]:oFontHead:hFont, ;
            If( ::aColumns[ nFromCol]:oFontHead != Nil, ;
                ::aColumns[ nFromCol]:oFontHead, ::oFont:hFont ) )

   hFont := If( uFont != Nil, uFont, hFont )

   If ValType( aColors ) == "A"
      ASize( aColors, 3 )
      nClrText := If( aColors[ 1 ] != Nil, aColors[ 1 ], ::nClrHeadFore )
      nClrBack := If( aColors[ 2 ] != Nil, aColors[ 2 ], ::nClrHeadBack )
      nClrLine := If( aColors[ 3 ] != Nil, aColors[ 3 ], ::nClrHeadBack )
   Else
      nClrText := ::nClrHeadFore
      nClrBack := ::nClrHeadBack
      nClrLine := ::nClrLine
   EndIf

   cHeading := If( Valtype( uHead ) == "B", Eval( uHead ), uHead )

   Do Case
      Case Valtype( cHeading ) == "C" .and. ;
         ( nAt := At( Chr( 13 ), cHeading ) ) > 0

         Default lNoLines := .F.

         nOcurs := 1
         cRest := Substr( cHeading, nAt + 2 )

         While ( nAt := At( Chr( 13 ), cRest ) ) > 0
            nOcurs++
            cRest := Substr( cRest, nAt + 2 )
         EndDo

         nLheight := SBGetHeight( ::hWnd, hFont, 0 )
         nLheight *= ( nOcurs + 1 )
         nLheight := If( nHeight == Nil .or. nLheight > nHeight, ;
                         nLheight, nHeight )

         If ( nLheight + 1 ) > ::nHeightSuper
            ::nHeightSuper := nLHeight + 1
         EndIf

      Case Valtype( cHeading ) == "C"
         Default lNoLines := .F.

         nLheight := SBGetHeight( ::hWnd, hFont, 0 )
         nLheight := If( nHeight == Nil .or. nLheight > nHeight, ;
                         nLheight, nHeight )

         If ( nLheight + 1 ) > ::nHeightSuper
            ::nHeightSuper := nLHeight + 1
         EndIf

      Case Valtype( cHeading ) == "N" .or. ValType( cHeading ) == "O"
         Default lNoLines := .T.
         lBitMap := .T.
         If ValType( cHeading ) == "O"
            uHead := Eval( ::bBitMapH, uHead )
         EndIf

         nLheight  := SBmpHeight( uHead )

         If nHeight != Nil
            If nHeight < nLHeight .and. lAdjust
               nLheight := nHeight
            ElseIf nHeight > nLheight
               nLheight := nHeight
            EndIf
         EndIf

         If ( nLheight + 1 ) > ::nHeightSuper
            ::nHeightSuper := nLHeight + 1
         EndIf

   EndCase

   nLineStyle := If( lNoLines, 0, 1 )

   AAdd( ::aSuperHead, { nFromCol, nToCol, uHead, nClrText, nClrBack, ;
                         l3dLook, hFont, lBitMap, lAdjust, nLineStyle, ;
                         nClrLine, nHAlign, nVAlign, lTransp } )

Return Self

* ============================================================================
* METHOD TSBrowse:ChangeFont() Version 6.0 Apr/5/2002
* ============================================================================

METHOD ChangeFont( oFont, nColumn, nLevel ) CLASS TSBrowse

   Local nEle, nHeight, nHHeight, oColumn, nAt, cHeading, cRest, nOcurs, ;
         lDrawFooters := If( ::lDrawFooters != Nil, ::lDrawFooters, .F. )

   Default nColumn := 0   // all columns

   nHeight := SBGetHeight( ::hWnd, oFont:hFont, 0 ) + 1

   If nColumn = 0

      If nLevel == Nil

         For nEle := 1 TO Len( ::aColumns )
             ::aColumns[ nEle ]:oFont := oFont
         Next

         If nHeight > ::nHeightCell
            ::nHeightCell := nHeight
         EndIf

         If ::lDrawHeaders

            nHHeight := nHeight

            For nEle := 1 TO Len( ::aColumns )
                oColumn := ::aColumns[ nEle ]
                ::aColumns[ nEle ]:oFontHead := oFont

                cHeading := If( Valtype( oColumn:cHeading ) == "B", ;
                                Eval( oColumn:cHeading ), oColumn:cHeading )

                If Valtype( cHeading ) == "C" .and. ;
                   ( nAt := At( Chr( 13 ), cHeading ) ) > 0

                   nOcurs := 1
                   cRest := Substr( cHeading, nAt + 2 )

                   While ( nAt := At( Chr( 13 ), cRest ) ) > 0
                      nOcurs++
                      cRest := Substr( cRest, nAt + 2 )
                   EndDo

                   nHHeight := nHHeight - 1
                   nHHeight := ( nHHeight * ( nOcurs + 1 ) ) + 1

                EndIf

            Next

            If nHHeight > ::nHeightHead
               ::nHeightHead := nHHeight
            EndIf

         EndIf

         If ::lFooting .and. lDrawFooters
            nHHeight := nHeight

            For nEle := 1 TO Len( ::aColumns )
                oColumn := ::aColumns[ nEle ]
                ::aColumns[ nEle ]:oFontFoot := oFont
                cHeading := If( Valtype( oColumn:cFooting ) == "B", ;
                                Eval( oColumn:cFooting ), oColumn:cFooting )

                If Valtype( cHeading ) == "C" .and. ;
                   ( nAt := At( Chr( 13 ), cHeading ) ) > 0

                   nOcurs := 1
                   cRest := Substr( cHeading, nAt + 2 )

                   While ( nAt := At( Chr( 13 ), cRest ) ) > 0
                      nOcurs++
                      cRest := Substr( cRest, nAt + 2 )
                   EndDo

                   nHHeight := nHHeight - 1
                   nHHeight := ( nHHeight * ( nOcurs + 1 ) ) + 1

                EndIf

            Next

            If nHHeight > ::nHeightFoot
               ::nHeightFoot := nHHeight
            EndIf

         EndIf
      Else
         Do Case
            Case nLevel == 1   // nLevel 1 = Cells

               For nEle := 1 TO Len( ::aColumns )
                  ::aColumns[ nEle ]:oFont := oFont
               Next

               If nHeight > ::nHeightCell
                  ::nHeightCell := nHeight
               EndIf

            Case nLevel == 2  .and. ::lDrawHeaders  // nLevel 2 = Headers

               nHHeight := nHeight

               For nEle := 1 TO Len( ::aColumns )
                   oColumn := ::aColumns[ nEle ]
                   ::aColumns[ nEle ]:oFontHead := oFont
                   cHeading := If( Valtype( oColumn:cHeading ) == "B", ;
                                   Eval( oColumn:cHeading ), oColumn:cHeading )

                   If Valtype( cHeading ) == "C" .and. ;
                      ( nAt := At( Chr( 13 ), cHeading ) ) > 0

                      nOcurs := 1
                      cRest := Substr( cHeading, nAt + 2 )

                      While ( nAt := At( Chr( 13 ), cRest ) ) > 0
                         nOcurs++
                         cRest := Substr( cRest, nAt + 2 )
                      EndDo

                      nHHeight := nHHeight - 1
                      nHHeight := ( nHHeight * ( nOcurs + 1 ) ) + 1

                   EndIf

               Next

               If nHHeight > ::nHeightHead
                  ::nHeightHead := nHHeight
               EndIf

            Case nLevel == 3 .and. ::lFooting .and. lDrawFooters    // nLevel 3 = Footers

               nHHeight := nHeight

               For nEle := 1 TO Len( ::aColumns )
                   oColumn := ::aColumns[ nEle ]
                   ::aColumns[ nEle ]:oFontFoot := oFont
                   cHeading := If( Valtype( oColumn:cFooting ) == "B", ;
                                   Eval( oColumn:cFooting ), oColumn:cFooting )

                   If Valtype( cHeading ) == "C" .and. ;
                      ( nAt := At( Chr( 13 ), cHeading ) ) > 0

                      nOcurs := 1
                      cRest := Substr( cHeading, nAt + 2 )

                      While ( nAt := At( Chr( 13 ), cRest ) ) > 0
                         nOcurs++
                         cRest := Substr( cRest, nAt + 2 )
                      EndDo

                      nHHeight := nHHeight - 1
                      nHHeight := ( nHHeight * ( nOcurs + 1 ) ) + 1

                   EndIf

               Next

               If nHHeight > ::nHeightFoot
                  ::nHeightFoot := nHHeight
               EndIf

         EndCase

      EndIf

   Else

      If nLevel == Nil

         If nHeight > ::nHeightCell
            ::nHeightCell := nHeight
         EndIf

         ::aColumns[ nColumn ]:oFont := oFont

         If ::lDrawHeaders

            oColumn := ::aColumns[ nColumn ]
            nHHeight := nHeight

            cHeading := If( Valtype( oColumn:cHeading ) == "B", ;
                            Eval( oColumn:cHeading ), oColumn:cHeading )

            If Valtype( cHeading ) == "C" .and. ;
               ( nAt := At( Chr( 13 ), cHeading ) ) > 0

               nOcurs := 1
               cRest := Substr( cHeading, nAt + 2 )

               While ( nAt := At( Chr( 13 ), cRest ) ) > 0
                  nOcurs++
                  cRest := Substr( cRest, nAt + 2 )
               EndDo

               nHHeight := nHHeight - 1
               nHHeight := ( nHHeight * ( nOcurs + 1 ) ) + 1

            EndIf

            If nHHeight > ::nHeightHead
               ::nHeightHead := nHHeight
            EndIf

            ::aColumns[ nColumn ]:oFontHead := oFont

         EndIf

         If ::lFooting .and. lDrawFooters

            oColumn := ::aColumns[ nColumn ]
            nHHeight := nHeight

            cHeading := If( Valtype( oColumn:cFooting ) == "B", ;
                            Eval( oColumn:cFooting ), oColumn:cFooting )

            If Valtype( cHeading ) == "C" .and. ;
               ( nAt := At( Chr( 13 ), cHeading ) ) > 0

               nOcurs := 1
               cRest := Substr( cHeading, nAt + 2 )

               While ( nAt := At( Chr( 13 ), cRest ) ) > 0
                  nOcurs++
                  cRest := Substr( cRest, nAt + 2 )
               EndDo

               nHHeight := nHHeight - 1
               nHHeight := ( nHHeight * ( nOcurs + 1 ) ) + 1

            EndIf

            If nHHeight > ::nHeightFoot
               ::nHeightFoot := nHHeight
            EndIf

            ::aColumns[ nColumn ]:oFontFoot := oFont

         EndIf

      Else

         Do Case
            Case nLevel == 1    // nLevel 1 = Cells

               ::aColumns[ nColumn ]:oFont := oFont

               If nHeight > ::nHeightCell
                  ::nHeightCell := nHeight
               EndIf

            Case nLevel == 2 .and. ::lDrawHeaders  // nLevel 2 = Headers

               oColumn := ::aColumns[ nColumn ]
               nHHeight := nHeight

               cHeading := If( Valtype( oColumn:cHeading ) == "B", ;
                               Eval( oColumn:cHeading ), oColumn:cHeading )

               If Valtype( cHeading ) == "C" .and. ;
                  ( nAt := At( Chr( 13 ), cHeading ) ) > 0

                  nOcurs := 1
                  cRest := Substr( cHeading, nAt + 2 )

                  While ( nAt := At( Chr( 13 ), cRest ) ) > 0
                     nOcurs++
                     cRest := Substr( cRest, nAt + 2 )
                  EndDo

                  nHHeight := nHHeight - 1
                  nHHeight := ( nHHeight * ( nOcurs + 1 ) ) + 1

               EndIf

               If nHHeight > ::nHeightHead
                  ::nHeightHead := nHHeight
               EndIf

               ::aColumns[ nColumn ]:oFontHead := oFont

            Case nLevel == 3 .and. ::lFooting .and. lDrawFooters    // nLevel 3 = Footers

               oColumn := ::aColumns[ nColumn ]
               nHHeight := nHeight

               cHeading := If( Valtype( oColumn:cFooting ) == "B", ;
                               Eval( oColumn:cFooting ), oColumn:cFooting )

               If Valtype( cHeading ) == "C" .and. ;
                  ( nAt := At( Chr( 13 ), cHeading ) ) > 0

                  nOcurs := 1
                  cRest := Substr( cHeading, nAt + 2 )

                  While ( nAt := At( Chr( 13 ), cRest ) ) > 0
                     nOcurs++
                     cRest := Substr( cRest, nAt + 2 )
                  EndDo

                  nHHeight := nHHeight - 1
                  nHHeight := ( nHHeight * ( nOcurs + 1 ) ) + 1

               EndIf

               If nHHeight > ::nHeightFoot
                  ::nHeightFoot := nHHeight
               EndIf

               ::aColumns[ nColumn ]:oFontFoot := oFont

         EndCase

      EndIf

   EndIf

   ::Refresh( .T. )

Return Self

* ============================================================================
* METHOD TSBrowse:DbSkipper() Version 6.0 Apr/5/2002
* ============================================================================

METHOD DbSkipper( nToSkip ) CLASS TSBrowse

   Local nSkipped := 0

   Default nToSkip := 0, ;
           ::nAt := 1

   If nToSkip == 0 .or. ( ::cAlias )->( LastRec() ) == 0
      ( ::cAlias )->( dbSkip( 0 ) )
   ElseIf nToSkip > 0 .and. ! ( ::cAlias )->( EoF() ) // going down

      While nSkipped < nToSkip
         ( ::cAlias )->( DbSkip( 1 ) )
         If ( ::cAlias )->( Eof() )
            If ::lAppendMode
               nSkipped ++
            Else
               ( ::cAlias )->( DbSkip( -1 ) )
            EndIf
            Exit
         EndIf
         nSkipped ++

      Enddo

   ElseIf nToSkip < 0 .and. ! ( ::cAlias )->( BoF() )  // going up
      Do While nSkipped > nToSkip
         ( ::cAlias )->( dbSkip( -1 ) )
         If ( ::cAlias )->( Bof() )
            Exit
         EndIf
         nSkipped --
      Enddo
   EndIf

   ::nAt += nSkipped

Return nSkipped

* ============================================================================
* METHOD TSBrowse:Default() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Default() CLASS TSBrowse

    Local nI, nTemp, nElements, aFields, nHeight, nStyle, nMin, nMax, nPage, ;
          nWidth := 0, ;
          nTxtWid := 0, ;
          nMaxWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ),;
          cAlias := Alias(), ;
          aJustify := ::aJustify

   Default ::aHeaders := {}, ::aColSizes := {}

   If ::bLine == Nil .and. Empty( ::aColumns )
      If Empty( ::cAlias )
         ::cAlias := cAlias
      Else
         cAlias := ::cAlias
      EndIf

      If Upper( ::oWnd:ClassName() ) != "TDIALOG"

         If ::lDrag
            ::nHeightCell := ::nHeightHead :=  SBGetHeight( ::hWnd, ;
                                                            ::oFont:hFont, 0 )
         EndIf

         ADD COLUMN TO Self ;
             DATA   { || " " } ;
             HEADER "_Dummy"

         Return Self

      EndIf

      If ! EmptyAlias( ::cAlias ) .and. ::cAlias != "ARRAY" .and. ;
         ::cAlias != "TEXT_"
         ::LoadFields()
      EndIf

   EndIf

   If ::bLine != Nil .and. Empty(::aColumns)

      Default nElements := Len( Eval(::bLine) ), ;
              aJustify := Afill( Array( nElements ), 0 )

      If Len( ::aHeaders ) < nElements
         If ::oTree == Nil
            ::aHeaders := Array( nElements )
            For nI := 1 to nElements
                ::aHeaders[ nI ] := ( cAlias )->( FieldName( nI ) )
            Next
         Else
            ::aHeaders := Array( nElements )
            AFill( ::aHeaders, "" )
         EndIf
      EndIf

      If ValType( ::aColSizes ) == "B"
         ::aColSizes := Eval( ::aColSizes )
      EndIf

      If Len( ::GetColSizes() ) < nElements
         ::aColSizes := Afill( Array( nElements ), 0 )
         aFields := Eval( ::bLine )

         For nI := 1 TO nElements
            nTxtWid := SBGetHeight( ::hWnd, ::oFont:hFont, 1 )
            ::aColSizes[ nI ] := If( ValType( aFields[ nI ] ) != "C", 16, ; // Bitmap handle
                                     ( nTxtWid * ;
                                       Max( Len( ::aHeaders[ nI ] ), ;
                                            Len( aFields[ nI ] ) ) + 1 ) )
         Next

      EndIf

      If ::oItem != Nil
         ::nLineStyle := 0
      EndIf

      aJustify := Afill( Array( nElements ), 0 )
      Aeval( ::aJustify, { | x, n | aJustify[ n ] := If( ValType( x ) == "L", ;
                           If( x, 2, 0 ), x ) } )

      For nI := 1 to nElements
         ADD COLUMN TO Self ;
             DATA   MakeBlock( Self, nI ) ;
             HEADER ::aHeaders[ nI ] ;
             SIZE   ::aColSizes[ nI ] ;
             COLOR  ::nClrText, ::nClrPane, ::nClrHeadFore, ::nClrHeadBack, ;
                    ::nClrFocuFore, ::nClrFocuBack ;
             MOVE   If( ::lAutoEdit, 5, 1 )

         ATail( ::aColumns ):lEdit  := ::lAutoEdit
         ATail( ::aColumns ):nAlign := aJustify[ nI ]
         ATail( ::aColumns ):oFont  := ::oFont
         ATail( ::aColumns ):oFontHead := ::oFont
         ATail( ::aColumns ):oFontFoot := ::oFont
      Next
   EndIf

   ::lIsDbf := ! EmptyAlias( ::cAlias ) .and. ::cAlias != "ARRAY" .and. ;
                 ::cAlias != "TEXT_" .and. ::oTree == Nil

   ASize( ::aColSizes, Len( ::aColumns ) ) // make sure they match sizes

   // rebuild build the aColSize, it's needed to Horiz Scroll etc
   // and expand selected column to flush table window right

   For nI := 1 To Len( ::aColumns )

      nTemp := ::aColSizes[ nI ] := ::aColumns[ nI ]:nWidth

      If ! Empty( ::nAdjColumn ) .and. ( nWidth + nTemp > nMaxWidth )
        If ::nAdjColumn < nI
          ::aColumns[ ::nAdjColumn ]:nWidth := ;
          ::aColSizes[ ::nAdjColumn ] += ( nMaxWidth - nWidth )
        EndIf
        ::nAdjColumn := 0
      EndIf

      nWidth += nTemp

      If ::lIsDbf .and. ! Empty( ::aColumns[ nI ]:cOrder ) .and. ;
         ! ::aColumns[ nI ]:lEdit

         If ::nColOrder == 0
            ::SetOrder( nI )  // establish cOrder as the active index/tag
         EndIf

         ::aColumns[ nI ]:lIndexCol := .T.
         ::lSeek := .T.

      EndIf

      If ValType( ::aColumns[ nI ]:cFooting ) $ "CB" // informs browse that it has footings to display
         ::lDrawFooters := If( ::lDrawFooters == Nil, .T., ::lDrawFooters )
         ::lFooting := ::lDrawFooters
         nHeight := SBGetHeight( ::hWnd, ;
                                 If( ::aColumns[ nI ]:oFontFoot != Nil, ;
                                     ::aColumns[ nI ]:oFontFoot:hFont, ;
                                     ::oFont:hFont ), 0 ) + 1
         If nHeight > ::nHeightFoot .and. ::lFooting
            ::nHeightFoot := nHeight
         EndIf
      EndIf


   Next

   // now catch the odd-ball where last column doesn't fill box
   If ! Empty( ::nAdjColumn ) .and. nWidth < nMaxWidth .and. ::nAdjColumn < nI

      ::aColumns[ ::nAdjColumn ]:nWidth := ;
                      ::aColSizes[ ::nAdjColumn ] += ( nMaxWidth - nWidth )
      ::nAdjColumn := 0

   EndIf

   If ::bLogicLen != Nil
      ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                    Eval( ::bLogicLen ) )
   EndIf

   If ! ::lNoVScroll
      nMin  := Min( 1, ::nLen )
      nMax  := Min( ::nLen, MAX_POS )
      nPage := Min( ::nRowCount(), ::nLen )
      ::oVScroll := TSBScrlBar():WinNew( nMin, nMax, nPage, .T., Self )
   EndIf

   #ifdef USE_CONTEXT
   If ::oCtx == Nil .and. ! Empty( ::cAlias ) .and.;
      (! ::cAlias == "ARRAY" ) .and. ;
      ! ( ::cAlias == "TEXT_" ) .and. ::lAutoCtx

      // a context hasn't been established, and not browsing arrays
      If ::lDbfObj
        ::oCtx := TWAContext():New( ::oDbf:cAlias )
      Else
        ::oCtx := TWAContext():New( ::cAlias )
      EndIf

   EndIf
   #EndIf

   If ::l3DLook    // to apply Look3d() method
      Aeval( ::aColumns, { | oCol | oCol:l3DLook := oCol:l3DLookHead := ;
                                    oCol:l3DLookFoot := .T. } )
   EndIf

   If ::cDriver == Nil
       ::ResetBarPos( .T. )   // first time call inits RDD specific ORD functions
   EndIf

   If ::oTree != Nil
      ::lDrawHeaders := .F.
      ::nLineStyle := 0
      ::lNoHScroll := .F.
      ::nFreeze := Min( 2, ( Len( ::aColumns ) - 1 ) )
   EndIf

   If ! ::lNoHScroll
      If ! Empty( ::cAlias ) .and. ::cAlias == "TEXT_"
         nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::oFont != Nil, ::oFont:hFont, 0 ) ) )
         nMin := 1
         nMax := ::oTxtFile:nMaxLineLength - Int( nMaxWidth / nTxtWid )
         ::oHScroll := TSBScrlBar():WinNew( nMin, nMax,, .F., Self )
      Else
         nMin := Min( 1, Len( ::aColumns ) )
         nMax := Len( ::aColumns )
         ::oHScroll := TSBScrlBar():WinNew( nMin, nMax,, .F., Self )
      EndIf

   EndIf

   If ::oFont == Nil
      ::oFont := ::oWnd:oFont
   EndIf

   For nI := 1 TO Len( ::aColumns )

      If ::aColumns[ nI ]:oFont == Nil
         ::aColumns[ nI ]:oFont := ::oFont
      EndIf

      If ::aColumns[ nI ]:oFontHead == Nil
         ::aColumns[ nI ]:oFontHead := ::oFont
      EndIf

      If ::aColumns[ nI ]:oFontFoot == Nil
         ::aColumns[ nI ]:oFontFoot := ::oFont
      EndIf

      If ::lLockFreeze .and. ::nFreeze >= nI
         ::aColumns[ nI ]:lNoHilite := .T.
      EndIf

   Next

   For nI := 1 To Len( ::aColumns )
      If ! ::aColumns[ nI ]:lNoHilite .and. nI > ::nFreeze
         ::HiliteCell( nI )
         Exit
      EndIf
   Next

   ::nHeightHead := If( ::lDrawHeaders, ::nHeightHead, 0 )
   ::nHeightFoot := If( ::lFooting .and. ::lDrawFooters, ::nHeightFoot, 0 )

   SetHeights( Self )

   If ! ::lNoVScroll
      nPage := Min( ::nRowCount(), ::nLen )
      ::oVScroll:SetPage( nPage, .T. )
   EndIf

   If ! ::lNoHScroll
      nPage := 1
      ::oHScroll:SetPage( nPage, .T. )
   EndIf

   nLapsus := Seconds()

   If ::oBrush != Nil .and. ::oBrush:hBrush != ::oWnd:oBrush:hBrush
      ::oBrush:nCount++
   EndIf

   If Upper( ::oWnd:ClassName() ) == "TDIALOG"
      ::Move( ::nTop, ::nLeft, ::nWidth(), ::nHeight(), .T. )
   EndIf


Return Self

* ============================================================================
* METHOD TSBrowse:DelColumn() Version 6.0 Apr/5/2002
* ============================================================================

METHOD DelColumn( nPos ) CLASS TSBrowse

   Local oCol, nMin, nMax

   Default nPos := 1

	If Len( ::aColumns ) == 1                     // cannot delete last column
		Return Nil                                 // ... or Nil if last column
   EndIf

	If nPos < 1
		nPos := 1
   ElseIf nPos > Len( ::aColumns )
		nPos := Len( ::aColumns )
   EndIf

   oCol := ::aColumns[ nPos ]
	ASize( ADel( ::aColumns, nPos), Len( ::aColumns ) - 1 )
	ASize( ADel( ::aColSizes, nPos), Len( ::aColSizes ) - 1 )

   If ::nColOrder == nPos                        // deleting a ::SetOrder() column
		::nColOrder := 0                           // to avoid runtime error
		::cOrderType := ""
   ElseIf ::nColOrder != 0 .and. ::nColOrder > nPos
		::nColOrder --
   EndIf

   If ::nCell > Len( ::aColSizes )
      If ! ::IsColVisible( ::nCell - 1 )
         ::GoLeft()
      Else
         ::nCell--
      EndIf
   EndIf

   ::HiliteCell( ::nCell )                       // make sure we have a hilited cell

   If ::lNoHScroll
      nMin := Min( 1, Len( ::aColumns ) )
      nMax := Len( ::aColumns )
      ::oHScroll := TSBScrlBar():WinNew( nMin, nMax,, .F., Self )
      ::oHScroll:SetRange( 1, Len( ::aColumns ) )
      ::oHScroll:SetPage( 1 , .T. )
      If ::nCell == Len( ::aColSizes )
         ::oHScroll:GoBottom()
      Else
         ::oHScroll:SetPos( ::nCell )
      EndIf
   EndIf

   ::SetFocus()
   ::Refresh( .F. )

Return oCol

* ============================================================================
* METHOD TSBrowse:Destroy() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Destroy() CLASS TSBrowse

   If ::oCtx != Nil
      ::oCtx:Destroy()
   EndIf

   If ::oTxtFile != Nil
      ::oTxtFile:Close()
   EndIf

   If ::lMyFont
      ::oFont:End()
   Else
      ::oFont:nCount--
   EndIf

   If ::oVScroll != Nil
      ::oVScroll:Destroy()
   EndIf

   If ::oHScroll != Nil
      ::oHScroll:Destroy()
   EndIf

   If ! Empty( ::hWnd )
      ::UnLink()
   EndIf

   ::hWnd = 0

Return Nil

* ============================================================================
* METHOD TSBrowse:Display() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Display() CLASS TSBrowse

	Local nRecs, nTxtWid
   Local nMaxWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 )

   If ::oWnd:hWnd == 0 .or. ! ::oWnd:lVisible .or. ;  // Dialog still not ACTIVATEd
      ( Empty( ::cAlias ) .and. ::oTree == Nil )      // or already closed
		Return 0
   EndIf

   ::BeginPaint()

   If ::oVScroll != Nil

      nRecs := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                   Eval( ::bLogicLen ) )

      If ::oVScroll:nMax != nRecs .or. nRecs != ::nLen
         ::nLen := nRecs
         ::oVScroll:SetRange( 1, Max( nRecs, 1 ) )
      EndIf

   EndIf

   If ::oHScroll != Nil
      If ! Empty( ::cAlias ) .and. ::cAlias == "TEXT_"
			 nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::oFont != nil, ::oFont:hFont, 0 ) ) )
			::oHScroll:SetRange( 1, ::oTxtFile:nMaxLineLength - Int( nMaxWidth / nTxtWid ) )
		Else
			::oHScroll:SetRange( 1, Len( ::aColumns ) )   //::GetColSizes()
      EndIf
   EndIf

	::Paint()

   ::EndPaint()

   If ::lIsDbf .and. ::lHasFocus .and. ( ::nLen == 0 .or. ::nRowPos == 0 )
      ::Godown()
   EndIf

   If ::bChange != Nil
      Eval( ::bChange, Self, 0 )
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:DrawHeaders() Version 6.0 Apr/5/2002
* ============================================================================

METHOD DrawHeaders() CLASS TSBrowse

    Local nI, nJ, nBegin, nStartCol, oColumn, l3DLook, nClrFore, lAdjBmp, ;
          nAlign, nClrBack, hFont, cFooting, cHeading, lBitMap, nLastCol, ;
          lMultiLine, nVertText, nClrTo, lDegrad, lBrush, ;
          nMaxWidth    := ::nWidth() , ;
          aColSizes    := AClone( ::aColSizes ), ;   // use local copies for speed
          aColumns     := AClone( ::aColumns ), ;
          nHeightHead  := ::nHeightHead, ;
          nHeightFoot  := ::nHeightFoot

    Local nHeightSuper := ::nHeightSuper, ;
          hBrwFont     := ::oFont:hFont, ;
          nVAlign      := 1, ;
          l3DText, nClr3dL, nClr3dS

    Local hWnd         := ::hWnd, ;
          hDC          := ::hDc, ;
          nClrText     := ::nClrText, ;
          nClrPane     := ::nClrPane, ;
          nClrHeadFore := ::nClrHeadFore, ;
          nClrHeadBack := ::nClrHeadBack, ;
          nClrFootFore := ::nClrFootFore, ;
          nClrFootBack := ::nClrFootBack, ;
          nClrOrdeFore := ::nClrOrdeFore, ;
          nClrOrdeBack := ::nClrOrdeBack, ;
          nClrLine     := ::nClrLine, ;
          l3DLookHead  := ::l3DLook, ;
          l3DLookFoot  := ::l3DLook

    If ::aColSizes == Nil .or. Len( ::aColSizes ) < Len( ::aColumns )
       ::aColSizes := {}
       For nI := 1 To Len( ::aColumns )
          AAdd( ::aColSizes, ::aColumns[ nI ]:nWidth )
       Next
       aColSizes := ::aColSizes
    EndIf

    nClrBack := If( ::nPhantom = -1, ATail( aColumns ):nClrHeadBack, nClrPane )
    nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), nClrBack )
    nClrFore := If( ::nPhantom = -1, ATail( aColumns ):nClrFootBack, nClrPane )
    nClrFore := If( ValType( nClrFore ) == "B", Eval( nClrFore ), nClrFore )

    l3DLook := ATail( aColumns ):l3DLookHead
    // "Phantom" column; :nPhantom hidden IVar
    AAdd( aColumns, TSColumn():New(  "", ; // cHeading
                               {|| "" }, ; // bdata
                                    nil, ; // cPicture
                  { nClrText, nClrPane,, ;
               nClrBack,,,,,,nClrFore }, ; // aColors
                                    nil, ; // aAlign
                             ::nPhantom, ; // nWidth
                                    nil, ; // lBitMap
                                    nil, ; // lEdit
                                    nil, ; // bValid
                                    .T., ; // lNoLite
                                    nil, ; // cOrder
                                    nil, ; // cFooting
                                    nil, ; // bPrevEdit
                                    nil, ; // bPostEdit
                                    nil, ; // nEditMove
                                    nil, ; // lFixLite
                            { l3DLook } ) )

    nLastCol := Len( aColumns )
    AAdd( aColSizes, ::nPhantom )

    nJ := nStartCol := 0

    nBegin := Min( If( ::nColPos <= ::nFreeze, ( ::nColPos := ::nFreeze + 1,;
                ::nColPos - ::nFreeze ), ::nColPos - ::nFreeze ), nLastCol )

    If Empty( aColumns )
       Return Self
    EndIf

   If ! Empty( ::aSuperHead )
      ::DrawSuper()
   EndIf

   For nI := nBegin To nLastCol

      If nStartCol > nMaxWidth
         Exit
      EndIf

      nJ := If( nI < ::nColPos, nJ + 1, nI )

      oColumn := aColumns[ nJ ]

      If ::lDrawHeaders

         nVertText := 0
         If oColumn:nHAlign == DT_VERT

            If oColumn:oFontHead != Nil
               cHeading := oColumn:oFontHead:cFaceName
               nAlign := oColumn:oFontHead:nHeight
               nVAlign := oColumn:oFontHead:nWidth
            Else
               cHeading := ::oFont:cFaceName
               nAlign := ::oFont:nHeight
               nVAlign := ::oFont:nWidth
            EndIf

            hFont = CreateFont( { nAlign, nVAlign, 900, 0, 0, .F., .F., .F., ;
                                  1, 0, 0, 0, 0, cHeading } )

            nVAlign := 2
            nAlign :=  1
            nVertText := 1

         Else
            hFont := If( oColumn:oFontHead == Nil, hBrwFont, oColumn:oFontHead:hFont )
         EndIf

         If ( l3DLook := oColumn:l3DLookHead ) == Nil
            l3DLook := l3DLookHead
         EndIf

         nAlign := If( ValType( oColumn:nHAlign ) == "B", ;
                       Eval( oColumn:nHAlign ), oColumn:nHAlign )

         If ( nClrFore := If( ::nColOrder == nI, oColumn:nClrOrdeFore, ;
                                oColumn:nClrHeadFore ) ) == Nil
            nClrFore := If( ::nColOrder == nI, nClrOrdeFore, ;
                            nClrHeadFore )
         EndIf

         nClrFore := If( ValType( nClrFore ) == "B", Eval( nClrFore ), nClrFore )

         If ( nClrBack := If( ::nColOrder == nI, oColumn:nClrOrdeBack, ;
                              oColumn:nClrHeadBack ) ) == Nil
            nClrBack := If( ::nColOrder == nI, nClrOrdeBack, ;
                            nClrHeadBack )
         EndIf

         nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), nClrBack )

         lBrush := Valtype( nClrBack ) == "O"

         If ( lDegrad := ValType( nClrBack ) == "A" )
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", ;
                            Eval( nClrBack ), nClrBack )
         EndIf

         cHeading := If( Valtype( oColumn:cHeading ) == "B", ;
                         Eval( oColumn:cHeading ), oColumn:cHeading )

         lBitMap := ValType( cHeading ) == "N" .or. ValType( cHeading ) == "O"

         cHeading := If( ValType( cHeading ) == "O", ;
                         Eval( ::bBitMapH, cHeading ), cHeading )

         lAdjBmp := If( Valtype( oColumn:lAdjBmpHead ) = Nil, .T., ;
                        oColumn:lAdjBmpHead )

         lMultiLine := Valtype( cHeading ) == "C" .and. At( Chr( 13 ), cHeading ) > 0

         If lMultiLine
            nVAlign := DT_TOP
         EndIf

         If oColumn:l3DTextHead != Nil
            l3DText := oColumn:l3DTextHead
            nClr3dL := oColumn:nClr3DLHead
            nClr3dS := oColumn:nClr3DSHead
            nClr3dL := If( ValType( nClr3dL ) == "B", ;
                           Eval( nClr3dL, 0, nJ ), nClr3dL )
            nClr3dS := If( ValType( nClr3dS ) == "B", ;
                           Eval( nClr3dS, 0, nJ ), nClr3dS )
         Else
            l3DText := nClr3dL := nClr3dS := Nil
         EndIf

         TSDrawCell(      hWnd, ;  // 1
                           hDC, ;  // 2
                             0, ;  // 3
                     nStartCol, ;  // 4
               aColSizes[ nJ ], ;  // 5
                      cHeading, ;  // 6
                        nAlign, ;  // 7
                      nClrFore, ;  // 8
                      nClrBack, ;  // 9
                         hFont, ;  // 10
           If( lBitMap, 1, 0 ), ;  // 11 nBitmap
                   nHeightHead, ;  // 12
                       l3DLook, ;  // 13
                             1, ;  // 14 nLineStyle
                      nClrLine, ;  // 15
                             1, ;  // 16 1=Header 2=Footer 3=Super
                   nHeightHead, ;  // 17
                   nHeightFoot, ;  // 18
                  nHeightSuper, ;  // 19
                       lAdjBmp, ;  // 20
                    lMulTiLine, ;  // 21
                       nVAlign, ;  // 22
                     nVertText, ;  // 23
                        nClrTo, ;  // 24
                       lDegrad, ;  // 25
                    If( lBrush, ;
          nClrBack:hBrush, 0 ), ;  // 26
                       l3DText, ;  // 27  3D text
                       nClr3dL, ;  // 28  3D text light color
                       nClr3dS )   // 29  3D text shadow color

         nVAlign := 1

         If oColumn:nHAlign == DT_VERT
            DeleteObject( hFont )
         EndIf

      EndIf

      If ::lFooting .and. ::lDrawFooters                  // Draw Footing

         hFont := If( oColumn:oFontFoot == Nil, hBrwFont, oColumn:oFontFoot:hFont )

         If ( l3DLook := oColumn:l3DLookFoot ) == Nil
            l3DLook := l3DLookFoot
         EndIf

         ATail( aColumns ):l3DLookFoot := l3DLook

         nAlign := If( ValType( oColumn:nFAlign ) == "B", ;
                       Eval( oColumn:nFAlign ), oColumn:nFAlign )

         nClrFore := If( oColumn:nClrFootFore != Nil, oColumn:nClrFootFore , ;
                         nClrFootFore )
         nClrFore := If( ValType( nClrFore ) == "B", Eval( nClrFore ), nClrFore )

         nClrBack := If( oColumn:nClrFootBack != Nil, oColumn:nClrFootBack, ;
                         nClrFootBack )

         nClrBack := If( ValType( nClrBack ) == "B", Eval( nClrBack ), nClrBack )

         lBrush := Valtype( nClrBack ) == "O"

         If ( lDegrad := ValType( nClrBack ) == "A" )
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", ;
                            Eval( nClrBack ), nClrBack )
         EndIf

         cFooting := If( Valtype( oColumn:cFooting ) == "B", ;
                         Eval( oColumn:cFooting ), oColumn:cFooting )

         lBitMap := ValType( cFooting ) == "N" .or. ValType( cHeading ) == "O"

         cFooting := If( ValType( cFooting ) == "O", ;
                         Eval( ::bBitMapH, cFooting ), cFooting )

         lAdjBmp := If( Valtype( oColumn:lAdjBmpFoot ) = Nil, .T., ;
                        oColumn:lAdjBmpFoot )

         lMultiLine := Valtype( cFooting ) == "C" .and. At( Chr( 13 ), cFooting ) > 0

         If oColumn:l3DTextFoot != Nil
            l3DText := oColumn:l3DTextFoot
            nClr3dL := oColumn:nClr3DLFoot
            nClr3dS := oColumn:nClr3DSFoot
            nClr3dL := If( ValType( nClr3dL ) == "B", ;
                           Eval( nClr3dL, 0, nJ ), nClr3dL )
            nClr3dS := If( ValType( nClr3dS ) == "B", ;
                           Eval( nClr3dS, 0, nJ ), nClr3dS )
         Else
            l3DText := nClr3dL := nClr3dS := Nil
         EndIf

         TSDrawCell(     hWnd, ;  // 1
                          hDC, ;  // 2
                ::nRowCount(), ;  // 3
                    nStartCol, ;  // 4
                aColSizes[nJ], ;  // 5
                     cFooting, ;  // 6
                       nAlign, ;  // 7
                     nClrFore, ;  // 8
                     nClrBack, ;  // 9
                        hFont, ;  // 10
          If( lBitMap, 1, 0 ), ;  // 11  nBitmap
                  nHeightFoot, ;  // 12
                      l3DLook, ;  // 13
                            1, ;  // 14  nLineStyle
                     nClrLine, ;  // 15
                            2, ;  // 16  1=Header 2=Footer 3=Super
                  nHeightHead, ;  // 17
                  nHeightFoot, ;  // 18
                 nHeightSuper, ;  // 19
                      lAdjBmp, ;  // 20
                   lMultiLine, ;  // 21
                      nVAlign, ;  // 22
                            0, ;  // 23 nVertText
                       nClrTo, ;  // 24
                      lDegrad, ;  // 25
                   If( lBrush, ;
         nClrBack:hBrush, 0 ), ;  // 26
                      l3DText, ;  // 27  3D text
                      nClr3dL, ;  // 28  3D text light color
                      nClr3dS )   // 29  3D text shadow color
      EndIf

      nStartCol += aColSizes[nJ]

   Next

Return Self

* ============================================================================
* METHOD TSBrowse:_DrawIcon() Version 6.0 Apr/5/2002
* ============================================================================

METHOD _DrawIcon( nIcon, lFocused ) CLASS TSBrowse

   Local nIconsByRow := Int( ::nWidth() / 50 ), ;
         nRow := Int( --nIcon / nIconsByRow ), ;
         nCol := If( nRow > 0, nIcon % ( nRow * nIconsByRow ), nIcon )

   DEFAULT lFocused := .F.

   If lFocused
      DrawIconFocus( ::GetDC(), ( nRow * 50 ) + 10, ( nCol * 50 ) + 10,;
                     ExtractIcon( "user.exe" ) )
   Else
      DrawIcon( ::GetDC(), ( nRow * 50 ) + 10, ( nCol * 50 ) + 10,;
                ExtractIcon( "user.exe" ) )
   EndIf

Return nil

* ============================================================================
* METHOD TSBrowse:DrawIcons() Version 6.0 Apr/5/2002
* ============================================================================

METHOD DrawIcons() CLASS TSBrowse

   Local oFont, cText, nFntSize, ;
         nWidth := ::nWidth(), ;
         nHeight := ::nHeight(), ;
         nRow := 10, ;
         nCol := 10, ;
         n := 1, ;
         nIcons := Int( nWidth / 50 ) * Int( nHeight / 50 ), ;
         hIcon := ExtractIcon( "user.exe", 0 )

   ::GSSysFont()                              // initialize "default" font
   nFntSize := If( ::cSysFont == "Tahoma", -11, -8 )

   DEFINE FONT oFont NAME ::cSysFont SIZE 0, nFntSize UNDERLINE

   SelectObject( ::hDC, oFont:hFont )
   SetBkColor( ::hDC, CLR_BLUE )
   SetTextColor( ::hDC, CLR_WHITE )

   While n <= nIcons .and. ! ( ::cAlias )->( EoF() )
      If ::bIconDraw != nil .and. ::aIcons != nil
         hIcon := ::aIcons[ Eval( ::bIconDraw, Self ) ]
      EndIf

      DrawIcon( ::hDC, nRow, nCol, hIcon )

      If ::bIconText != nil
         cText := cValToChar( Eval( ::bIconText, Self ) )
      Else
         cText := Str( ( ::cAlias )->( RecNo() ) )
      EndIf

      DrawText( ::hDC, cText, { nRow + 35, nCol - 5, nRow + 48, nCol + 40 }, 1 )

      nCol += 50

      If nCol >= nWidth - 32
         nRow += 50
         nCol := 10
      EndIf

      ( ::cAlias )->( DbSkip() )
      n++
   Enddo

   ( ::cAlias )->( DbSkip( 1 - n ) )

   oFont:End()

Return Nil

* ============================================================================
* METHOD TSBrowse:DrawLine() Version 6.0 Apr/5/2002
* ============================================================================

METHOD DrawLine( xRow ) CLASS TSBrowse

   Local nI, nJ, nBegin, nStartCol, oColumn, lBitMap, cPicture, hFont, nClrTo, ;
         nClrFore, nClrBack, uData, nLastCol, lAdjBmp, lMultiLine, nAlign, ;
         lDegrad, lBrush, ;
         nVertText   := 0, ;
         nVAlign     := 1, ;
         lSelected   := .F., ;
         nMaxWidth   := ::nWidth(), ;        // use local copies for speed
         nRowPos     := ::nRowPos, ;
         nClrText    := ::nClrText, ;
         nClrPane    := ::nClrPane

   Local l3DText, nClr3dL, nClr3dS

   Local aColSizes   := AClone( ::aColSizes ), ;
         aColumns    := AClone( ::aColumns ), ;
         hWnd        := ::hWnd, ;
         hDC         := ::hDC, ;
         lGridLine   := ::lGridLine, ;
         nLineStyle  := ::nLineStyle, ;
         nClrLine    := ::nClrLine, ;
         hBrwFont    := ::oFont:hFont, ;
         nHeightCell := ::nHeightCell, ;
         nHeightHead := If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
         nHeightFoot := If( ::lDrawFooters != Nil .and. ::lDrawFooters, ;
                            ::nHeightFoot, 0 ), ;
         nHeightSuper := If( ::lDrawHeaders, ::nHeightSuper, 0 )

   Default xRow := ::nRowPos

   lSelected := ::lCanSelect .and. ( AScan( ::aSelected, ;
                If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt ) ) ) > 0

   nClrBack := If( ::nPhantom = -1, ATail( aColumns ):nClrBack, nClrPane )
   nClrBack := If( ValType( nClrBack ) == "B", ;
                   Eval( nClrBack, ::nAt, Len( aColumns ), Self ), nClrBack )

   If ::nLen > 0
      //  "Phantom" column; :nPhantom hidden IVar
      AAdd( aColumns, TSColumn():New(  "", ; // cHeading
                                 {|| "" }, ; // bdata
                                      nil, ; // cPicture
                   { nClrText, nClrBack }, ; // aColors
                                      nil, ; // aAlign
                               ::nPhantom, ; // nWidth
                                      nil, ; // lBitMap
                                      nil, ; // lEdit
                                      nil, ; // bValid
                                      .T., ; // lNoLite
                                      nil, ; // cOrder
                                      nil, ; // cFooting
                                      nil, ; // bPrevEdit
                                      nil, ; // bPostEdit
                                      nil, ; // nEditMove
                                      nil, ; // lFixLite
                              {::l3DLook} ) )
      AAdd( aColSizes, ::nPhantom )

      nJ := nStartCol := 0
      nLastCol := Len( aColumns ) // last col width -1 (grid) -2 (no grid) is flag for TSDrawCell
      nBegin := Min( If( ::nColPos <= ::nFreeze, ( ::nColPos := ::nFreeze + 1,;
                  ::nColPos - ::nFreeze ), ::nColPos - ::nFreeze ), nLastCol )

      For nI := nBegin To nLastCol
         If nStartCol > nMaxWidth
            Exit
         EndIf

         nJ := If( nI < ::nColPos, nJ + 1, nI )

         oColumn  := aColumns[ nJ ]
         cPicture := oColumn:cPicture
         lBitMap  := oColumn:lBitMap
         lAdjBmp := If( Valtype( oColumn:lAdjBmp ) = Nil, .T., ;
                        oColumn:lAdjBmp )

         hFont    := If( oColumn:oFont == Nil, hBrwFont, oColumn:oFont:hFont )

         If ::cAlias == "ARRAY" .and. ( ::lAppendMode .or. ::nAt > Len( ::aArray ) )
            uData := ""                     // append mode for arrays
         Else
            uData := Eval( oColumn:bData )
         EndIf

         If ::oTree != Nil
            If ValType( uData ) == "N"
               lBitMap := .T.
               lAdjBmp := .F.
            EndIf
         EndIf

         nVertText := 0

         If lBitMap .and. ValType( uData ) == "L"
            lBitMap := .F.
            nVertText := If( uData, 3, 4 )
         EndIf

         Do Case
            Case lBitMap

               If ValType( uData ) == "O"

                  uData := Eval( ::bBitMapH, uData )

               ElseIf Valtype( uData ) == "N" .and. ! Empty( ::aBitMaps )

                  uData := ::aBitMaps[ uData ]

                  If ValType( uData ) == "O"
                     uData := Eval( ::bBitMapH, uData )
                  EndIf

               EndIf

            Case cPicture == Nil
               uData := If( Valtype( uData ) != "C", cValToChar( uData ), ;
                           uData )

            OtherWise
               uData := Transform( uData, cPicture )

         EndCase

         nAlign := If( ValType( oColumn:nAlign ) == "B", ;
                         Eval( oColumn:nAlign ), oColumn:nAlign )

         If ( nClrFore := oColumn:nClrFore ) == Nil .or. lSelected
            nClrFore := If( ! lSelected, nClrText, ::nClrSeleFore )
         EndIf

         nClrFore := If( Valtype( nClrFore ) == "B", ;
                         Eval( nClrFore, ::nAt, nJ, Self ), nClrFore )

         If ( nClrBack := oColumn:nClrBack ) == Nil .or. lSelected
            nClrBack := If( ! lSelected, nClrPane, ::nClrSeleBack )
         EndIf

         nClrBack := If( Valtype( nClrBack ) == "B", ;
                         Eval( nClrBack, ::nAt, nJ, Self ), nClrBack )

         lBrush := Valtype( nClrBack ) == "O"

         If ( lDegrad := ValType( nClrBack ) == "A" )
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", ;
                            Eval( nClrBack ), nClrBack )
         EndIf

         lAdjBmp := If( ! lBitMap, .F., lAdjBmp )
         lMultiLine := Valtype( uData ) == "C" .and. At( Chr( 13 ), uData ) > 0

         If oColumn:l3DTextCell != Nil
            l3DText := oColumn:l3DTextCell
            nClr3dL := oColumn:nClr3DLCell
            nClr3dS := oColumn:nClr3DSCell
            nClr3dL := If( ValType( nClr3dL ) == "B", ;
                           Eval( nClr3dL, ::nAt, nJ ), nClr3dL )
            nClr3dS := If( ValType( nClr3dS ) == "B", ;
                           Eval( nClr3dS, ::nAt, nJ ), nClr3dS )
         Else
            l3DText := nClr3dL := nClr3dS := Nil
         EndIf

         TSDrawCell(                    hWnd, ; // 1
                                         hDC, ; // 2
                                        xRow, ; // 3
                                  nStartCol , ; // 4
                             aColSizes[ nJ ], ; // 5
                                       uData, ; // 6
                                     nAlign , ; // 7
                                    nClrFore, ; // 8
                                    nClrBack, ; // 9
                                       hFont, ; // 10
                         If( lBitMap, 1, 0 ), ; // 11 hBitmap
                                 nHeightCell, ; // 12
                             oColumn:l3DLook, ; // 13
                                  nLineStyle, ; // 14
                                    nClrLine, ; // 15
                                           0, ; // 16 header/footer/super
                                 nHeightHead, ; // 17
                                 nHeightFoot, ; // 18
                                nHeightSuper, ; // 19
                                     lAdjBmp, ; // 20
                                  lMultiline, ; // 21
                                     nVAlign, ; // 22
                                   nVertText, ; // 23
                                      nClrTo, ; // 24
                                     lDegrad, ; // 25
            If( lBrush, nClrBack:hBrush, 0 ), ; // 26
                                    l3DText, ;  // 27  3D text
                                    nClr3dL, ;  // 28  3D text light color
                                    nClr3dS )   // 29  3D text shadow color
         nStartCol += aColSizes[nJ]
      Next
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:DrawSelect() Version 6.0 Apr/5/2002
* ============================================================================

METHOD DrawSelect() CLASS TSBrowse

   Local nI, nJ, nBegin, nStartCol, oColumn, nLastCol, lBitMap, hFont, nAlign, ;
         cPicture, nClrFore, nClrBack, lNoLite, uData, l3DLook, lMultiLine, ;
         nClrTo, lDegrad, lBrush, ;
         nVertText  := 0, ;
         lAdjBmp    := .F., ;
         lSelected  := .F., ;
         nMaxWidth  := ::nWidth(),;     // use local copies for speed
         nRowPos    := ::nRowPos,;
         aColSizes  := AClone( ::aColSizes ), ;
         aColumns   := AClone( ::aColumns ), ;
         hWnd       := ::hWnd, ;
         hDC        := ::hDc, ;
         lFocused   := ::lFocused, ;
         hBrwFont   := ::oFont:hFont, ;
         nVAlign    := 1

   Local l3DText, nClr3dL, nClr3dS

   Local nClrText     := ::nClrText, ;
         nClrPane     := ::nClrPane, ;
         nClrFocuFore := ::nClrFocuFore, ;
         nClrFocuBack := ::nClrFocuBack, ;
         lGridLine    := ::lGridLine, ;
         nClrLine     := ::nClrLine, ;
         nLineStyle   := ::nLineStyle, ;
         nClrSeleBack := ::nClrSeleBack, ;
         nClrSeleFore := ::nClrSeleFore, ;
         nHeightCell  := ::nHeightCell, ;
         nHeightHead := If( ::lDrawHeaders, ::nHeightHead, 0 ), ;
         nHeightFoot := If( ::lDrawFooters != Nil .and. ::lDrawFooters, ;
                            ::nHeightFoot, 0 ), ;
         nHeightSuper := If( ::lDrawHeaders, ::nHeightSuper, 0 )

   lSelected := ::lCanSelect .and. ( AScan( ::aSelected, ;
                If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt ) ) ) > 0

   If ( ::lNoLiteBar .or. ( ::lNoGrayBar .and. ! ::lFocused ) )
      ::DrawLine()   // don't want no hilited cursor bar of any color
   ElseIf ::nLen > 0

      nClrBack := If( ::nPhantom = -1, ATail( aColumns ):nClrBack, nClrPane )
      nClrBack := If( ValType( nClrBack ) == "B", ;
                      Eval( nClrBack, ::nAt, Len( aColumns ), Self ), nClrBack )

      // "Phantom" column; :nPhantom hidden IVar
      AAdd( aColumns, TSColumn():New(  "", ; // cHeading
                                 {|| "" }, ; // bdata
                                      nil, ; // cPicture
                   { nClrText, nClrBack }, ; // aColors
                                      nil, ; // aAlign
                               ::nPhantom, ; // nWidth
                                      nil, ; // lBitMap
                                      nil, ; // lEdit
                                      nil, ; // bValid
                                      .T., ; // lNoLite
                                      nil, ; // cOrder
                                      nil, ; // cFooting
                                      nil, ; // bPrevEdit
                                      nil, ; // bPostEdit
                                      nil, ; // nEditMove
                                      nil, ; // lFixLite
                              {::l3DLook} ) )

      AAdd( aColSizes, ::nPhantom )

      nJ := nStartCol := 0
      nLastCol := Len( aColumns )
      nBegin := Min( If( ::nColPos <= ::nFreeze, ( ::nColPos := ::nFreeze + 1, ;
                  ::nColPos - ::nFreeze ),::nColPos - ::nFreeze ), nLastCol )

      For nI := nBegin To nLastCol
         If nStartCol > nMaxWidth
            Exit
         EndIf

         nJ := If( nI < ::nColPos, nJ + 1, nI )
         oColumn := aColumns[ nJ ]

         hFont    := If( oColumn:oFont == Nil, hBrwFont, oColumn:oFont:hFont )

         If nJ == 1 .and. ! Empty( ::hBmpCursor )
            uData   := ::hBmpCursor
            lBitMap := .T.
            lNoLite := .T.
            lAdjBmp := .F.
         Else
            If ::cAlias == "ARRAY" .and. ( ::lAppendMode .or. ::nAt > Len( ::aArray ) )
               uData := ""                         // append mode for arrays
            Else
               uData := Eval( oColumn:bData )
            EndIf

            cPicture := oColumn:cPicture
            lBitMap  := oColumn:lBitMap
            lAdjBmp := If( Valtype( oColumn:lAdjBmp ) = Nil, .T., ;
                           oColumn:lAdjBmp )

            lNoLite  := oColumn:lNoLite

            If ::oTree != Nil
               If ValType( uData ) == "N"
                  lBitMap := lNoLite := .T.
                  lAdjBmp := .F.
               EndIf
            EndIf

            nVertText := 0

            If lBitMap .and. ValType( uData ) == "L"
               lBitMap := .F.
               nVertText := If( uData, 3, 4 )
            EndIf

            Do Case
               Case lBitMap
                  If ValType( uData ) == "O"

                     uData := Eval( ::bBitMapH, uData )

                  ElseIf Valtype( uData ) == "N" .and. ! Empty( ::aBitMaps )

                     uData := ::aBitMaps[ uData ]

                     If ValType( uData ) == "O"
                        uData := Eval( ::bBitMapH, uData )
                     EndIf

                  EndIf

               Case cPicture == Nil
                  uData := If( Valtype( uData ) != "C", cValToChar( uData ), ;
                               uData )

               OtherWise
                  uData := Transform( uData, cPicture )

            EndCase

         EndIf

         nAlign := If( ValType( oColumn:nAlign ) == "B", ;
                       Eval( oColumn:nAlign ), oColumn:nAlign )

         If lNoLite
            If ( nClrFore := oColumn:nClrFore ) == Nil
               nClrFore := nClrText
            EndIf

            nClrFore := If( Valtype( nClrFore ) == "B", ;
                            Eval( nClrFore, ::nAt, nJ, Self ), nClrFore )

            If ( nClrBack := oColumn:nClrBack ) == Nil
               nClrBack := nClrPane
            EndIf

            nClrBack := If( Valtype( nClrBack ) == "B", ;
                            Eval( nClrBack, ::nAt, nJ, Self ), nClrBack )

         Else
            If ( nClrFore := If( lFocused, oColumn:nClrFocuFore, ;
                 oColumn:nClrSeleFore ) ) == Nil
                 nClrFore := If( lFocused, nClrFocuFore, nClrSeleFore )
            EndIf

            nClrFore := If( Valtype( nClrFore ) == "B", ;
                            Eval( nClrFore, ::nAt, nJ, Self ), nClrFore )

            If ( nClrBack := If( lFocused, oColumn:nClrFocuBack, ;
                 oColumn:nClrSeleBack ) ) == Nil
                 nClrBack := If( lFocused, nClrFocuBack, nClrSeleBack )
            EndIf

            nClrBack := If( Valtype( nClrBack ) == "B", ;
                            Eval( nClrBack, ::nAt, nJ, Self ), nClrBack )

         EndIf

         lBrush := Valtype( nClrBack ) == "O"

         If ( lDegrad := ValType( nClrBack ) == "A" )
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", ;
                            Eval( nClrBack ), nClrBack )
         EndIf

         If ( l3DLook := oColumn:l3DLook ) == Nil
            l3DLook := ::l3DLook
         EndIf

         lAdjBmp  := If( lBitMap, lAdjBmp, ;
                     If( ::lCellBrw .and. nJ == ::nCell, .T., ;
                     If( ! ::lCellBrw .and. nJ < nLastCol, .T., .F. ) ) )

         lMultiLine := Valtype( uData ) == "C" .and. At( Chr( 13 ), uData ) > 0

         If oColumn:l3DTextCell != Nil // .and. ::lCellBrw .and. nJ != ::nCell )
            l3DText := oColumn:l3DTextCell
            nClr3dL := oColumn:nClr3DLCell
            nClr3dS := oColumn:nClr3DSCell
            nClr3dL := If( ValType( nClr3dL ) == "B", ;
                           Eval( nClr3dL, ::nAt, nJ ), nClr3dL )
            nClr3dS := If( ValType( nClr3dS ) == "B", ;
                           Eval( nClr3dS, ::nAt, nJ ), nClr3dS )
         Else
            l3DText := nClr3dL := nClr3dS := Nil
         EndIf

         TSDrawCell(            hWnd, ; //  1
                                 hDC, ; //  2
                             nRowPos, ; //  3
                           nStartCol, ; //  4
                     aColSizes[ nJ ], ; //  5
                               uData, ; //  6
                              nAlign, ; //  7
                            nClrFore, ; //  8
                            nClrBack, ; //  9
                               hFont, ; // 10
                 If( lBitMap, 1, 0 ), ; // 11
                         nHeightCell, ; // 12
                             l3DLook, ; // 13
                          nLineStyle, ; // 14
                            nClrLine, ; // 15
                                   0, ; // 16 Header/Footer/Super
                         nHeightHead, ; // 17
                         nHeightFoot, ; // 18
                        nHeightSuper, ; // 19
                             lAdjBmp, ; // 20
                          lMultiLine, ; // 21
                             nVAlign, ; // 22
                           nVertText, ; // 23
                              nClrTo, ; // 24
                            lDegrad, ;  // 25
                         If( lBrush, ;
               nClrBack:hBrush, 0 ), ;  // 26
                            l3DText, ;  // 27  3D text
                            nClr3dL, ;  // 28  3D text light color
                            nClr3dS )   // 29  3D text shadow color

         nStartCol += aColSizes[ nJ ]
      Next
   EndIf

   If ::bOnDraw != Nil
      Eval( ::bOnDraw )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:DrawSuper() Version 6.0 Apr/5/2002
* ============================================================================

METHOD DrawSuper() CLASS TSBrowse

   Local nI, nJ, nBegin, nStartCol, l3DLook, nClrFore, lAdjBmp, nClrTo, ;
         nClrBack, hFont, cHeading, lBitMap, nLastCol, lMultiLine, lDegrad, ;
         nHAlign, nVAlign, nWidth, nS, nLineStyle, lTransp, lBrush, ;
         nMaxWidth    := ::nWidth() , ;
         aColSizes    := AClone( ::aColSizes ), ;   // use local copies for speed
         aColumns     := AClone( ::aColumns ), ;
         aSuperHead   := AClone( ::aSuperHead ), ;
         nHeightHead  := ::nHeightHead, ;
         nHeightFoot  := ::nHeightFoot, ;
         nHeightSuper := ::nHeightSuper

   Local hWnd         := ::hWnd, ;
         hDC          := ::hDc, ;
         nClrText     := ::nClrText, ;
         nClrPane     := ::nClrPane, ;
         nClrLine     := ::nClrLine

   Local l3DText, nClr3dL, nClr3dS

   If Empty( aColumns )
       Return Nil
   EndIf

   nLastCol := Len( aColumns )

   nClrText   := aSuperHead[ 1, 4 ]
   nClrBack   := aSuperHead[ 1, 5 ]
   l3DLook    := aSuperHead[ 1, 6 ]
   hFont      := aSuperHead[ 1, 7 ]
   nLineStyle := aSuperHead[ 1, 10 ]
   nClrLine   := aSuperHead[ 1, 11 ]

   nBegin := nI := 1

   While nI <= Len( aSuperHead )

      If aSuperHead[ nI, 1 ] > nBegin
         nJ := aSuperHead[ nI, 1 ] - 1
         ASize( aSuperHead, Len( aSuperHead ) + 1 )
         AIns( aSuperHead, nI )
         aSuperHead[ nI ] := { nBegin, nJ, "", nClrText, nClrBack, ;
                               l3DLook , hFont, .F., .F., nLineStyle, ;
                               nClrLine, 1, 1, .F. }
         nBegin := nJ + 1
      Else
         nBegin := aSuperHead[ nI++, 2 ] + 1
      EndIf

   EndDo

   nI := Len( aSuperHead )
   nClrText   := aSuperHead[ nI, 4 ]
   nClrBack   := aSuperHead[ nI, 5 ]
   l3DLook    := aSuperHead[ nI, 6 ]
   hFont      := aSuperHead[ nI, 7 ]
   nLineStyle := aSuperHead[ nI, 10 ]
   nClrLine   := aSuperHead[ nI, 11 ]


   If ( nI := ATail( aSuperHead )[  2 ] ) < Len( aColumns )
        AAdd( aSuperHead, { nI + 1, Len( aColumns ), "", nClrText, nClrBack, ;
                            l3DLook, hFont, .F., .F., nLineStyle, ;
                            nClrLine, 1, 1, .F. } )
   EndIf

   nStartCol := nWidth := 0

   nBegin := If( ::nColPos == ::nFreeze + 1, ::nColPos - ::nFreeze, ::nColPos )

   For nS := 1 To Len( aSuperHead )

      If nBegin >= aSuperHead[ nS, 1 ] .and. nBegin <= aSuperHead[ nS, 2 ]
         Do Case
            Case nBegin > aSuperHead[ nS, 1 ] .and. nS == 1
               For nJ := aSuperHead[ nS, 1 ] To nBegin - 1
                  nStartCol -= ::aColSizes[ nJ ]
               Next

               For nJ := aSuperHead[ nS, 1 ]  To aSuperHead[ nS, 2 ]
                  nWidth += aColSizes[ nJ ]
               Next

            Case nBegin > aSuperHead[ nS, 1 ] .and. nS > 1
               For nJ := 1 To ::nFreeze
                  nStartCol += ::aColSizes[ nJ ]
               Next

               For nJ := nBegin  To aSuperHead[ nS, 2 ]
                   nWidth += aColSizes[ nJ ]
               Next

            OtherWise
               If nBegin > 1
                  For nJ := 1 To ::nFreeze
                     nStartCol += ::aColSizes[ nJ ]
                  Next
               EndIf

               For nJ := aSuperHead[ nS, 1 ]  To aSuperHead[ nS, 2 ]
                  nWidth += aColSizes[ nJ ]
               Next

         EndCase

         Exit

      EndIf

   Next

   For nI := nS To Len( aSuperHead ) + 1

      If nStartCol > nMaxWidth
         Exit
      EndIf

      If nI <= Len( aSuperHead )
         nClrFore := If( ValType( aSuperHead[ nI, 4 ] ) == "B", ;
                         Eval( aSuperHead[ nI, 4 ] ), aSuperHead[ nI, 4 ] )
         nClrBack := If( ValType( aSuperHead[ nI, 5 ] ) == "B", ;
                         Eval( aSuperHead[ nI, 5 ] ), aSuperHead[ nI, 5 ] )

         lBrush := Valtype( nClrBack ) == "O"

         If ( lDegrad := ValType( nClrBack ) == "A" )
            nClrTo   := nClrBack[ 2 ]
            nClrBack := nClrBack[ 1 ]
            nClrTo := If( ValType( nClrTo ) == "B", Eval( nClrTo ), nClrTo )
            nClrBack := If( ValType( nClrBack ) == "B", ;
                            Eval( nClrBack ), nClrBack )
         EndIf

         cHeading := aSuperHead[ nI, 3 ]

         cHeading := If( Valtype( cHeading ) == "B", Eval( cHeading ), cHeading )

         lMultiLine := Valtype( cHeading ) == "C" .and. At( Chr( 13 ), cHeading ) > 0

         l3DLook    := aSuperHead[ nI, 6 ]
         hFont      := aSuperHead[ nI, 7 ]
         lBitMap    := aSuperHead[ nI, 8 ]
         lAdjBmp    := aSuperHead[ nI, 9 ]
         nLineStyle := aSuperHead[ nI, 10 ]
         nClrLine   := aSuperHead[ nI, 11 ]
         nHAlign    := aSuperHead[ nI, 12 ]
         nVAlign    := aSuperHead[ nI, 13 ]
         lTransp    := If( lBitMap, If( aSuperHead[ nI, 14 ], 1, 2 ), 0 )
      Else
         cHeading := ""
         nWidth   := ::nPhantom
         lBitmap  := .F.
         lTransp  := 0
         nClrBack := If( ::nPhantom == -2, nClrPane, nClrBack )
      EndIf

      If ::aColumns[ aSuperHead[ nI, 1 ] ]:l3DTextHead != Nil
         l3DText := ::aColumns[ aSuperHead[ nI, 1 ] ]:l3DTextHead
         nClr3dL := ::aColumns[ aSuperHead[ nI, 1 ] ]:nClr3DLHead
         nClr3dS := ::aColumns[ aSuperHead[ nI, 1 ] ]:nClr3DSHead
         nClr3dL := If( ValType( nClr3dL ) == "B", ;
                        Eval( nClr3dL, 0, nStartCol ), nClr3dL )
         nClr3dS := If( ValType( nClr3dS ) == "B", ;
                        Eval( nClr3dS, 0, nStartCol ), nClr3dS )
      Else
         l3DText := nClr3dL := nClr3dS := Nil
      EndIf

      TSDrawCell(      hWnd, ;  // 1
                        hDC, ;  // 2
                          0, ;  // 3
                  nStartCol, ;  // 4
                     nWidth, ;  // 5
                   cHeading, ;  // 6
                    nHAlign, ;  // 7
                   nClrFore, ;  // 8
                   nClrBack, ;  // 9
                      hFont, ;  // 10
                    lTransp, ;  // 11 0 = No Bitmap 1 = Transparent 2 = Opaque
                nHeightHead, ;  // 12
                    l3DLook, ;  // 13
                 nLineStyle, ;  // 14
                   nClrLine, ;  // 15
                          3, ;  // 16 1=Header 2=Footer 3=Super
                nHeightHead, ;  // 17
                nHeightFoot, ;  // 18
               nHeightSuper, ;  // 19
                    lAdjBmp, ;  // 20
                 lMulTiLine, ;  // 21
                    nVAlign, ;  // 22
                          0, ;  // 23 nVertLine
                     nClrTo, ;  // 24
                    lDegrad, ;  // 25
                 If( lBrush, ;
       nClrBack:hBrush, 0 ), ;  // 26
                    l3DText, ;  // 27  3D text
                    nClr3dL, ;  // 28  3D text light color
                    nClr3dS )   // 29  3D text shadow color

      nStartCol += nWidth

      nWidth := 0
      If nI < Len( aSuperHead )
         For nJ := aSuperHead[ nI + 1, 1 ] To aSuperHead[ nI + 1, 2 ]
            nWidth += aColSizes[ nJ ]
         Next
      EndIf

   Next

Return Nil

* ============================================================================
* METHOD TSBrowse:EditExit() Version 6.0 Apr/5/2002
* ============================================================================

METHOD EditExit( nKey, oGet, uVar, bValid, nCombo ) CLASS TSBrowse

   Local uTemp, xTemp, aList

   Default nCombo := 0

   If oEdit == Nil .or. ! ::lEditing
      ::lEditing := .F.
      ::oWnd:nLastKey := VK_ESCAPE
      ::SetFocus()
      Return .T.
   Endif

   If nCombo == 0
      If ! ( nKey == VK_RETURN .or. nKey == VK_DOWN .or. nKey == VK_UP .or. ;
             nKey == VK_ESCAPE .or. nKey == VK_TAB .or. ;
             ( nKey == VK_RIGHT .and. oGet:lRightLeftExit ) .or. ;
             ( nKey == VK_LEFT .and. oGet:lRightLeftExit ) )

         Return .F.

      EndIf

      If ( ( nKey == VK_UP .and. ::lAppendMode ) .or. ;
           ( nKey == VK_DOWN .and. ::lAppendMode ) ) .and. ;
           Empty( oGet:Value() ) .or. nKey == VK_ESCAPE
         // you can actually append a blank record only with enter key

         ::oWnd:nLastKey := VK_ESCAPE
         ::lChanged := .F.
         ::oGet := uVar
         oEdit:Hide()
         oEdit:End()
         ::SetFocus()

         If ::lAppendMode
            ::GoBottom()
            If ::nRowCount() > ::nLen
               ::Refresh( .T. )
            EndIf
         EndIf

         Return .T.

      ElseIf nKey == VK_UP .or. nKey == VK_DOWN .or. nKey == VK_RETURN .or. ;
             ( ( nKey == VK_RIGHT .or. nKey == VK_LEFT ) .and. ;
               oGet:lRightLeftExit )

         ::lChanged := oGet:Value() != uVar
         ::lHasChanged := If( ::lChanged, .T., ::lHasChanged )
         ::oGet := oGet:Value()
         oEdit:Hide()
         oEdit:End()
         ::SetFocus()
         ::oWnd:nLastKey := nKey
         ::PostEdit( ::oGet, ::nCell, bValid )
         Return .T.

      EndIf
   ElseIf nCombo == 1

      If nKey == Nil
         Return .T.

      ElseIf nKey == VK_RETURN .or. nKey == VK_TAB

         ::oWnd:nLastKey := VK_RETURN
         uTemp := oGet:aItems[ oGet:nAt ]
         aList := ::aColumns[ ::nCell ]:aList

         If ValType( aList[ 1 ] ) == "A"
            uTemp := aList[ 2, AScan( aList[ 1 ], uTemp ) ]
         Else
            If ValType( uVar ) == "N"
               uTemp := AScan( aList, uTemp )
            ElseIf ValType( uVar ) == "L"
               uTemp := Upper( uTemp ) $ "SIYES"
            Else
               uTemp := Substr( uTemp, 1, Len( uVar) )
            EndIf
         EndIf

         ::lChanged := uTemp != uVar
         ::lHasChanged := If( ::lChanged, .T., ::LHasChanged )
         ::oGet := uTemp
         oGet:oWnd:Hide()
         oGet:oWnd:End()
         ::oWnd:nLastKey := nKey
         ::PostEdit( ::oGet, ::nCell, bValid )
         Return .T.

      ElseIf nKey == VK_ESCAPE // .or. nKey == 0
         oEdit:Hide()
         oEdit:End()
         ::SetFocus()
         Return .T.
      Else
         oGet:SetFocus()
         Return .T.
      EndIf

   Else
      uTemp := oGet:oGet:Value()

      If nKey == VK_RETURN .or. nKey == VK_TAB
         uTemp := uTemp $ "SiYes"
         ::lChanged := uTemp != uVar
         ::lHasChanged := If( ::lChanged, .T., ::LHasChanged )
         ::oGet := uTemp
      ElseIf nKey == VK_ESCAPE
         ::oWnd:nLastKey := VK_ESCAPE
         ::oGet := uVar
         Return .T.
      Else
         Return .F.
      EndIf

   EndIf

Return .F.

* ============================================================================
* METHOD TSBrowse:FreezeCol() Version 6.0 Apr/5/2002
* ============================================================================

METHOD FreezeCol( lNext ) CLASS TSBrowse

   Local nFreeze := ::nFreeze

   Default lNext := .T.

	If lNext                                      // freeze next available column
		::nFreeze := Min( nFreeze + 1, Len( ::aColumns ) )
	Else                                          // unfreeze previous column
		::nFreeze := Max( nFreeze - 1, 0 )
   EndIf

   If ::nFreeze != nFreeze                        // only update if necessary
      If( ! lNext, ::PanHome(), Nil )
		::HiliteCell( ::nFreeze + 1 )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GetColumn() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GetColumn( nCol ) CLASS TSBrowse

	Default nCol := 1

	If nCol < 1
		nCol := 1
   ElseIf nCol > Len( ::aColumns )
		nCol := Len( ::aColumns )
   EndIf

Return ::aColumns[ nCol ]                       // returns a Column object

* ============================================================================
* METHOD TSBrowse:GetDlgCode() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GetDlgCode( nLastKey ) CLASS TSBrowse

   // This method is very similar to TControl:GetDlgCode() but it is
   // necessary to have WHEN working

   If ! ::oWnd:lValidating
      If nLastKey == VK_UP .or. nLastKey == VK_DOWN ;
         .or. nLastKey == VK_RETURN .or. nLastKey == VK_TAB
         ::oWnd:nLastKey := nLastKey
      Else
         ::oWnd:nLastKey := 0
      EndIf
   EndIf

Return If( IsWindowEnabled( ::hWnd ) .and. nLastKey != VK_ESCAPE, ;
           DLGC_WANTALLKEYS, 0 )

* ============================================================================
* METHOD TSBrowse:GoBottom() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GoBottom() CLASS TSBrowse

   Local nSkipped, n, nLen, ;
         nLines := ::nRowCount()

   ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                 Eval( ::bLogicLen ) )

   If ::nLen < 1
      Return Self
   EndIf

   ::lAppendMode := .F.
	::ResetSeek()

   If ! ::lHitBottom
      Eval( ::bGoBottom )
      ::lHitBottom := .T.
      ::lHitTop    := .F.
      ::nRowPos := Min( nLines, ::nLen )

      #ifdef __HARBOUR__
         If ::cDriver == "ADS"
            ::nAt := ::nLogicPos()
         Else
            ::nAt := ::nLen
         EndIf
      #else
         ::nAt := ::nLogicPos()
      #endif

      If ::bChange != Nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )
      EndIf

      If ::oVScroll != Nil
         ::oVScroll:SetPos( ::oVScroll:nMax )
      EndIf

//      ::HiliteCell( ::nCell )
      ::Refresh( ::nLen < nLines )

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GoDown() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GoDown() CLASS TSBrowse

   Local nSkipped, nFirst, ;
         nLines    := ::nRowCount(), ;
         lRePaint  := .F., ;
         lEditable := .F.

   If ::nLen < 1       // for empty dbfs or arrays
		If ::lCanAppend
			::nRowPos := 1
		Else
      	Return Self
      EndIf
   EndIf

   ::ResetSeek()

   If ::cAlias == "TEXT_" .and. ::nLen <= nLines .and. ::lNoLiteBar
      Return Self
   EndIf

   If ::cAlias == "TEXT_" .and. ::lNoLiteBar
      ::nRowPos := nLines
   EndIf

   AEval( ::aColumns, { |o,n| If( ::lCanAppend .and. o:lEdit, lEditable := .T., Nil ) } )

   If ! ::lAppendMOde
      ::nPrevRec := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )
   EndIf

   If ! ::lHitBottom
      If ! ::lAppendMode .and. ::cAlias != "TEXT_"
         ::DrawLine()
      EndIf

      If ::Skip( 1 ) == 1
         ::lHitTop := .F.

         If ::nRowPos < nLines
            ::nRowPos++
         Else
            If ::lPageMode
               lRePaint := If( ( ::nLogicPos + nLines - 1 ) > ::nLen, .T., .F. )
               ::nRowPos := 1
               ::Refresh( lRePaint )
            Else
               ::nRowPos := nLines
               ::lRePaint := .F.
               ::TSBrwScroll( 1 )
            EndIf
         EndIf

      Else
         ::lHitBottom := .T.
      EndIf

      If ! ::lAppendMode .and. ! ::lEditing
         ::DrawSelect()
      EndIf

      If ::oVScroll != Nil .and. ! ::lAppendMode
         ::oVScroll:SetPos( ::nLogicPos() )
      EndIf

      If ::bChange != nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )
      EndIf
   EndIf

   If ::lCanAppend .and. lEditable .and. ::lHitBottom .and. ! ::lAppendMode

      nFirst := 0
      Aeval( ::aColumns, { | oCol, nCol | ;
                           nFirst := If( oCol:lEdit .and. ;
                                     ( oCol:bWhen == Nil .or. ;
                                     Eval( oCol:bWhen ) ) .and. nFirst == 0, ;
                                     nCol, nFirst ) } )

      If ! ::nCell == nFirst .and. ! ::IsColVisible( nFirst )
         While ! ::IsColVisible( nFirst )
            ::nColPos += If( nFirst < ::nCell, -1, 1 )
         EndDo
         ::Refresh( .F. )
      EndIf

      ::lHitTop := ::lHitBottom := .F.
      ::nCell := nFirst
      ::DrawLine()
      ::lAppendMode := .T.
      ::GoDown()                // recursive call to force entry to itself
      ::oWnd:nLastKey := VK_RETURN
      ::DrawLine()
      ::PostMsg( WM_KEYDOWN, VK_RETURN, nMakeLong( 0, 0 ) )

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GoEnd() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GoEnd() CLASS TSBrowse

   Local nTxtWid, nI, nLastCol, nBegin, ;
         nWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ),;
         nWide := 0,;
         nCols := Len( ::aColumns ),;
         nPos := ::nColPos

	If ::cAlias == "TEXT_"
      nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::oFont != Nil, ::oFont:hFont, 0 ) ) )

      If ::nAt < ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
			::nAt := ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
         ::Refresh( .F. )
         If ::oHScroll != Nil
				::oHScroll:SetPos( ::nAt )
         EndIf
      EndIf

      Return Self
   EndIf

   nLastCol := Len( ::aColumns )
   nBegin := Min( If( ::nColPos <= ::nFreeze, ( ::nColPos := ::nFreeze + 1,;
                  ::nColPos - ::nFreeze ), ::nColPos - ::nFreeze ), nLastCol )

   nWide := 0

   For nI := nBegin To nPos
       nWide += ::aColSizes[ nI ]
   Next

   nBegin := ::nCell

   For nI := nPos + 1 To nCols
      If nWide + ::aColSizes[ nI ] <= nWidth    // only if column if fully visible
         nWide += ::aColSizes[ nI ]
         ::nCell := nI
		Else
			Exit
      EndIf
	Next

   If nBegin == ::nCell
      Return Self
   EndIf

   ::Refresh( .F. )

   If ::oHScroll != Nil
		::oHScroll:SetPos( ::nCell )
   EndIf

	::HiliteCell( ::nCell )

Return Self

* ============================================================================
* METHOD TSBrowse:GoHome() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GoHome() CLASS TSBrowse

   Local nCellAnt := ::nCell

   If ::cAlias == "TEXT_"
		If ::nAt > 1
			::nAt := 1
         ::Refresh( .F. )
         If ::oHScroll != Nil
				::oHScroll:SetPos( ::nAt )
         EndIf
      EndIf
		Return Self
   EndIf

	::nCell := ::nColPos

   If ::nCell == nCellAnt
      Return Self
   EndIf

   ::Refresh( .F. )

   If ::oHScroll != Nil
		::oHScroll:SetPos( ::nCell )
   EndIf

	::HiliteCell( ::nCell )

Return Self

* ============================================================================
* METHOD TSBrowse:GoLeft() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GoLeft()  CLASS TSBrowse

   Local nCell, nSkip

   If ::cAlias == "TEXT_"
      If ::nOffset > 5
         ::nOffset -= 5
      Else
         ::nOffset := 1
      EndIf
      ::Refresh( .F. )

      If ::oHScroll != Nil
         ::oHScroll:SetPos( ::nOffset )
      EndIf
      Return Self
   EndIf

   ::ResetSeek()

   If ::lCellBrw
      nCell := ::nCell
      nSkip := 0
      While nCell > 0
         nCell --
         nSkip ++
         If nCell > 0 .and. ! ::aColumns[ nCell ]:lNoHilite
            Exit
         EndIf
      EndDo

      If nCell = 0
         Return Self
      EndIf

      While nSkip > 0
         ::nCell --
         nSkip --
      EndDo

      If ::nCell < ::nColPos .and. ::nCell > ::nFreeze
         ::nColPos := ::nCell
         ::Refresh( .F. )
      EndIf

      If( ::oHScroll != Nil, ::oHScroll:SetPos( ::nCell ), Nil )
      ::HiliteCell( ::nCell )
      ::DrawSelect()

	Else
      If ::nCell > ( ::nFreeze + 1 )
         ::nColPos := ::nCell := ::nFreeze + 1
         ::Refresh( .F. )
         If ::oHScroll != Nil
            ::oHScroll:GoTop()
         EndIf
      EndIf
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GoNext() Version 6.0 Apr/5/2002
* Post-edition cursor movement.  Cursor goes  to next editable cell, right
* or first-down according to the position of the last edited cell.
* This method is activated when the MOVE clause of ADD COLUMN command is
* set to 5 ( DT_MOVE_NEXT )
* ============================================================================

METHOD GoNext() CLASS TSBrowse

   Local nEle, ;
         nFirst := 0

   For nEle := ( ::nCell  + 1 ) To Len( ::aColumns )
      If ::aColumns[ nEle ]:lEdit .and. nEle >= ::nColPos .and. ;
         ( ::aColumns[ nEle ]:bWhen == Nil .or. ;
           Eval( ::aColumns[ nEle ]:bWhen ) )

         nFirst := nEle
         Exit

      EndIf
   Next

   If nFirst > 0

      If ::IsColVisible( nFirst )
         ::nCell := nFirst
         ::HiLiteCell( ::nCell )
         If ! ::lEditing
            ::DrawSelect()
         EndIf
      Else
         While ! ::IsColVisible( nFirst ) .and. ::nColPos < nFirst
            ::nColPos ++
         EndDo
         ::nCell := nFirst
         ::HiliteCell( nFirst )
         ::Refresh( .F. )
      EndIf

      If( ::oHScroll != Nil, ::oHScroll:SetPos( ::nCell ), Nil )

      Return Self

   EndIf

   Aeval( ::aColumns, { | oCol, nCol | ;
                        nFirst := If( oCol:lEdit .and. ( oCol:bWhen == Nil .or. ;
                                  Eval( oCol:bWhen ) ) .and. nFirst = 0, ;
                                  nCol, nFirst ) } )

   If nFirst == 0
      Return Self
   EndIf

   If ::IsColVisible( nFirst )
      ::nCell := nFirst
   Else

      ::nColPos := ::nFreeze + 1
      ::nCell := nFirst

      While ::nColPos < ::nCell .and. ! ::IsColVisible( ::nCell )
         ::nColPos ++
      EndDo

   EndIf

   ::HiliteCell( ::nCell )
   ::Refresh( .F. )
   If( ::oHScroll != Nil, ::oHScroll:SetPos( ::nCell ), Nil )
   SysRefresh()
   ::GoDown()

Return Self

* ============================================================================
* METHOD TSBrowse:GoPos() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GoPos( nNewRow, nNewCol ) CLASS TSBrowse

   Local nOldRow, nI, bTemp, ;
         nOldCol := ::nCell, ;
         lScoped := ::bScope != Nil .and. ! Empty( Eval( ::bScope ) )

   If ValType( nNewRow ) != "N" .or. ValType( nNewCol ) != "N"
      Return( Nil )
   EndIf

   If ::cAlias = "ARRAY"
      nOldRow := ::nAt
   Else
     If ! lScoped
        nOldRow := ::nRowPos
     Else
        nOldRow := ::nLogicPos()
     EndIf
   EndIf

   bTemp := ::bChange

   ::bChange := Nil

   If nOldCol > nNewCol
      For nI := nNewCol To nOldCol -1
         ::GoLeft()
      Next
   Else
      For nI := nOldCol To nNewCol -1
         ::GoRight()
      Next
   EndIf

   If nOldRow > nNewRow
      For nI := nNewRow To nOldRow - 1
         ::GoUp()
         ::oWnd:nLastKey := VK_UP
      Next
   Else
      For nI:= nOldRow To nNewRow - 1
         ::GoDown()
         ::oWnd:nLastKey := VK_DOWN
      Next
   EndIf

   ::bChange := bTemp

   If ::bChange != Nil .and. nNewRow != nOldRow
      Eval( ::bChange, Self, ::oWnd:nLastKey )
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:GoRight() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GoRight() CLASS TSBrowse

   Local nI, nLeftPix, nTxtWid, nWidth, nCell, nSkip, ;
         lRefresh := .F.

   nWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 )

   If ::cAlias == "TEXT_"
      nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::oFont != nil, ::oFont:hFont, 0 ) ) )
      If ::nOffset < ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
         ::nOffset += 5
         ::Refresh( .F. )
         If ::oHScroll != Nil
            ::oHScroll:SetPos( ::nOffset )
         EndIf
      EndIf
		Return Self
   EndIf

   ::ResetSeek()

   If ::lCellBrw
      If ::nCell == Len( ::aColumns ) .and. ;  // avoid undesired displacement  //::GetColSizes()
         ::IsColVisible( ::nCell )
         Return Self
      EndIf

      nCell := ::nCell
      nSkip := 0

      While nCell < Len( ::aColumns )
         nCell ++
         nSkip ++
         If nCell <= Len( ::aColumns ) .and. ! ::aColumns[ nCell ]:lNoHilite
            Exit
         EndIf
      EndDo

      If nCell > Len( ::aColumns )
         Return Self
      EndIf

      While nSkip > 0
         ::nCell ++
         nSkip --
      EndDo

      While ! ::IsColVisible( ::nCell ) .and. ::nColPos < ::nCell
         ::nColPos ++
         lRefresh := .T.
      EndDo

      ::HiliteCell( ::nCell )

      If lRefresh
         ::Refresh( .F. )
      ElseIf ! ::lEditing
         ::DrawSelect()
      EndIf

      If( ::oHScroll != Nil, ::oHScroll:SetPos( ::nCell ), Nil )

   Else

      If ::nCell == Len( ::aColumns ) .and. ;  // avoid undesired displacement  //::GetColSizes()
         ::IsColVisible( ::nCell )
         Return Self
      EndIf

      If ::oHScroll != Nil
         ::HScroll( SB_PAGEDOWN )
      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GotFocus() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GotFocus() CLASS TSBrowse

   If ::oCtx != Nil
      ::oCtx:Restore()
   EndIf

   Super:GotFocus()

   If ::cAlias != "ARRAY" .and. ::cAlias != "TEXT_" .and. ::lPainted .and. ;
      ! ::lFirstFocus .and. ! ::lEditing .and. ! ::lNoResetPos

      If ! ::uLastTag == Nil
         ( ::cAlias )->( Eval( ::bTagOrder, ::uLastTag ) )
      EndIf

      ( ::cAlias )->( DbGoTo( ::nLastPos ) )
      ::nAt := ::nLastnAt

   ElseIf ::cAlias != "ARRAY" .and. ::cAlias != "TEXT_" .and. ::lFirstFocus .and. ;
          ! ::lEditing .and. ! ::lNoResetPos

      ::GoTop()

      If ::lPainted
         ::Refresh()
         If ::nLen == 0
            ::GoDown()
         EndIf
      EndIf

   EndIf

   If ::lPainted
      ::lFirstFocus := .F.
   EndIf

   If ::nLen > 0 .and. ! EmptyAlias( ::cAlias ) .and. ! ::lIconView .and. ! ::lEditing
      ::DrawSelect()
   EndIf

   ::lHasFocus := .T.

Return 0

* ============================================================================
* METHOD TSBrowse:GoTop() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GoTop() CLASS TSBrowse

   ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                 Eval( ::bLogicLen ) )

   If ::nLen < 1
      Return Self
   EndIf

   ::lAppendMode := .F.
	::ResetSeek()

   If ! ::lHitTop
      Eval( ::bGoTop )

      ::lHitBottom := .F.
      ::nRowPos := ::nAt := 1
      ::Refresh( .F. )

      If ::oVScroll != Nil
         ::oVScroll:GoTop()
      EndIf

      If ::bChange != Nil
         Eval( ::bChange, Self, VK_UP )
      EndIf

		::HiliteCell( ::nCell )

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:GoUp() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GoUp() CLASS TSBrowse

   Local nSkipped, ;
         nLines := ::nRowCount()

   If ::nLen < 1
      If ::lCanAppend .and. ::lAppendMode        // append mode being canceled
         ::lAppendMode := ::lHitBottom := .F.
			::nRowPos--                             // for empty dbfs
      Else
      	Return Self
      EndIf
   EndIf

   ::ResetSeek()

   If ::cAlias == "TEXT_" .and. ::nLen <= nLines .and. ::lNoLiteBar
      Return Self
   EndIf

   If ::cAlias == "TEXT_" .and. ::lNoLiteBar
      ::nRowPos := 1
   EndIf

   // When filtering database using NTX and :SetFilter()
	// with params 2 and/or 3, simulate Scoping from CDX RDD
	// With CDX it's not needed as works quite fast
	//
   If ::lAppendMode .and. ::lFilterMode .and. ::nPrevRec != Nil
      ( ::cAlias )->( DbGoTo( ::nPrevRec ) )
   EndIf

   If ! ::lHitTop

      If ! ::lAppendMode
         ::DrawLine()
      EndIf

      If ::Skip( -1 ) == -1

         ::lHitBottom := .F.

         If ::nRowPos > 1

            If ! ::lAppendMode .or. ( ::lAppendMode .and. ::nLen < nLines )
               ::nRowPos--
            EndIf

            If ::lAppendMode
               If ::lFilterMode
                  ::Skip( 1 )
               EndIf
               ::Refresh( If( ::nLen < nLines, .T., .F. ) )
               ::HiliteCell( ::nCell )
            EndIf

         Else
            If ::lPageMode
               ::nRowPos := nLines
               ::Refresh( .F. )
            Else
               ::lRePaint := .F.
               ::TSBrwScroll( -1 )
            EndIf
         EndIf

      ElseIf ! ::lAppendMode
         ::lHitTop := .T.
      EndIf

      ::DrawSelect()

      If ::oVScroll != Nil .and. ! ::lAppendMode
         ::oVScroll:SetPos( ::nLogicPos() )
      EndIf

      If ::bChange != Nil
         Eval( ::bChange, Self, VK_UP )
      EndIf
   EndIf

   ::lAppendMode := .F.                          // turn append mode off
	::nPrevRec := Nil

Return Self

* ==============================================================================
* METHOD TSBrowse:KeyChar()  Version 6.0 Apr/5/2002
* ==============================================================================

METHOD KeyChar( nKey, nFlags )  CLASS TSBrowse

   /* Next lines were added to filter keys according with
      the data type of columns to start editing cells. Also were defined
      two static functions IsChar() and IsNumeric() to do the job */

   Local cComp, lProcess, cTypeCol

   If ::lAppendMode
      Return 0
   EndIf

   cTypeCol := ValType( Eval( ::aColumns[ ::nCell ]:bData ) )

   If Upper( ::aMsg[ 1 ] ) == "SI"
      cComp := "TFSCYN"
   else
      cComp := "TFYN"
   EndIf

   lProcess := IF(( cTypeCol == "C" .or. cTypeCol == "M") .and. ;
                  IsChar( nKey ), .T.,;
               IF(( cTypeCol == "N" .or. cTypeCol == "D") .and. ;
                  IsNumeric( nKey ), .T.,;
               IF( ( cTypeCol == "L" .and. Upper( Chr( nKey ) ) $ cComp ) .or. ;
                   ( cTypeCol == "L" .and. ::aColumns[ ::nCell ]:lBitMap .and. ;
                     nKey == VK_SPACE ), .T., .F. ) ) )

   /* End of added lines */


   If lProcess .and. ::lCellBrw .and. ::aColumns[ ::nCell ]:lEdit  // here we process direct cell editing with keyboard, not just the Enter key !
      ::KeyDown( ::nKeyDown := nKey, ::nKeyFlag := nFlags )
   ElseIf ::lSeek .and. nKey != VK_RETURN               // lSeek just when want
      ::Seek( nKey )                                    // TSBrowse seeking feature
   Else
		Super:KeyChar( nKey, nFlags )
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:KeyDown() Version 6.0 Apr/5/2002
* ============================================================================

METHOD KeyDown( nKey, nFlags ) CLASS TSBrowse

   Local uTemp, aMoveCell, bRecLock, bAddRec, uVal, uReturn, ;
         lEditable := .F., ;
         nFireKey  := ::nFireKey, ;
         nCol      := ::nCell

   Default nFireKey := VK_F2

   ::oWnd:nLastKey := nKey
   ::lFirstFocus := .F.

   If nFlags > 0
      ::lEditing := .F.
   EndIf

   If ::bUserKeys != Nil
      uReturn := Eval( ::bUserKeys, nKey, nFlags, Self )

      If uReturn != Nil .and. ValType( uReturn ) == "N" .and. ;
         uReturn < 200      // it will be interpreted as a virtual key code
         nKey := uReturn    // to change the original key pressed
      ElseIf uReturn != Nil .and. ValType( uReturn ) == "L" .and. ;
             ! uReturn      // it wll be interpreted as you want to inhibit
         ::nKeyDown := 0    // the TSBrowse KeyDown() Method
         Return 0
      EndIf

   EndIf

   AEval( ::aColumns, { |o,n| If( ::lCanAppend .and. o:lEdit, lEditable := .T., Nil ) } )

   Do Case                                       // Maintain Clipper behavior for key navigation
      Case ::lIgnoreKey( nKey, nFlags )          // has to go before any other case statement

           Super:KeyDown( nKey, nFlags )

      Case GetKeyState( VK_CONTROL ) .and. ;     // Ctrl+Shift+key
            GetKeyState( VK_SHIFT )

         If nKey == VK_RIGHT                     // Ctrl+Shift+Right Arrow

            ::aColumns[ nCol ]:nEditMove := DT_MOVE_RIGHT

         ElseIf nKey == VK_DOWN                  // Ctrl+Shift+Down Arrow

            ::aColumns[ nCol ]:nEditMove := DT_MOVE_DOWN

         ElseIf nKey == VK_UP                    // Ctrl+Shift+Up Arrow

            ::aColumns[ nCol ]:nEditMove := DT_MOVE_UP

         ElseIf nKey == VK_LEFT                  // Ctrl+Shift+Left Arrow

            ::aColumns[ nCol ]:nEditMove := DT_MOVE_LEFT

         EndIf

      Case GetKeyState( VK_CONTROL )

         If nKey == VK_HOME                      // Ctrl+Home
			   ::GoTop()
				::PanHome()
         ElseIf nKey == VK_END                   // Ctrl+End
            If ::lHitBottom
               ::PanEnd()
            Else
               ::GoBottom()
            EndIf
         ElseIf nKey == VK_PRIOR                 // Ctrl+PgUp
		      ::GoTop()
         ElseIf nKey == VK_NEXT                  // Ctrl+PgDn
		      ::GoBottom()
         ElseIf nKey == VK_LEFT                  // Ctrl+Left
				::PanLeft()
         ElseIf nKey == VK_RIGHT                 // Ctrl+Right
				::PanRight()
			Else
				Super:KeyDown( nKey, nFlags )
         EndIf

      Case GetKeyState( VK_SHIFT ) .and. ::nKeyDown = 0

         If nKey == VK_HOME                      // Shift+Home
				::PanHome()
         ElseIf nKey == VK_END                   // Shift+End
				::PanEnd()

         ElseIf nKey == VK_DOWN .or. nKey == VK_UP .and. ::lCanSelect
            uVal := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )

            If ( uTemp := AScan( ::aSelected, uVal ) ) > 0
               ADel( ::aSelected, uTemp )
               ASize( ::aSelected, ( Len( ::aSelected ) - 1 ) )
               ::DrawSelect()
               If ::bSelected != Nil
                  Eval( ::bSelected, Self, uVal, .F. )
               EndIf
            Else
               AAdd( ::aSelected, uVal )
               ::DrawSelect()
               If ::bSelected != Nil
                  Eval( ::bSelected, Self, uVal, .T. )
               EndIf
            EndIf

         Else
				Super:KeyDown( nKey, nFlags )
         EndIf

      Case nKey == VK_HOME
			//::GoHome() // J Bott
         ::gotop()
      Case nKey == VK_END
			//::GoEnd() // J Bott
         ::goBottom()
      Case ( ( nKey == VK_RETURN .or. ::nKeyDown != 0 .or. nKey == nFireKey ) .and.;
               ::lCellBrw .and. ::aColumns[ nCol ]:lEdit .and. ;
               ( ::aColumns[ nCol ]:bWhen == Nil .or. ;
               Eval( ::aColumns[ nCol ]:bWhen ) ) ) .or. ;
               ( ::lAppendMode .and. lEditable  ) // VK_F2 to emulate Excel behavior

         If ::nRowPos == 0 .and. ::lCanAppend .and. ::cAlias != "TEXT_" .and. ;
            ::cAlias != "ARRAY" .and. ::oTree == Nil .and. ;
            ( ::cAlias )->( LastRec() ) == 0 .and. ::lDrawHeaders
            ::GoDown()
            Return 0
         EndIf

         ::oWnd:nLastKey := nKey

         If ::aColumns[ nCol ]:bPrevEdit != Nil

            uVal := Eval( ::aColumns[ nCol ]:bPrevEdit  )

            If ValType( uVal ) == "L" .and. ! uVal
               ::nKeyDown := ::nKeyFlag := 0
               Return 0
            EndIf

         EndIf

         If ::lAppendMode .and. ::cAlias == "ARRAY"
            uTemp := If( nCol <= Len( ::aDefValue ), ;
                         ::aDefValue[ nCol ], Space( 10 ) )
         Else
            uTemp := Eval( ::aColumns[ nCol ]:bData )
         EndIf

         If ::aColumns[ nCol ]:bPrevEdit != Nil
            Eval( ::aColumns[ nCol ]:bPrevEdit, uTemp, Self )
         EndIf

         ::lEditCol( uTemp, nCol )

      Case nKey == VK_UP

           ::GoUp()

      Case nKey == VK_DOWN

           ::GoDown()

      Case nKey == VK_LEFT

           ::GoLeft()

      Case nKey == VK_RIGHT

           ::GoRight()

      Case nKey == VK_PRIOR

           ::PageUp()

      Case nKey == VK_NEXT

           ::PageDown()

      Case nKey == VK_DELETE .and. ::lCanDelete

           ::DeleteRow()

      Case nKey == VK_CONTEXT .and. nFlags == 22872065

           ::lFirstFocus := .F.

           If ::bContext != Nil
              Eval( ::bContext, ::nRowPos, ::nColPos, Self )
           EndIf

      Otherwise

           Super:KeyDown( nKey, nFlags )

   EndCase

Return 0

* ============================================================================
* METHOD TSBrowse:LButtonDown() Version 6.0 Apr/5/2002
* ============================================================================

METHOD LButtonDown( nRowPix, nColPix, nKeyFlags ) CLASS TSBrowse

   Local nClickRow, nSkipped, nI, lHeader, nIcon, nAtCol, ;
         nColPixPos := 0, ;
         nColInit := ::nColPos - 1, ;
         lDrawRow := .F., ;
         lDrawCol := .F.

   If ::lDrag
      ::Refresh( .T. )
      Return Super:LButtonDown( nRowPix, nColPix, nKeyFlags )
   EndIf

   If ::nFreeze > 0
      For nI := 1 to ::nFreeze
         nColPixPos += ::GetColSizes()[ nI ]
      Next
   EndIf

   nClickRow := ::nTSBRow( nRowPix )

   lHeader   := nClickRow <= 0 .and. ::lDrawHeaders
   ::lFirstFocus := .F.

   If oEdit != Nil .and. ::lEditing
      oEdit:Hide()
      oEdit:End()
      oEdit := Nil
      ::oWnd:nLastKey := VK_ESCAPE
   Else
      ::oWnd:nLastKey := 0
   EndIf

   ::lEditing := .F.

   If ::oWnd:hCtlFocus != Nil .and. ::oWnd:hCtlFocus != ::hWnd
      SendMessage( ::oWnd:hCtlFocus, WM_KILLFOCUS, ::hWnd )
   EndIf

   ::SetFocus()

   If ::nLen < 1 .or. ::cAlias == "TEXT_"
      If ! ::lCanAppend .or. ::cAlias == "TEXT_"
         Return 0
      ElseIf nClickRow > 0
         ::PostMsg( WM_KEYDOWN, VK_DOWN, nMakeLong( 0, 0 ) )
         Return 0
      EndIf
   EndIf

   If lHeader  .and. Valtype( nKeyFlags ) == "N"
      If ::aActions != Nil .and. ;
         ( nAtCol := ::nAtCol( nColPix ) ) <= Len( ::aActions )
         If ::aActions[ nAtCol ] != nil
            ::DrawHeaders()
            Eval( ::aActions[ nAtCol ], Self, nRowPix, nColPix )
            ::DrawHeaders()
         Else
            // Tone(500,1)
         EndIf
      Else
         // Tone(500,1)
      EndIf
   EndIf

   If ::lIconView
      If ( nIcon := ::nAtIcon( nRowPix, nColPix ) ) != 0
         ::DrawIcon( nIcon )
      EndIf
      Return Nil
   EndIf

   If ::lMChange .and. nClickRow == 0
      If AScan( ::GetColSizes(),;
                { | nColumn | nColPixPos += nColumn,;
                  nColInit++,;
                  nColPix >= nColPixPos - 2 .and. ;
                  nColPix <= nColPixPos + 2 }, ::nColPos ) != 0
         ::lLineDrag := .T.
         ::VertLine( nColPixPos, nColInit, nColPixPos - nColPix )
      Else
         ::lColDrag := .T.
         ::nDragCol := ::nAtCol( nColPix )
      EndIf

      If ! ::lCaptured
         ::lCaptured := .T.
         ::Capture()
      EndIf
   EndIf

   If nClickRow > 0 .and. nClickRow != ::nRowPos .and. ;
                          nClickRow < ::nRowCount() + 1

	   ::ResetSeek()
      ::DrawLine()

      nSkipped  := ::Skip( nClickRow - ::nRowPos )
      ::nRowPos += nSkipped

      If ! ::lNoVScroll
         ::oVScroll:SetPos( ::oVScroll:GetPos() + nSkipped )
      EndIf

      lDrawRow      := .T.
      ::lHitTop     := .F.
      ::lHitBottom  := .F.
      ::lAppendMode := .F.

      If ::bChange != Nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )
      EndIf

   EndIf

   If ::bLClicked != nil
      Eval( ::bLClicked, nRowPix, nColPix, nKeyFlags, Self )
   EndIf

   If nClickRow > 0
      If ! ( ::lLockFreeze .and. ::nAtCol( nColPix, .T. ) <= ::nFreeze )
         lDrawCol := ::HiliteCell( ::nCell, nColPix )
      EndIf

      If ! ::lNoHScroll .and. lDrawCol
         ::oHScroll:SetPos( ::nCell )
      EndIf
   EndIf

   If lDrawRow .or. lDrawCol
      ::DrawSelect()
   EndIf

   ::lGrasp := ! lHeader .and. ! Empty( ::bDragBegin )
   ::lMouseDown := .T.

Return 0

* ============================================================================
* METHOD TSBrowse:LButtonUp() Version 6.0 Apr/5/2002
* ============================================================================

METHOD LButtonUp( nRowPix, nColPix, nFlags ) CLASS TSBrowse

   Local nClickRow, nDestCol

   If ::lDrag
      If ::lColDrag
         ::lDrag := .F.
      Else
         Return Super:LButtonUp( nRowPix, nColPix, nFlags )
      EndIf
   EndIf

   If ::lCaptured

      ::lCaptured := .F.
      ReleaseCapture()

      If ::lLineDrag
        ::lLineDrag := .F.
        ::VertLine()
      Else
         ::lColDrag := .F.
         nClickRow := ::nTSBRow( nRowPix )

         nDestCol := ::nAtCol( nColPix )

         // we gotta be on header row within listbox and not same colm
         If nClickRow == 0 .and. nColPix > ::nLeft .and. ::nDragCol != nDestCol
            If( ::lMoveCols, ::MoveColumn( ::nDragCol, nDestCol ), ;
                ::Exchange( ::nDragCol, nDestCol ) )
         EndIf

      EndIf
   EndIf

   ::lGrasp := .F.

   Super:LButtonUp( nRowPix, nColPix, nFlags )

Return 0

* ============================================================================
* METHOD TSBrowse:LDblClick() Version 6.0 Apr/5/2002
* ============================================================================

METHOD LDblClick( nRowPix, nColPix, nKeyFlags ) CLASS TSBrowse

   Local nCol, uTemp, uVal, ;
         nLines := ::nRowCount(), ;
         nClickRow := ::nTSBRow( nRowPix ), ;
         aMoveCell := { {|| ::GoRight() }, {|| ::GoDown() }, {|| ::goLeft() }, ;
                        {|| ::GoUp() }, {|| ::GoNext() } }, ;
         bRecLock := If( ! Empty( ::bRecLock ), ::bRecLock, ;
                         {|| ( ::cAlias )->( RLock() ) } ), ;
         bAddRec := If( ! Empty( ::bAddRec ), ::bAddRec, ;
                        {|| ( ::cAlias )->( dbAppend() ), ! NetErr() } )

   ::oWnd:nLastKey := 0
   ::lFirstFocus := .F.

   If nClickRow == ::nRowPos

      If ::lCellBrw .and. ::aColumns[ nCol := ::nAtCol( nColPix ) ]:lEdit .and. ;
         ! ::lCanSelect

            If ValType( Eval( ::aColumns[ nCol ]:bData ) ) == "L" .and. ;
               ::aColumns[ nCol ]:lBitMap  // virtual checkbox
               ::KeyDown( ::nKeyDown := VK_SPACE, ::nKeyFlag := 0 )
            Else
               ::oWnd:nLastKey := VK_RETURN
               ::SendMsg( WM_KEYDOWN, VK_RETURN,0 )
            EndIf

            Return 0

      ElseIf ::lCanSelect

         uVal := If( ::lIsDbf, ( ::cAlias )->( RecNo() ), ::nAt )

         If ( uTemp := AScan( ::aSelected, uVal ) ) > 0
            ADel( ::aSelected, uTemp )
            ASize( ::aSelected, ( Len( ::aSelected ) - 1 ) )
            ::DrawSelect()
            If ::bSelected != Nil
               Eval( ::bSelected, Self, uVal, .F. )
            EndIf
         Else
            AAdd( ::aSelected, uVal )
            ::DrawSelect()
            If ::bSelected != Nil
               Eval( ::bSelected, Self, uVal, .T. )
            EndIf
         EndIf

         If ::bLDblClick != nil
            Eval( ::bLDblClick, nRowPix, nColPix, nKeyFlags )
         EndIf

      ElseIf ::bLDblClick != nil
         Eval( ::bLDblClick, nRowPix, nColPix, nKeyFlags )
      EndIf

   ElseIf nClickRow == 0
      ::SetOrder( ::nAtCol( nColPix ) )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:LoadFields() Version 6.0 Apr/5/2002
* ============================================================================

METHOD LoadFields( lEditable ) CLASS TSBrowse

   Local n, cHeading, nAlign, nSize, aColSizes, ;
         aAlign := { "LEFT", "CENTER", "RIGHT", "VERT" }

   Default lEditable := .T.

   aColSizes := If( Len( ::aColumns )  ==  Len( ::aColSizes ), ;
                    Nil, ::aColSizes )

   For n := 1 to ( ::cAlias )->( FCount() )

      cHeading := If( ! ::aHeaders == Nil .and. Len( ::aHeaders ) >= n, ;
                      ::aHeaders[ n ], ;
                      ::Proper( ( ::cAlias )->( Field( n ) ) ) )

      nAlign := If( ! ::aJustify == Nil .and. Len( ::aJustify ) > 0 .and. ;
                    Len( ::aJustify ) >= n, ::aJustify[ n ], ;
                    If( ( ::cAlias )->( ValType( FieldGet( n ) ) ) == "N", 2, ;
                    If( ( ::cAlias )->( ValType( FieldGet( n ) ) ) == "L", ;
                          1, 0 ) ) )

      nAlign := If( ValType( nAlign ) == "L", If( nAlign, 2, 0 ), ;
                If( ValType( nAlign ) == "C", AScan( aAlign, nAlign ) - 1, ;
                    nAlign ) )

      nSize := If( ! aColSizes == Nil .and. Len( aColsizes ) >= n, ;
                     aColSizes[ n ], Nil )

      ADD COLUMN TO Self ;
          DATA  ( FieldSetGetBlock( ::cAlias, n ) ) ;
          TITLE cHeading ;
          SIZE nSize ;
          COLOR ::nClrText, ::nClrPane ;
          ALIGN nAlign ;
          MOVE  If( lEditable, 5, 1 )

      ATail( ::aColumns ):lEdit := lEditable
      ATail( ::aColumns ):cData := ::cAlias + "->" + FieldName( n )

      ATail( ::aColumns ):oFont := ::oFont
      ATail( ::aColumns ):oFontHead := ::oFont
      ATail( ::aColumns ):oFontFoot := ::oFont

   Next

Return Self

* ============================================================================
* METHOD TSBrowse:nAtCol() Version 6.0 Apr/5/2002
* ============================================================================

METHOD nAtCol( nColPixel, lActual ) CLASS TSBrowse

   Local nColumn := ::nColPos - 1, ;
         aSizes  := ::GetColSizes(), ;
         nI := 0, ;
         nPos := 0

   DEFAULT lActual := .F.

   If ::nFreeze > 0
      If lActual
         nColumn := 0
      Else
         For nI := 1 to ::nFreeze
            nPos += aSizes[nI]
         Next
      EndIf
   EndIf

   While nPos < nColPixel .and. nColumn < Len( aSizes )
      nPos += aSizes[ nColumn + 1 ]
      nColumn++
   Enddo

Return nColumn

* ============================================================================
* METHOD TSBrowse:nAtIcon() Version 6.0 Apr/5/2002
* ============================================================================

METHOD nAtIcon( nRow, nCol ) CLASS TSBrowse

   Local nIconsByRow := Int( ::nWidth() / 50 )

   nRow -= 9
   nCol -= 1

   If ( nCol % 50 ) >= 9 .and. ( nCol % 50 ) <= 41
      return Int( ( nIconsByRow * Int( nRow / 50 ) ) + Int( nCol / 50 ) ) + 1
   Else
      return 0
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:nLogicPos() Version 6.0 Apr/5/2002
* ============================================================================

METHOD nLogicPos() CLASS TSBrowse

   Local cAlias, cOrderName, nLogicPos

   If ! ::lIsDbf
      If ::cAlias == "TEXT_"
         ::nAt := ::oTxtFile:RecNo()
      EndIf
      Return ::nAt
   EndIf
/*
   #ifdef __HARBOUR__
      If ::cDriver != "ADS"
         Return ::nAt   // by now native Harbour RDD's are not complete
      EndIf
   #endif
*/
   If ::lDbfObj
      cAlias := ::oDbf:cAlias
   Else
      cAlias := ::cAlias
   EndIf

   cOrderName := ( cAlias )->( OrdSetFocus() )
   nLogicPos  := Eval( ::bKeyNo, cOrderName )

   If ::lFilterMode
      nLogicPos := nLogicPos - ::nFirstKey
   EndIf

   nLogicPos := If( nLogicPos <= 0, ::nLen + 1, nLogicPos )

Return nLogicPos

* ============================================================================
* METHOD TSBrowse:HiliteCell() Version 6.0 Apr/5/2002
* ============================================================================

METHOD HiliteCell( nCol, nColPix ) CLASS TSBrowse

   Local nI, nAbsCell, nRelCell, nNowPos, nOldPos, nLeftPix, ;
         lDraw := .F.,;
         lMove := .T.

	Default nCol := 1

   If ! ::lCellBrw .and. nColPix == Nil          // if not browsing cell-style AND no nColPix, ignore call.
      Return lDraw                               // nColPix NOT nil means called from ::LButtonDown()
   EndIf

	If nCol < 1
		nCol := 1
   ElseIf nCol > Len( ::aColumns )
		nCol := Len( ::aColumns )
   EndIf

	If Len( ::aColumns ) > 0
      If nColPix != Nil                           // used internally by ::LButtonDown() only
         nAbsCell := ::nAtCol( nColPix, .F. )
         nRelCell := ::nAtCol( nColPix, .T. )

         If nAbsCell >= ::nFreeze .and. nRelCell <= ::nFreeze
		      nNowPos := nRelCell
		   Else
		      nNowPos := nAbsCell
         EndIf

		   nOldPos := ::nCell

         If ::nFreeze > 0 .and. nOldPos < nNowPos  // frozen col and going right
				nNowPos := nAbsCell
				lMove := ( nOldPos > ::nFreeze )
         EndIf

		   If nOldPos < nNowPos                    // going right
				nLeftPix := 0

            For nI := nOldPos To nNowPos - 1
               lDraw := .T.
			      ::nCell ++
               nLeftPix += ::aColSizes[ nI ]       // we need to know pixels left of final cell...
				Next

            ::nCell := If( ::nCell > Len(::aColumns), Len(::aColumns), ::nCell )

            If ::nWidth() < nLeftPix + ::aColSizes[ ::nCell ] .and. ;  // ...and set ::nColPos accordingly
                  ::nColPos < Len( ::aColumns ) .and. lMove //::GetColSizes()
		         ::nColPos ++
               ::Refresh( .F. )
            EndIf
         ElseIf nNowPos < nOldPos                // going left
				For nI := nNowPos To nOldPos - 1
               lDraw := .T.
			      ::nCell --
				Next
				::nCell := If( ::nCell < 1, 1, ::nCell )
         EndIf

			nCol := ::nCell
		Else
			lDraw := ! ( ::nCell == nCol )

         ::nColPos := Max( ::nFreeze + 1, ::nColPos )
         If ::nFreeze > 0 .and. ::lLockFreeze
            ::nCell := Max( nCol, ::nFreeze + 1 )
         EndIf

         If ! ::lNoHScroll .and. lDraw
            ::oHScroll:SetPos( nCol )
            ::Refresh( .F. )
         EndIf
      EndIf

		If ::lCellBrw
			// unhilite all columns EXCEPT those with "double cursor" (permanent) efect
         AEval( ::aColumns, { |oColumn| oColumn:lNoLite := ! oColumn:lFixLite } )   // allways .T. if no double cursor
         ::aColumns[ nCol ]:lNoLite := .F.
      EndIf

   EndIf

Return lDraw

* ============================================================================
* METHOD TSBrowse:HScroll() Version 6.0 Apr/5/2002
* ============================================================================

METHOD HScroll( nWParam, nLParam ) CLASS TSBrowse

   Local nCol

   If oEdit != Nil
      oEdit:Hide()
      oEdit:End()
      oEdit := Nil
      ::lEditing := .F.
      ::oWnd:nLastKey := VK_ESCAPE
   Else
      ::oWnd:nLastKey := 0
      ::lEditing := .F.
   EndIf

   If GetFocus() != ::hWnd
      SetFocus( ::hWnd )
   EndIf

	Do Case
	Case nWParam == SB_LINEUP
		::GoLeft()

	Case nWParam == SB_LINEDOWN
		::GoRight()

	Case nWParam == SB_PAGEUP

      ::PanLeft()

	Case nWParam == SB_PAGEDOWN
        nCol := ::nColPos + 1

        While ::IsColVisible( nCol ) .and. nCol <= Len( ::aColumns )
           ++nCol
        EndDo

        If nCol < Len ( ::aColumns )
           ::nColPos := ::nCell := nCol
           ::Refresh( .F. )
           ::oHScroll:SetPos( nCol )
        Else

           nCol := Len( ::aColumns )
           While ! ::IsColVisible( nCol ) .and. ::nColPos < nCol
              ::nColPos++
           EndDo
           ::nCell := nCol
           ::oHScroll:GoBottom()
           ::Refresh( .F. )
        EndIf

        If ::lCellBrw
           ::HiLiteCell( ::nCell )
        EndIf

   Case nWParam == SB_TOP
		::PanHome()

	Case nWParam == SB_BOTTOM
      ::PanEnd()

	Case nWParam == SB_THUMBPOSITION
		::HThumbDrag( nLParam )

	Endcase

Return 0

* ============================================================================
* METHOD TSBrowse:HThumbDrag() Version 6.0 Apr/5/2002
* ============================================================================

METHOD HThumbDrag( nNewCol ) CLASS TSBrowse

   Local nI, nLeftPix, nColPos,;
         nWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 )

   If ::oHScroll != Nil .and. ! Empty( nNewCol )

      If nNewCol >= Len( ::aColumns )
         If ::IsColVisible( Len( ::aColumns ) )
            ::nCell := Len( ::aColumns )
            ::HiliteCell( ::nCell )
            ::Refresh( .F. )
         Else
            ::PanEnd()
         EndIf
         ::oHScroll:GoBottom()
         Return Self
      EndIf

      If ! Empty( ::cAlias ) .and. ::cAlias == "TEXT_"
			::oHScroll:SetPos( ::nAt := nNewCol )
		Else
         If ::lLockFreeze .and. nNewCol <= ::nFreeze  // watch out for frozen columns
				::oHScroll:SetPos( ::nCell := ::nFreeze + 1 )
			Else
            ::oHScroll:SetPos( ::nCell := Min( nNewCol, Len( ::aColumns ) ) )
         EndIf

         nLeftPix := 0                              // check for frozen columns,

         For nI := 1 To ::nFreeze                   // if any
            nLeftPix += ::aColSizes[ nI ]
			Next
			nColPos := ::nCell
			For nI := ::nCell To 1 Step - 1            // avoid extra scrolling
				If nLeftPix + ::aColSizes[nI] < nWidth  // to the right of the
					nLeftPix += ::aColSizes[nI]          // last cell (column)
					nColPos := nI
				Else
					Exit
            EndIf
			Next
			::nColPos := nColPos
			::HiliteCell( ::nCell )
      EndIf
      ::Refresh( .F. )

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:Inspect() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Inspect( cData ) CLASS TSBrowse

   Do case
      Case cData == "aColumns"
           Return { | aColumns | Tone(500,1), aColumns }
   Endcase

Return Nil

* ============================================================================
* METHOD TSBrowse:InsColumn() Version 6.0 Apr/5/2002
* ============================================================================

METHOD InsColumn( nPos, oColumn ) CLASS TSBrowse

   Local nCell := ::nCell

	Default nPos := 1

	If oColumn == Nil                             // if no Column object supplied
		Return Nil                                 // return nil insted of reference to object
   EndIf

	If nPos < 1
		nPos := 1
   ElseIf nPos > Len( ::aColumns ) + 1
		nPos := Len( ::aColumns ) + 1
   EndIf

	ASize( ::aColumns, Len( ::aColumns ) + 1 )
	aIns( ::aColumns, nPos )
	::aColumns[nPos] := oColumn

	ASize( ::aColSizes, Len( ::aColSizes ) + 1 )
	aIns( ::aColSizes, nPos )
	::aColsizes[nPos] := oColumn:nWidth

   If( nCell != nPos, ::nCell := nPos, Nil )
	::HiliteCell( ::nCell )

   If ! Empty( oColumn:cOrder )                       // if column has a TAG, we
      ::SetOrder( nPos )                              // set it as controling order
   ElseIf ::nColOrder != 0 .and. nPos <= ::nColOrder  // if left of current order
      ::nColOrder ++                                  // adjust position
   EndIf

   If ::oHScroll != Nil
      ::oHScroll:SetRange( 1, Len( ::aColumns ) )
      ::oHScroll:SetPos( ::nCell )
   EndIf

   ::Refresh( .F. )
   ::SetFocus()

Return oColumn                                   // returns reference to Column object

* ============================================================================
* METHOD TSBrowse:IsColVisible() Version 6.0 Apr/5/2002
* ============================================================================

METHOD IsColVisible( nCol ) CLASS TSBrowse

   Local nCols, nFirstCol, nLastCol, nWidth, nBrwWidth, xVar, ;
         aColSizes := ::GetColSizes()

   nCols     := Len( aColSizes )
   nFirstCol := ::nColPos
   nLastCol  := nFirstCol
   nWidth    := 0
   nBrwWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 )

   If nCol < ::nColPos
      Return .F.
   EndIf

   xVar := 1

   While xVar <= ::nFreeze
      nWidth += aColSizes[ xVar++ ]
   EndDo

   While nWidth < nBrwWidth .and. nLastCol <= nCol .and. nLastCol <= nCols
      nWidth += aColSizes[ nLastCol ]
      nLastCol++
   Enddo

   If nCol <= --nLastCol
      Return ! nWidth > nBrwWidth
   EndIf

Return .F.

* ============================================================================
* METHOD TSBrowse:IsColVis2() Version 6.0 Apr/5/2002
* ============================================================================

METHOD IsColVis2( nCol ) CLASS TSBrowse

   Local nCols, nFirstCol, nLastCol, nBrwWidth, ;
         nWidth := 0, ;
         aColSizes := ::GetColSizes()

   nCols     := Len( aColSizes )
   nFirstCol := ::nColPos
   nLastCol  := nFirstCol

   // mt differs from iscolvisible here - allows for frozen column
   If ::nFreeze > 0
		AEval( aColSizes, {|nSize| nWidth += nSize }, 1, ::nFreeze )
   EndIf

   nBrwWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 )

   If nCol < ::nColPos
      Return .F.
   EndIf

   Do While nWidth < nBrwWidth .and. nLastCol <= nCols
      nWidth += aColSizes[ nLastCol ]
      nLastCol++
   Enddo

   If nCol <= --nLastCol
      // mt differs from new iscolvisible here
      Return .T.
   EndIf

Return .F.

* ============================================================================
* METHOD TSBrowse:lEditCol() Version 6.0 Apr/5/2002
* ============================================================================

METHOD lEditCol( uVar, nCol, cPicture, bValid, nClrFore, nClrBack ) CLASS TSBrowse

   Local cMsg     := ::aColumns[ nCol ]:cMsg, ;
         cType    := ValType( uVar ), ;
         cError   := ::aColumns[ nCol ]:cError, ;
         bWhen    := ::aColumns[ nCol ]:bWhen, ;
         lSpinner := ::aColumns[ nCol ]:lSpinner, ;  // optional spinner support
         bUp      := ::aColumns[ nCol ]:bUp, ;
         bDown    := ::aColumns[ nCol ]:bDown, ;
         bMin     := ::aColumns[ nCol ]:bMin, ;
         bMax     := ::aColumns[ nCol ]:bMax, ;
         aVer     := GetVersion(), ;
         nOffset  := 0, ;
         bBackup  := ::oWnd:bValid

   Local oGet, oFont, oBtn, nI, nKey, nFlag, aDim, xTemp, aGetArray, lMulti, ;
         nWidth   := ::GetColSizes()[ nCol ], ;
         lDropBox := ( cType == "L" .and. ::lLogicDrop ), ;
         uTemp    := uVar, ;
         nStartCol := 0, ;
         nFireKey := ::nFireKey, ;
         lWin95 := aVer[1] >= 4 .or. aVer[2] >= 95 .or. IsWinNT()

   Default cPicture := ::aColumns[ nCol ]:cPicture, ;
           bValid   := ::aColumns[ nCol ]:bValid, ;
           nClrFore := ::aColumns[ nCol ]:nClrEditFore, ;
           nClrBack := ::aColumns[ nCol ]:nClrEditBack, ;
           nFireKey := VK_F2, ;
           lSpinner := .F.

   ::oWnd:bValid := { || ! GetASyncKey( VK_ESCAPE ) }
   ::lEditing := .T.
   ::lUpdated := .F.

   If ::nFreeze > 0
      For nI := 1 to Min(::nFreeze , nCol - 1 )
         nStartCol += ::GetColSizes()[ nI ]
      Next
   EndIf

   For nI := ::nColPos To nCol - 1
      nStartCol += ::GetColSizes()[ nI ]
   Next

   nClrFore := If( ValType( nClrFore ) == "B", ;
                   Eval( nClrFore, ::nAt, nCol, Self ), nClrFore )

   nClrBack := If( ValType( nClrBack ) == "B", ;
                   Eval( nClrBack, ::nAt, nCol, Self ), nClrBack )

   If ::lIsDbf .and. ValType( Eval( ::aColumns[ nCol ]:bData ) ) == "M"

      ::nKeyDown := ::nKeyFlag := 0
      If EditMemo( @uTemp, ::aColumns[ nCol ]:cHeading )
         ::lChanged := uVar != uTemp
         uVar := uTemp
         ::PostEdit( uVar, nCol )
         Return 0
      Else
         ::lEditing := .F.
         Return 0
      EndIf

   EndIf

   If ValType( uVar ) == "L" .and. ::aColumns[ nCol ]:lBitMap

      ::nKeyDown := ::nKeyFlag := 0

      If ::oWnd:nLastKey != VK_RETURN

         If Upper( Chr( ::oWnd:nLastKey ) ) $ "YCST"
            ::lChanged := uVar == .F.
            uVar := .T.
         ElseIf Upper( Chr( ::oWnd:nLastKey ) ) $ "FN"
            ::lChanged := uVar == .T.
            uVar := .F.
         Else
            uVar := ! uTemp
            ::lChanged := .T.
         EndIf
         ::oWnd:nLastKey := VK_RETURN
         ::PostEdit( uVar, nCol )
         Return 0
      Else
         ::lChanged := .F.
         ::PostEdit( uVar, nCol )
         Return 0
      EndIf
   EndIf

   aDim := aTSBrwPosRect( ::hWnd, ::nRowPos, nStartCol, nWidth, ;
                          If( ::aColumns[ nCol ]:oFont != Nil, ;
                              ::aColumns[ nCol ]:oFont:hFont, 0 ), ;
                              ::nHeightCell, ::nHeightHead, ::nHeightSuper )

   If ::nLineStyle < 5 .and. ! ( lDropBox .or. ;
                                 ::aColumns[ nCol ]:aList != Nil .or. ;
                                 ::aColumns[ nCol ]:cResName != Nil )

      If ! ::aColumns[ nCol ]:l3DLook
         aDim[ 3 ] -= 2
         --aDim[ 4 ]
      Else
         aDim[ 1 ] += 1
         aDim[ 2 ] += 2
         aDim[ 3 ] -= 2
         aDim[ 4 ] -= 2
      EndIf
   ElseIf ::nLineStyle = 5 .and. ! ( lDropBox .or. ;
                                 ::aColumns[ nCol ]:aList != Nil .or. ;
                                 ::aColumns[ nCol ]:cResName != Nil )
      aDim[ 1 ] += 2
      aDim[ 2 ] += 2
      aDim[ 3 ] -= 1
   EndIf

   If ::oFont != Nil .and. ! Empty( ::oFont:nHeight )
      // added default font of system 10 300 weight
      oFont := TFont():New( ::oFont:cFaceName, 0 ,; // ::oFont:nWidth,;
               If( Abs( ::oFont:nHeight ) < 10, -10, -Abs( ::oFont:nHeight ) ), .F., ;
                   ::oFont:lBold, Nil, Nil, If(::oFont:lBold, Nil, 300 ) )
   EndIf

   DEFINE DIALOG oEdit OF ::oWnd ;
          FROM aDim[ 1 ], aDim[ 2 ] TO aDim[ 3 ], aDim[ 4 ] ;
          STYLE nOR( WS_VISIBLE, WS_POPUP ) PIXEL

   If lDropBox .or. ::aColumns[ nCol ]:aList != Nil
      If lDropBox
         aGetArray := { ::aMsg[ 1 ], ::aMsg[  2 ] }

         xTemp := uTemp

         If ::nKeyDown != 0                     // direct cell editing with keys!
            uTemp := AScan( aGetArray, ;
                           { | item | Upper( Chr( ::nKeyDown ) ) $ item }  )
            If uTemp = 0
               uTemp := Max( 1, AT( Upper( Chr( ::nKeydown ) ), "TF"  ) )
            EndIf

            xTemp := If( uTemp == 1, .T., .F. )
            uTemp := aGetArray[ uTemp ]
            ::nKeyDown := 0

         Else
            uTemp := If( uVar, aGetArray[ 1 ], aGetArray[ 2 ] )
         EndIf

         oGet := TSCombo():New( 0, 0, bSETGET( uTemp ), aGetArray, ;
                 aDim[ 4 ] - aDim[ 2 ] - 26, 32, oEdit,,,, nClrFore, ;
                 nClrBack, .T., oFont, cMsg,, bWhen )
         oGet:oGet := oGet
         oGet:cError := cError
         oGet:bChange := {|| xTemp := ! xTemp }

      Else

         aGetArray := ::aColumns[ nCol ]:aList

         If ValType( aGetArray[ 1 ] ) == "A"
            aGetArray := aGetArray[ 1 ]
         EndIf

         nI := 0
         AEval( aGetArray, { | item, x, y | item := Upper( Trim( item ) ), ;
                             If( ( y := GetTextWidth( 0, item, oFont ) ) > nI, ;
                             nI := y, Nil ) } )

         If ::nKeyDown != 0                     // direct cell editing with keys!
            uTemp := Max( 1, AScan( aGetArray, Upper( Chr( ::nKeyDown ) ) ) )
            uTemp := aGetArray[ uTemp ]
            ::nKeyDown := 0
         Else
            uTemp := If( ValType( uVar ) = "N", aGetArray[ Max( 1, uVar ) ], ;
                     If( ValType( uVar ) = "L" .and. uVar, aGetArray[ 1 ], ;
                     If( ValType( uVar ) = "L", aGetArray[ 2 ], ;
                         aGetArray[ Max( 1, AScan( aGetArray, uTemp ) ) ] ) ) )
         EndIf

         oGet := TSCombo():New( 0, 0, bSETGET( uTemp ), aGetArray, ;
                 aDim[ 4 ] - aDim[ 2 ] - 26, 82, oEdit,, ;
                 {|o,i| xTemp := i},, nClrFore, ;
                 nClrBack, .T., oFont, cMsg,, bWhen)

         oGet:nRight := ::aColSizes[ nCol ] * .5
         oGet:cError := cError
         oGet:bKeyDown := { | nKey | ;
                            ( ::EditExit( nKey, oGet, uVar, bValid, 1 ) ) }
      EndIf

   ElseIf ValType( uTemp ) == "C" .and. Chr( 13 ) $ uTemp
      oGet := TSMulti():New( 0, 0, bSETGET( uTemp ), oEdit, ;
              ( aDim[ 4 ] - aDim[ 2 ] ) / 2 , ( aDim[ 3 ] - aDim[ 1 ] ) / 2, ;
              oFont,,nClrFore, nClrBack,,,,, bWhen,,,,,,, )

      oGet:bGotFocus := { || oGet:HideSel(), oGet:SetPos( 0 ) }
      oGet:bKeyDown := { | nKey | ::EditExit( nKey, oGet, uVar, bValid, 2 ) }

   Else

      If ::aColumns[ nCol ]:cResName != Nil

         oGet := TSBtnGet():New( 0, 0, bSETGET( uTemp ), oEdit, ;
                 ( ( aDim[ 4 ] - aDim[ 2 ] ) / 2 ), ( aDim[ 3 ] - aDim[ 1 ] ) / 2, ;
                 cPicture,, nClrFore, nClrBack, oFont,,,,,, ;
                 bWhen,,,,,, .T.,, ::aColumns[ nCol ]:cResName, ;
                 ::aColumns[ nCol ]:bAction, lSpinner .and. cType $ "ND", ;
                 bUp, bDown, bMin, bMax, ::aColumns[ nCol ]:nBmpWidth )


         oGet:nFireKey := nFireKey
         aGetArray := {}

      Else

         // TSGet class to evaluate oGet:bKeydown
         oGet := TSGet():New( 0, 0, bSETGET( uTemp ), oEdit, ;
                 Int( ( aDim[ 4 ] - aDim[ 2 ] ) / 2 ), ;
                 Int( ( aDim[ 3 ] - aDim[ 1 ] ) / 2 ), ;
                 cPicture,, nClrFore, nClrBack, ;
                 oFont,,,,,, bWhen,,,,,, .T.,, ;
                 lSpinner .and. cType $ "ND", bUp, bDown, bMin, bMax )

      EndIf

      oGet:bKeyDown := { | nKey | ::EditExit( nKey, oGet, uVar, bValid ) }
      oGet:lFixCaret := ::lFixCaret
      oGet:oJump := Self

      If ::nKeyDown != 0                          // direct cell editing with keys!
         nKey  := ::nKeyDown
			nFlag := ::nKeyFlag
			::nKeyDown := ::nKeyFlag := 0
         oGet:lRightLeftExit := .T.
         oEdit:bStart := {|| oGet:KeyChar( nKey, nFlag ) }  // stuff keyboard Windows way, not with __KeyBoard()
      EndIf

   EndIf

   If lWin95 .and. lAnd( GetWindowLong( ::oWnd:hWnd, GWL_STYLE ), DS_3DLOOK )
      nOffset := 1
   EndIf

   ACTIVATE DIALOG oEdit NOWAIT ;
            ON INIT ( oEdit:Move( aDim[ 1 ], aDim[ 2 ] + 1, ;
                             aDim[ 4 ] - aDim[ 2 ], aDim[ 3 ] - aDim[ 1 ] ),;
                If( lDropBox,;
                oGet:Move( -10, -2, aDim[ 4 ] - aDim[ 2 ] - 26, 22 ), ;
                If( aGetArray != Nil, Nil, ;
                oGet:Move( If( lWin95, -1, -3) + nOffset, -1 + nOffset, ;
                           aDim[ 4 ] - aDim[ 2  ] + 1, ;
                           aDim[ 3 ] - aDim[ 1 ] + If(lWin95, 1, 3) ) ) ),;
                ::oWnd:bValid := { || ! GetASyncKey( VK_ESCAPE ) }, ;
                oGet:GotFocus() ) ;
      VALID ( ::oWnd:bValid := bBackUp, If( oFont != Nil, oFont:End(), Nil ), ;
              .T. )


Return 0

* ============================================================================
* METHOD TSBrowse:lIgnoreKey() Version 6.0 Apr/5/2002
* Checks if any of the predefined navigation keys has been remapped so as to
* ignore its default behavior and forward it to TWindow class in case a new
* behavior has been defined in ::bKeyDown. Uses the new nested array IVar
* ::aKeyRemap which has the following structure (data type in parens):
*
* { { VK_ to ignore(n), alone(l), ctrl(l), shift(l), alt(l), ctrl+shift(l), bBlock }, ... }
*
* Example:  AAdd( ::aKeyRemap, { VK_END, .T., .F., .T., .F., .F., { || Tone(600) } } )
*           will ignore End key alone and with shift+end combinations
*
* It's the programmer's (ie you!) responsibility to make sure each subarray
* has 6 elements of the specified data type or kaboom!
* This method is called by ::KeyDown() which provides nKey and nFlags.
* If called directly, you must specify the parameter nKey (nFlags is always ignored)
* ============================================================================

METHOD lIgnoreKey( nKey, nFlags ) CLASS TSBrowse

   Local lIgnore := .F., ;
         nAsync := 2, ;                // key by itself
         nIgnore := AScan( ::aKeyRemap, {|aRemap| aRemap[1] == nKey } )

   If nIgnore > 0

      If GetKeyState( VK_CONTROL ) .and. GetKeyState( VK_SHIFT )
         nAsync := 6
      ElseIf GetKeyState( VK_CONTROL )
         nAsync := 3
      ElseIf GetKeyState( VK_SHIFT )
         nAsync := 4
      ElseIf GetKeyState( VK_MENU )                    // alt key
         nAsync := 5
      EndIf

      lIgnore := ::aKeyRemap[ nIgnore, nAsync ]

      If lIgnore .and. ValType( ::aKeyRemap[ nIgnore, 7 ] ) == "B"
         Eval( ::aKeyRemap[ nIgnore, 7 ] )
      EndIf

   EndIf

Return lIgnore

* ============================================================================
* METHOD TSBrowse:Look3D() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Look3D( lOnOff, nColumn, nLevel, lPhantom ) CLASS TSBrowse

   Default lOnOff   := .T., ;
           nColumn  :=  0 , ;
           lPhantom := .T., ;
           nLevel   :=  0

   ::l3DLook := lOnOff                              // used internally

   If nColumn > 0
      If nLevel = 1 .or. nLevel = 0
         ::aColumns[ nColumn ]:l3DLook := lOnOff
      EndIf

      If nLevel = 2 .or. nLevel = 0
         ::aColumns[ nColumn ]:l3DLookHead := lOnOff
      EndIf

      If nLevel = 3 .or. nLevel = 0
         ::aColumns[ nColumn ]:l3DLookFoot := lOnOff
      EndIf
   Else
      If nLevel > 0
         AEval( ::aColumns, { | oCol | If( nLevel = 1, oCol:l3DLook := lOnOff, ;
                                       If( nLevel = 2, oCol:l3DLookHead := lOnOff, ;
                                           oCol:l3DLookFoot := lOnOff ) ) } )
      Else
         AEval( ::aColumns, { | oCol | oCol:l3DLook := lOnOff, ;
                                       oCol:l3DLookHead := lOnOff, ;
                                       oCol:l3DLookFoot := lOnOff } )
      EndIf
   EndIf

   If lPhantom
      ::nPhantom := PHCOL_GRID
   Else
      ::nPhantom := PHCOL_NOGRID
   EndIf

   ::Refresh( .T. )

Return Self

* ============================================================================
* METHOD TSBrowse:LostFocus() Version 6.0 Apr/5/2002
* ============================================================================

METHOD LostFocus( hCtlFocus ) CLASS TSBrowse

   If ::lEditing
      Return 0
   EndIf

   Super:LostFocus( hCtlFocus )

   If ::nLen > 0 .and. ! EmptyAlias( ::cAlias ) .and. ! ::lIconView
      ::DrawSelect()
   EndIf

   If ::oCtx != Nil
      ::oCtx:Save()
   EndIf

   If ::cAlias != "ARRAY" .and. ::cAlias != "TEXT_"

      ::nLastPos := ( ::cAlias )->( RecNo() )
      ::nLastnAt := ::nAt

      If ::bTagOrder != Nil .and. ! ::lNoResetPos .and. ::bLastTag != Nil
         ::uLastTag := Eval( ::bLastTag )
      EndIf

   EndIf

   ::lHasFocus := .F.

Return 0

* ============================================================================
* METHOD TSBrowse:MButtonDown() Version 6.0 Apr/5/2002
* ============================================================================

METHOD MButtonDown( nRow, nCol, nKeyFlags ) CLASS TSBrowse

   If ::bMButtonDown != Nil
      Eval( ::bMButtonDown, nRow, nCol, nKeyFlags )
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:MouseMove() Version 6.0 Apr/5/2002
* ============================================================================

METHOD MouseMove( nRowPix, nColPix, nKeyFlags ) CLASS TSBrowse

   Local nI, nColPixPos := 0, lHeader, lMChange, lFrozen := .F., nIcon

   DEFAULT ::lMouseDown := .F.

   If ::lIconView
      If ( nIcon := ::nAtIcon( nRowPix, nColPix ) ) != 0
         If ::nIconPos != 0 .and. ::nIconPos != nIcon
            ::DrawIcon( ::nIconPos )
         EndIf
         ::nIconPos := nIcon
         ::DrawIcon( nIcon, .T. )
         CursorHand()
         Return 0
      EndIf
   EndIf

   lHeader := ::nTSBRow( nRowPix ) == 0

   If ::lDrag
      Return Super:MouseMove( nRowPix, nColPix, nKeyFlags )
   EndIf

   If ::nFreeze > 0
      For nI := 1 to ::nFreeze
         nColPixPos += ::GetColSizes()[ nI ]
      Next

      If nColPix < nColPixPos
         lFrozen := .T.
      EndIf
   EndIf

   If ! ::lGrasp .and. ( lFrozen .or. ! lHeader .or. ! ::lMChange )
       // don't allow MouseMove to drag/resize columns
       // unless in header row and not in frozen zone
      CursorArrow()

      If ::lCaptured
         If ::lLineDrag
            ::VertLine()
            ::lLineDrag := .F.
         EndIf

         ReleaseCapture()
         ::lColDrag := ::lCaptured := ::lMouseDown := .F.
      EndIf

      lMChange := ::lMChange  // save it for restore
      ::lMChange := .F.
      Super:MouseMove( nRowPix, nColPix, nKeyFlags )
      ::lMChange := lMChange
      Return 0
   EndIf

   If ::lDrag
      Return Super:MouseMove( nRowPix, nColPix, nKeyFlags )
   Else
      If ::lMChange
         If lHeader
            If ::lGrasp             // avoid dragging between header & rows
               ::lGrasp := .F.
               CursorArrow()        // restore default cursor
            EndIf

            If ::lColDrag
               CursorSize()
            Else
               If ::lLineDrag
                  ::VertLine( nColPix )
                  CursorWE()
               Else
                  If AScan( ::GetColSizes(),;
                       { | nColumn | nColPixPos += nColumn,;
                       nColPix >= nColPixPos - 2 .and. ;
                       nColPix <= nColPixPos + 2 }, ::nColPos ) != 0
                     CursorWE()
                  Else
                     CursorHand()
                  EndIf
               EndIf
            EndIf
         ElseIf ::lGrasp
            ::lCaptured := ::lColDrag := .F.     // to avoid collision with header/column dragging
            ::lMouseDown := .T.                  // has to be down until dragging finishes
            Super:MouseMove( nRowPix, nColPix, nKeyFlags )
         Else
            CursorArrow()
         EndIf
      Else
         CursorArrow()
      EndIf
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:MoveColumn() Version 6.0 Apr/5/2002
* ============================================================================

METHOD MoveColumn( nColPos, nNewPos ) CLASS TSBrowse

   Local oCol, cOrder, ;
         nMaxCol := Len( ::aColumns ), ;
         nOrder := ::nColOrder, ;
         lCurOrder := ( ::nColOrder == nColPos )

   Local lSetOrder := ;
      ( nOrder != nColPos .and. nOrder != nNewPos .and. ::nColOrder == nNewPos )

   If ! Empty( nColPos ) .and. ! Empty( nNewPos ) .and. ;
         nColPos > ::nFreeze .and. nNewPos > ::nFreeze .and. ;
         nColPos <= nMaxCol .and. nNewPos <= nMaxCol

      oCol := ::aColumns[ nColPos ]
		cOrder := oCol:cOrder
		oCol:cOrder := Nil                         // avoid ::InsColumn() from seting order...

		::delColumn( nColPos )
		::insColumn( nNewPos, oCol )

		::aColumns[nNewPos]:cOrder := cOrder       // ...restore ::cOrder (if any)

		If lSetOrder
         ::SetOrder( nNewPos - 1 )
      ElseIf lCurOrder
         ::SetOrder( nNewPos )
      ElseIf nOrder != 0
			// check if current order is in between moving columns
         If nOrder >= nColPos .and. nOrder <= nNewPos      // left to right movement
				nOrder --
         ElseIf nOrder <= nColPos .and. nOrder >= nNewPos  // right to left movement
				nOrder ++
         EndIf
         ::SetOrder( nOrder )
      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:PageDown() Version 6.0 Apr/5/2002
* ============================================================================

METHOD PageDown( nLines ) CLASS TSBrowse

   Local nSkipped, nI, ;
         lPageMode := ::lPageMode

   Default nLines := ::nRowCount()

   ::lAppendMode := .F.
   ::ResetSeek()

   ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                 Eval( ::bLogicLen ) )

   If ::nLen < 1
      Return Nil
   EndIf

   If ! ::lHitBottom

      ::DrawLine()

      If lPageMode .and. ::nRowPos < nLines
         nSkipped := ::Skip( nLines - ::nRowPos )
         lPageMode := .F.
      Else
         nSkipped = ::Skip( ( nLines * 2 ) - ::nRowPos )
      EndIf

      If nSkipped != 0
         ::lHitTop = .F.
      EndIf

      Do Case
         Case nSkipped == 0
              ::lHitBottom := .T.
         Case nSkipped < nLines .and. ! lPageMode
              If nLines - ::nRowPos < nSkipped
                 ::Skip( -( nLines ) )
                 For nI = 1 To ( nLines - 1 )
                     ::Skip( 1 )
                     ::DrawLine( nI )
                 Next
                 ::Skip( 1 )
              EndIf
              ::nRowPos = Min( ::nRowPos + nSkipped, nLines )
         Case nSkipped < nLines .and. lPageMode
              ::Refresh( .T. )
         Otherwise
              For nI = nLines To 1 Step -1
                  ::Skip( -1 )
              Next
              ::Skip( ::nRowPos )
              ::Refresh( ::nLen < nLines )
      Endcase

      ::DrawSelect()

      If ::bChange != Nil
         Eval( ::bChange, Self, VK_NEXT )
      EndIf

      If ::oVScroll != Nil
         If ! ::lHitBottom
            ::oVScroll:SetPos( ::nLogicPos() )
         Else
            ::oVScroll:GoBottom()
         EndIf
      EndIf

   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:PageUp() Version 6.0 Apr/5/2002
* ============================================================================

METHOD PageUp( nLines ) CLASS TSBrowse

   Local nSkipped

   Default nLines := ::nRowCount()

   ::lHitBottom := .F.
   ::lAppendMode := .F.
	::ResetSeek()

   If ::lPageMode .and. ::nRowPos > 1

      ::DrawLine()
      nSkipped := ::Skip( -( ::nRowPos - 1 ) )
      ::nRowPos := 1
      ::Refresh( .F. )

      If ::oVScroll != Nil
         ::oVScroll:SetPos( ::nLogicPos() )
      EndIf

      If ::bChange != Nil
         Eval( ::bChange, Self, VK_PRIOR )
      EndIf

      Return Self

   EndIf

   nSkipped := ::Skip( -nLines )

   ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                 Eval( ::bLogicLen ) )

   IF ::nLen < 1
      Return nil
   EndIf

   If ! ::lHitTop
      If nSkipped == 0
         ::lHitTop := .T.
      Else

         If -nSkipped < nLines
            ::nRowPos := 1
            If ::oVScroll != Nil
               ::oVScroll:SetPos( 1 )
            EndIf
         Else
            If ::oVScroll != nil
               ::oVScroll:SetPos( ::nLogicPos() )
            EndIf
         EndIf

         ::Refresh( .f. )

         If ::bChange != nil
            Eval( ::bChange, Self, VK_PRIOR )
         EndIf

      EndIf

   Else
      If ::oVScroll != Nil
         ::oVScroll:GoTop()
      EndIf
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:Paint() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Paint() CLASS TSBrowse

   Local nRecs, lAppendMode, ;
         nColPos := ::nColPos, ;
         nI      := 1, ;
         nLines  := Min( ( ::nLen + If( ::lAppendMode .and. ::cAlias != "ARRAY", ;
                                        1, 0 ) ), ::nRowCount() ), ;
         nSkipped := 1

   local aInfo := ::DispBegin()

   // check to bypass area paint routines

   If ! ::lRePaint
      Return 0
   EndIf

   FillRect( ::hDC, GetClientRect( ::hWnd ), ::oBrush:hBrush )

   If ! ::lPainted .and. Upper( ::oWnd:ClassName ) != "TDIALOG"
      ::Default()
   EndIf

   If ::lFirstPaint .and. !::lPainted .and. ;
      Upper( ::oWnd:ClassName ) != "TDIALOG"
      ::lFirstPaint := .F.
      Return 0
   EndIf

   If ::lIconView
      ::DrawIcons()
      Return 0
   EndIf

   If ::nHeightSuper > 0
      ::nColPos := ::nFreeze + 1
      ::DrawSuper()
      ::nColPos := nColPos
   EndIf

   ::DrawHeaders()

   If ! ::lFocused .and. ::oCtx != Nil
      ::oCtx:Restore()  // window not in focus but needs repainting
   EndIf

   If ::lAppendMode .and. ::lFilterMode
      Eval( ::bGoBottom )
   EndIf

   ::Skip( 1 - ::nRowPos )
//   ::GetDC()

   If ::cAlias == "ARRAY"
      lAppendMode := ::lAppendMode
      ::lAppendMode := .F.
   EndIf

   ::nLastPainted := 0

   While nI <= nLines .and. nSkipped == 1
      If ! ::nRowPos == nI
         ::DrawLine( nI )
      Else
         ::DrawSelect()
      EndIf
      ::nLastPainted := nI
      nSkipped := ::Skip( 1 )
      If nSkipped == 1
         nI++
      EndIf
   Enddo

//   ::ReleaseDC()

   If ::cAlias == "ARRAY"
      ::lAppendMode := lAppendMode
   EndIf

   If ::lAppendMode
      nI := Max( 1, --nI )
   EndIf

   ::Skip( ::nRowPos - nI )

   If ::nLen  < ::nRowPos
      ::nRowPos := ::nLen
   EndIf

   If ::lAppendMode .and. ::nLen == ::nRowPos .and. ::nRowPos < nLines
      ::DrawLine( ++ ::nRowPos )
   Else
//      ::DrawSelect()
   EndIf

   If ! ::lFocused .and. ::oCtx != Nil
      ::oCtx:Save()
   EndIf

   ::lPainted := .T.

   ::DispEnd( aInfo )

Return 0

* ============================================================================
* METHOD TSBrowse:PanEnd() Version 6.0 Apr/5/2002
* ============================================================================

METHOD PanEnd() CLASS TSBrowse

   Local nI, nTxtWid,;
         nWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ),;
         nWide := 0,;
         nCols := Len( ::aColumns )

	If ::cAlias == "TEXT_"
		nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::oFont != nil, ::oFont:hFont, 0 ) ) )
		::nAt := ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
      ::Refresh( .F. )

      If ::oHScroll != Nil
			::oHScroll:setPos( ::nAt )
      EndIf

      Return Self
   EndIf

   ::nColPos := nCols
	::nCell := nCols
	nWide := ::aColSizes[nCols]

   For nI := nCols - 1 To 1 Step - 1
		If nWide + ::aColSizes[nI] <= nWidth
			nWide += ::aColSizes[nI]
			::nColPos--
		Else
			Exit
      EndIf
	Next

   ::Refresh( .F. )

   If ::oHScroll != Nil
      If ::oHScroll:nMax != nCols
         ::oHScroll:SetRange( 1, nCols )
      EndIf
      ::oHScroll:GoBottom()
   EndIf

	::HiliteCell( nCols )

Return Self

* ============================================================================
* METHOD TSBrowse:PanHome() Version 6.0 Apr/5/2002
* ============================================================================

METHOD PanHome() CLASS TSBrowse

   Local nColChk, nEle

   If ::cAlias == "TEXT_"
		::nAt := 1
      ::Refresh( .F. )

      If ::oHScroll != Nil
			::oHScroll:setPos( ::nAt )
      EndIf

      Return Self
   EndIf

   For nEle := 1 To Len( ::aColumns )
      If ! ::aColumns[ nEle ]:lNoHilite
         nColChk := nEle
         Exit
      EndIf
   Next

   ::nColPos := 1
   ::nCell := nColChk

   If ! ::lEditing
      ::Refresh( .F. )
   Else
      ::Paint()
   EndIf

   If ::oHScroll != Nil
      ::oHScroll:SetPos( ::nCell )
   EndIf

   ::HiliteCell( ::nCell )

Return Self

* ============================================================================
* METHOD TSBrowse:PanLeft() Version 6.0 Apr/5/2002
* ============================================================================

METHOD PanLeft() CLASS TSBrowse

   Local nI,;
         nWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ),;
         nWide := 0,;
         nCols := Len( ::aColumns ),;
         nPos := ::nColPos,;
         nFirst := If( ::lLockFreeze .and. ::nFreeze > 0, ::nFreeze + 1, 1 )

   Local nCellAnt := ::nCell

	If ::cAlias == "TEXT_"
		If ::nAt > 11
			::nAt := ::nAt - 10
		Else
			::nAt := 1
      EndIf
      If ::oHScroll != Nil
			::oHScroll:SetPos( ::nAt )
      EndIf
      ::Refresh( .F. )
		Return Self
   EndIf

   If ::nFreeze >= nCols
      Return Self
   EndIf

   AEval( ::aColSizes, { | nSize | nWide += nSize } )

   If  nWide <= nWidth                           // browse fits all inside
		::nCell := nFirst                          // window or dialog
		::nColPos := 1
	Else
		nWide := ::aColSizes[nPos]
		For nI := nPos - 1 To nFirst Step - 1
			If nWide <= nWidth
            nWide += ::aColSizes[ nI ]
				::nCell := nI
			Else
				Exit
         EndIf
		Next
		::nColPos := ::nCell                       // current column becomes first in offset
   EndIf

   If ! ::lCellBrw .and. ! ::lLockFreeze .and. ;  // for frozen columns
         ::nFreeze > 0 .and. ::nCell - 1 == 1
		::nCell := ::nColPos := ::nFreeze
   EndIf

   If ::nCell != nCellant
      ::Refresh( .F. )
   EndIf

   If ::oHScroll != Nil
		::oHScroll:SetPos( ::nCell )
   EndIf

   If ::lCellBrw
      ::HiliteCell( ::nCell )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:PanRight() Version 6.0 Apr/5/2002
* ============================================================================

METHOD PanRight() CLASS TSBrowse

   Local nTxtWid, nI,;
         nWidth := ::nWidth() - If( ::oVScroll != Nil, 16, 0 ),;
         nWide := 0,;
         nCols := Len( ::aColumns ),;
         nPos := ::nColPos, ;
         nCellAnt := ::nCell

	If ::cAlias == "TEXT_"
 		nTxtWid := Max( 1, GetTextWidth( 0, "B", If( ::oFont != nil, ::oFont:hFont, 0 ) ) )
 		If ::nAt < ::oTxtFile:nMaxLineLength - 21 - Int( nWidth / nTxtWid )
 			::nAt := ::nAt + 20
 		Else
 			::nAt := ::oTxtFile:nMaxLineLength - Int( nWidth / nTxtWid )
      EndIf

      If ::oHScroll != Nil
 			::oHScroll:SetPos( ::nAt )
      EndIf

      ::Refresh( .F. )
		Return Self
   EndIf

   If ::nFreeze >= nCols
      Return Self
   EndIf

   AEval( ::aColSizes, {|nSize| nWide += nSize }, nPos )

   If ::nFreeze > 0
		AEval( ::aColSizes, {|nSize| nWide += nSize }, 1, ::nFreeze )
   EndIf

   If nWide <= nWidth     // we're in last columns (including the current one),
      ::nCell := nCols    // so just ::nCell changes, not ::nColPos
	Else
		nWide := 0
		AEval( ::aColSizes, {|nSize| nWide += nSize }, nPos + 1 )

      If ::nFreeze > 0
			AEval( ::aColSizes, {|nSize| nWide += nSize }, 1, ::nFreeze )
      EndIf

      If nWide <= nWidth .and. nPos < nCols      // the remaining columns are added
			::nCell := nPos + 1                     // the last in the browse
			nPos := nCols                           // so as to avoid For..Next
      EndIf

      nWide := ::aColSizes[nPos]

      For nI := nPos + 1 To nCols
         If ( nWide + ::aColSizes[nI] <= nWidth ) .or. ;
               ( nI - nPos < 2 .and. nWide + ::aColSizes[nI] > nWidth )  // two consecutive very wide columns
				nWide += ::aColSizes[nI]
				::nCell := nI
			Else
				Exit
         EndIf
		Next
		::nColPos := ::nCell                       // last column becomes first in offset
   EndIf

   If ! ::lCellBrw .and. ;                       // for frozen columns
			If( ::nFreeze > 0, ::IsColVis2( nCols ), ::IsColVisible( nCols ) )
		::nCell := nCols
   EndIf

   If ::nCell != nCellAnt
      ::Refresh( .F. )
   EndIf

   If ::oHScroll != Nil
		::oHScroll:SetPos( ::nCell )
   EndIf

	::HiliteCell( ::nCell )

Return Self

* ============================================================================
* METHOD TSBrowse:Proper() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Proper( cText ) CLASS TSBrowse

   Local nVar, lPunto

   cText := Lower( Trim( cText ) )
   cText := Upper( Substr( cText, 1, 1 ) ) + Substr( cText, 2 )

   WHILE .T.
      lPunto := .F.
      nVar := AT( " ", cText )
      If nVar = 0
         lPunto := .T.
         nVar := AT( ".", cText )
      EndIf

      If nVar = 0
         Exit
      EndIf

      cText := SubStr( cText, 1, nVar - 1 ) + ;
               IF( ! lPunto, Chr( 200 ), Chr( 201 ) ) + ;
               Upper( SubStr( cText, nVar + 1, 1 ) ) + ;
               SubStr( cText, nVar + 2)
   Enddo

   cText := StrTran( cText, Chr( 200 ), " " )
   cText := StrTran( cText, CHR( 201 ), "." )
   cText := StrTran( cText, ::aMsg[ 51 ], Lower( ::aMsg[ 51 ] ) )
   cText := StrTran( cText, ::aMsg[ 52 ], Lower( ::aMsg[ 52 ] ) )
   cText := StrTran( cText, ::aMsg[ 53 ], Lower( ::aMsg[ 53 ] ) )
   cText := StrTran( cText, ::aMsg[ 54 ], Lower( ::aMsg[ 54 ] ) )
   cText := StrTran( cText, ::aMsg[ 55 ], Lower( ::aMsg[ 55 ] ) )

Return cText

* ============================================================================
* METHOD TSBrowse:PostEdit() Version 6.0 Apr/5/2002
* ============================================================================

METHOD PostEdit( uTemp, nCol, bValid ) CLASS TSBrowse

   Local aMoveCell, bRecLock, bAddRec, ;
         nLastKey := ::oWnd:nLastKey

   oEdit := Nil

   aMoveCell := { {|| ::GoRight() }, {|| ::GoDown() }, ;
                  {|| ::GoLeft() },  {|| ::GoUp() }, ;
                  {|| ::GoNext() } }

   bRecLock := If( ! Empty( ::bRecLock ), ::bRecLock, ;
                   {|| ( ::cAlias )->( RLock() ) } )

   bAddRec := If( ! Empty( ::bAddRec ), ::bAddRec, ;
                  {|| ( ::cAlias )->( dbAppend() ), ! NetErr() } )

   If bValid != Nil

      If !  Eval( bValid, uTemp, Self  )
         ::nKeyDown := ::nKeyFlag := 0
         ::lEditing := .F.
         If ::lAppendMode
            ::GoBottom()
            If ::nRowCount() > ::nLen
               ::Refresh( .T. )
            EndIf
         EndIf
         Return Nil
      EndIf

   EndIf

   If ::lIsDbf

      If Eval( If( ! ::lAppendMode, bRecLock, bAddRec ), uTemp )

         Eval( ::aColumns[ nCol ]:bData, uTemp, Self )

         If ::lAppendMode

            If ! Empty( ::aDefault )
               ASize( ::aDefault, Len( ::aColumns ) )
               AEval( ::aDefault, { | e, n | If( e != Nil .and. ;
               n != nCol, If( Valtype( e ) == "B", ;
               Eval( ::aColumns[ n ]:bData, Eval( e, Self ) ), ;
               Eval( ::aColumns[ n ]:bData, e ) ), Nil ) } )
               ::DrawLine()
            EndIf

            If ::lFilterMode .and. ::aColumns[ nCol ]:lIndexCol
               If &( ( ::cAlias )->( IndexKey() ) ) >= ::uValue1 .and. ;
                  &( ( ::cAlias )->( IndexKey() ) ) <= ::uValue2

                  ::nLen := ( ::cAlias )->( Eval( ::bLogicLen() ) )
                  ::nRowPos := ::nAt := Min( ::nRowCount, ::nLen )
               Else
                  ::lChanged := .F.
                  DbGoTo( ::nPrevRec )
                  ::Refresh( .F. )
                EndIf
            Else
               ::nLen++
            EndIf

            ::lAppendMode := .F.     // turn append mode off

            If ::nRowPos == 0 .and. ::lDrawHeaders
               ::nRowPos := ::nAt := 1
            EndIf

            ::DrawLine( ::nRowPos )

         EndIf

         If ::oVScroll != Nil      // update vertical scrollbar
            ::oVScroll:SetRange( 1, Max( 1, ::nLen ) )
            ::oVScroll:SetPos( ::nLogicPos() )
         EndIf

         If ::aColumns[ nCol ]:bPostEdit != Nil
            Eval( ::aColumns[ nCol ]:bPostEdit, uTemp, Self )
         EndIf

         ::lUpdated := .T.
         ( ::cAlias )->( dbUnLock() )

         If ! ::lDbfObj .and. ::aColumns[ nCol ]:lIndexCol .and. ::lChanged
            ::UpStable()  // only in the case that an index field changes
         EndIf

         If ! ::lAutoEdit
            ::lEditing := .F.
         EndIf

         ( ::cAlias )->( DbGoTo( ( ::cAlias )->( RecNo() ) ) )  // refresh relations just in case that
                                                                // a relation field changes
         If nLastKey == VK_UP
            ::GoUp()
         ElseIf nLastkey == VK_RIGHT
            ::GoRight()
         ElseIf nLastkey == VK_LEFT
            ::GoLeft()
         ElseIf nLastkey == VK_DOWN
            ::GoDown()
         ElseIf ::aColumns[ nCol ]:nEditMove >= 1 .and. ;
            ::aColumns[ nCol ]:nEditMove <= 5  // excel-like behaviour post-edit movment
            Eval( aMoveCell[ ::aColumns[ nCol ]:nEditMove] )
         ElseIf ::aColumns[ nCol ]:nEditMove == 0 .and. ! ::lAutoEdit
            ::DrawSelect()
         EndIf

         ::oWnd:nLastKey := Nil

         If ::lAutoEdit .and. ! ::lAppendMode
            SysRefresh()
            ::nKeyDown := 0
            ::DrawLine()
            ::PostMsg( WM_KEYDOWN, VK_RETURN, nMakeLong( 0, 0 ) )
            ::PostMsg( WM_KEYUP, VK_RETURN, nMakeLong( 0, 0 ) )
            Return Nil
         Endif

      Else
         If ! ::lAppendMode .and. Empty( ::bRecLock )
            MsgStop( ::aMsg[ 3 ], ::aMsg[ 4 ] )
         ElseIf ::lAppendMode .and. Empty( ::bAddRec )
            MsgStop( ::aMsg[ 5 ], ::aMsg[ 4 ] )
         EndIf
      EndIf
   Else

      If ::lAppendMode .and. ::cAlias == "ARRAY"
         // when ::aDefValue[1] == Nil, it flags this element
         // as the equivalent of the "record no" for the array
         // this is why ::aDefValue will have one more element
         // than Len( ::aArray )
         ::lAppendMode := .F.        // turn append mode off
         AAdd( ::aArray, ;
         Array( Len( ::aDefValue ) - If( ::aDefValue[ 1 ] == Nil, 1, 0 ) ) )
         ::nAt := Len( ::aArray )
         ::nLen++

         If ::oVScroll != Nil         // update vertical scrollbar
            ::oVScroll:SetRange( 1, Max( 1, ::nLen ) )
            ::oVScroll:GoBottom()
         EndIf

         AEval( ATail( ::aArray ), { | uVal, n | ::aArray[ ::nAt, n ] := ;
                ::aDefValue[ n + If( ::aDefValue[ 1 ] == Nil, 1, 0 ) ] } )

         If ! Empty( ::aDefault )
            ASize( ::aDefault, Len( ::aColumns ) )
            AEval( ::aDefault, { | e, n | If( e != Nil .and. ;
                   n != nCol, If( Valtype( e ) == "B", ;
                   Eval( ::aColumns[ n ]:bData, Eval( e, Self ) ), ;
                   Eval( ::aColumns[ n ]:bData, e ) ), Nil ) } )
            ::DrawLine()
         EndIf

      EndIf

      Eval( ::aColumns[ nCol ]:bData, uTemp )

      If ::aColumns[ nCol ]:bPostEdit != Nil
         Eval( ::aColumns[ nCol ]:bPostEdit, uTemp, Self )
      EndIf

      If ! ::lAutoEdit
         ::lEditing := .F.
      EndIf

      ::oWnd:nLastKey := Nil

      If nLastKey == VK_UP
         ::GoUp()
      ElseIf nLastkey == VK_RIGHT
         ::GoRight()
      ElseIf nLastkey == VK_LEFT
         ::GoLeft()
      ElseIf nLastkey == VK_DOWN
         ::GoDown()
      ElseIf ::aColumns[ nCol ]:nEditMove >= 1 .and. ;
         ::aColumns[ nCol ]:nEditMove <= 5  // excel-like behaviour post-edit movment
         Eval( aMoveCell[ ::aColumns[ nCol ]:nEditMove ] )
      ElseIf ::aColumns[ nCol ]:nEditMove == 0
         ::DrawSelect()
      EndIf

      If ::lAutoEdit .and. ! ::lAppendMode
         ::nKeyDown := 0
         ::DrawLine()
         ::PostMsg( WM_KEYDOWN, VK_RETURN, nMakeLong( 0, 0 ) )
         Return Nil
      Endif

   EndIf

   ::lEditing := .F.
   ::nKeyDown := 0

Return Nil

* ============================================================================
* METHOD TSBrowse:RButtonDown() Version 6.0 Apr/5/2002
* ============================================================================

METHOD RButtonDown( nRowPix, nColPix, nFlags ) CLASS TSBrowse

   Local nRow, nCol, nSkipped, oMenu, lNoEdit, ;
         lNoDelete := ! Empty( ::aSuperHead ) .or. ::lNoMoveCols

   ::SetFocus()
   ::lFirstFocus := .F.

   ::oWnd:nLastKey := 0

   If ::nLen < 1
      Return 0
   EndIf

   nRow := ::nTSBRow( nRowPix )
   nCol := ::nAtCol( nColPix )

   lNoEdit := ! ::aColumns[ nCol ]:lEdit

   If nRow > 0

      If nCol <= ::nFreeze
         Return 0
      EndIf

      ::ResetSeek()
      ::DrawLine()

      nSkipped  := ::Skip( nRow - ::nRowPos )
      ::nRowPos += nSkipped
      ::nCell := nCol

      If ! ::lNoVScroll
         ::oVScroll:SetPos( ::oVScroll:GetPos() + nSkipped )
      EndIf

      If ! ::lNoHScroll
         ::oHScroll:SetPos( ::nCell )
      EndIf

      If nSkipped != 0 .and. ::bChange != Nil
         Eval( ::bChange, Self, ::oWnd:nLastKey )
      Endif

      ::DrawSelect()

      If ::lCellBrw
         ::HiliteCell( ::nCell )
      EndIf

      If ::bRClicked != Nil
         Return Eval( ::bRClicked, nRowPix, nColPix, nFlags )
      Else
         Return 0
      EndIf

   EndIf

   If nCol <= ::nFreeze .or. ( lNoDelete .and. lNoEdit )
      Return 0
   EndIf

   MENU oMenu POPUP
      If ::lUnDo
         MENUITEM ::aMsg[ 6 ] + Space( 1 ) + ::aClipBoard[ 3 ] ;
         ACTION ( ::InsColumn( ::aClipBoard[ 2 ], ;
                               ::aClipBoard[ 1 ] ), ;
                               ::nCell := ::aClipBoard[ 2 ], ::Refresh( .T. ), ;
                               ::aClipBoard := Nil, ::lUnDo := .F. )
      Else
         MENUITEM ::aMsg[ 6 ] ACTION Nil DISABLED
      EndIf
      SEPARATOR
      MENUITEM ::aMsg[ 7 ]  ACTION ::aClipBoard := { OClone( ::aColumns[ nCol ] ), ;
                                                        nCol, ::aMsg[ 12 ] }

      If ! lNoDelete
         MENUITEM ::aMsg[ 8 ]  ACTION ( ::aClipBoard := { OClone( ::aColumns[ nCol ] ), ;
                                                           nCol, ::aMsg[ 13 ] }, ;
                                   ::DelColumn( nCol ), ::Refresh( .T. ), ;
                                   ::lUnDo := .T. )
      Else
         MENUITEM ::aMsg[ 8 ] ACTION Nil DISABLED
      EndIf

      If ::aClipBoard != Nil .and. ::aClipBoard[ 3 ] != ::aMsg[ 12 ] .and. ;
         ! lNoDelete
         MENUITEM ::aMsg[ 9 ] ACTION ( ::InsColumn( nCol, ::aClipBoard[ 1 ] ), ;
                                      ::nCell := nCol, ::Refresh( .T. ), ;
                                      ::aClipBoard := Nil, ::lUnDo := .F. )
      Else
         MENUITEM ::aMsg[ 9 ] ACTION Nil DISABLED
      EndIf

      SEPARATOR

      If ! lNoDelete
         MENUITEM ::aMsg[ 10 ]  ;
         ACTION ( ::aClipBoard := { OClone( ::aColumns[ nCol ] ), ;
                                            nCol, ::aMsg[ 12 ] }, ;
                                   ::DelColumn( nCol ), ::Refresh( .T. ), ;
                                   ::lUnDo := .T. )
      Else
         MENUITEM ::aMsg[ 10 ] ACTION Nil DISABLED
      EndIf

      If ! lNoEdit
         SEPARATOR
         MENUITEM ::aMsg[ 19 ]
            MENU
               MENUITEM ::aMsg[ 14 ] ACTION ::aColumns[ nCol ]:nEditMove := DT_MOVE_DOWN
               MENUITEM ::aMsg[ 15 ] ACTION ::aColumns[ nCol ]:nEditMove := DT_MOVE_RIGHT
               MENUITEM ::aMsg[ 16 ] ACTION ::aColumns[ nCol ]:nEditMove := DT_MOVE_UP
               MENUITEM ::aMsg[ 17 ] ACTION ::aColumns[ nCol ]:nEditMove := DT_MOVE_LEFT
               MENUITEM ::aMsg[ 18 ] ACTION ::aColumns[ nCol ]:nEditMove := DT_MOVE_NEXT
           ENDMENU
      EndIf
   ENDMENU

   ACTIVATE POPUP oMenu AT nRowPix + ::nHeightHead + 2, nColPix OF ::oWnd

Return 0

* ============================================================================
* METHOD TSBrowse:_RecCount() Version 6.0 Apr/5/2002
* ============================================================================

METHOD _RecCount() CLASS TSBrowse

   Local nLen := 0, ;
         nRecNo := ( ::cAlias )->( RecNo() )

   ::nFirstKey := 0

   Eval( ::bGoTop )

   If ! EOF() .and.  ( If( ! ::lDescend, ;
                       ( &( ( ::cAlias )->( IndexKey() ) ) <= ::uValue2 ), ;
                       ( &( ( ::cAlias )->( IndexKey() ) ) >= ::uValue2 ) ) )
      ::nFirstKey := ( ::cAlias )->( Eval( ::bKeyNo ) ) - 1
      Eval( ::bGoBottom() )
      nLen := ( ::cAlias )->( Eval( ::bKeyNo ) ) - ::nFirstKey
   EndIf

   ( ::cAlias )->( DbGoTo( nRecNo ) )

Return nLen

* ============================================================================
* METHOD TSBrowse:Report() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Report( cTitle, lPreview, oFont, nLang, cCaption, lModal ) CLASS TSBrowse

   Local oRpt, oColumn, nRecNo, nI, nAt, cType, lNoResetPos, ;
         nCols := Len( ::aColumns ), ;
         nVPos := If( ::oVScroll != Nil, ::oVScroll:GetPos(), Nil ), ;
         nRPos := ::nRowPos

   Default cTitle := ::oWnd:GetText(), ;
           lPreview := .T., ;
           cCaption := ::oWnd:GetText(), ;
           lModal := .F., ;
           oFont := ::oFont

   If ::lIsDbf
      If ::lDbfObj
         nRecNo := ::oDbf:RecNo()
      Else
         nRecNo := ( ::cAlias )->( RecNo() )
      EndIf
   EndIf

   nAt := ::nAt
   lNoResetPos := ::lNoResetPos
   ::lNoResetPos := .T.
   ::GoTop()

	If lPreview
      REPORT oRpt TITLE cTitle FONT oFont ;
      CAPTION cCaption + Space( 1 ) + ::aMsg[ 23 ] PREVIEW ;
      HEADER ::aMsg[ 20 ] + Space( 1 ) + DToC( Date() ) + " - " + ;
             ::aMsg[ 22 ] + Space( 1 ) + Time() ;
      FOOTER ::aMsg[ 21 ] + Str( oRpt:nPage, 3 ) ;
      CENTER
	Else
      REPORT oRpt TITLE cTitle CAPTION cCaption FONT oFont ;
      HEADER ::aMsg[ 20 ] + Space( 1 ) + DToC( Date() ) + " - " + ;
             ::aMsg[ 22 ] + Space( 1 ) + Time() ;
      FOOTER ::aMsg[ 21 ] + Str( oRpt:nPage, 3 ) ;
      CENTER
   EndIf

   oRpt:oDevice:lPrvModal := lModal
   oRpt:bPostEnd  := {|| ::SetFocus() }
        // best way to make sure focus get's back to where we want, not the damn WinAPI

		For nI := 1 To nCols
         If ! ::aColumns[ nI ]:lBitMap
				cType := ValType( Eval( ::aColumns[nI]:bData ) )
				oRpt:AddColumn( TrColumn():New( { GenHead( ::aColumns, nI ) },, ;
														  { GenData( ::aColumns, nI ) },, ;
                           { If( ! Empty( ::aColumns[ nI ]:cPicture), ;
                            ::aColumns[ nI ]:cPicture, "" ) },, ;
                            ( ::aColumns[ nI ]:cFooting != Nil .and. ;
                            cType == "N"),, ;  // prints footings if the column has one (numeric only)
                            If( cType $ "DN", "RIGHT", Nil ),,,, oRpt ) )

         EndIf

		Next

	END REPORT

	oRpt:bSkip := { || oRpt:Cargo := ::Skip( 1 ) }
   oRpt:Cargo := 1

	ACTIVATE REPORT oRpt ;
		WHILE If( ::cAlias == "ARRAY",;
					 oRpt:nCounter <= Max( ( Eval( ::bLogicLen ) ) - 1, 1 ),;
					 oRpt:Cargo == 1 )

   If ! ( ::cAlias == "ARRAY" ) .and. ! ( ::cAlias == "TEXT_" )
      If ::lDbfObj
         ::oDbf:GoTo( nRecNo )
		Else
			( ::cAlias )->( dbGoTo( nRecNo ) )
      EndIf

   Else
      ::GoTop()
   EndIf

   ::nRowPos := nRPos
   ::nAt := nAt
   ::lHitTop := .F.

Return Self

* ============================================================================
* METHOD TSBrowse:Reset() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Reset() CLASS TSBrowse

   Local nMin, nMax, nPage

   ::nRowPos := 1
   ::nColPos := 1

   If ! ::cAlias == "ARRAY" .and. ! ::cAlias == "TEXT_" .and. ::oTree == Nil

      If ::lFilterMode
         ::SetFilter( ::cField, ::uValue1, ::uValue2 )
      Else
         ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                       Eval( ::bLogicLen ) )
      EndIf

      If ! ::lNoVScroll
         nMin  := Min( 1, ::nLen )
         nMax  := Min( ::nLen, MAX_POS )
         nPage := Min( ::nRowCount(), ::nLen )
         ::oVScroll := TSBScrlBar():WinNew( nMin, nMax, nPage, .T., Self )
         ::oVScroll:SetRange( 1, ::nLen )
         ::oVScroll:SetPage( nPage, .T. )
      EndIf

   EndIf

   ::Refresh( .T. )

Return Self

* ============================================================================
* METHOD TSBrowse:ResetBarPos() Version 6.0 Apr/5/2002
* ============================================================================

METHOD ResetBarPos( lInit ) CLASS TSBrowse

   Local cRDDName, cType, cOrderName, cAlias, nLogicPos

   Default lInit := .F.

	If lInit
		::cDriver   := "NONE"                      // anything different from a database
      ::lClipMore := .F.
   EndIf

   If ! Empty( ::cAlias ) .and. ! ( ::cAlias == "ARRAY" ) .and. ;
         ! ( ::cAlias == "TEXT_" )

      If ::lDbfObj
         cAlias := ( ::oDbf:cAlias )
		Else
         cAlias := ::cAlias
      EndIf

      If lInit .and. ! Empty( ( cAlias )->( IndexKey( 0 ) ) )
         If ( cAlias )->( Used() )
				cRddName := ( cAlias )->( RddName() )
			Else
				cRddName := RddSetDefault()
         EndIf

         #ifdef __HARBOUR__
            cRddName := If( cRddName == "DBF", "DBFNTX", cRddName )
         #endif
//msgInfo(cRddName)
         ::bScope := {|| "" }

         If cRDDName == "COMIX"
			   ::cDriver := "COMIX"
            ::bLastTag := &( "{|| OrdSetFocus() }" )
            ::bTagOrder := &( "{ | uTag | OrdSetFocus( uTag ) }" )
            cType := Type( "cmKeyNo()" )
            If ( ::lClipMore := ( cType == "C" .or. cType == "UI" ) )
               ::bKeyNo    := &( "{|cTag| cmKeyNo( cTag ) }" )
               ::bLogicLen := If( ::lFilterMode,;
                                  {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                                  &( "{|cTag| cmKeyCount( cTag ) }" ) )
               ::bGoToPos  := &( "{|n| cmKeyGoTo( n ) }" )
               ::bScope := &( "{|x|x:=cmSetScope(0),cmSetScope(0,x)}" )
            Else
               ::bKeyNo    := &( "{|cTag| cmxKeyNo( cTag ) }" )
               ::bLogicLen := If( ::lFilterMode,;
                                  {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                                  &( "{|cTag| cmxKeyCount( cTag ) }" ) )
               ::bGoToPos  := &( "{|n| cmxKeyGoTo( n ) }" )
               ::bScope    := &( "{|x|x:=cmxSetScope(0),cmxSetScope(0,x)}" )
            EndIf
         Elseif cRDDName $ "DBFCDX_DBFCDX"

			   ::cDriver   := "CDX"
            ::bKeyNo    := &( "{|| OrdKeyNo() }" )
            ::bLogicLen := If( ::lFilterMode,;
                               {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                               &( "{|cTag| OrdKeyCount( cTag ) }" ) )
            ::bGoToPos  := &( "{|n| OrdKeyGoTo( n ) }" )
            ::bTagOrder := &( "{ | uTag | OrdSetFocus( uTag ) }" )
            ::bLastTag  := &( "{|| OrdSetFocus() }" )
            ::bScope    := &( "{|x|x:=OrdScope(0),OrdScope(0,x)}" )
         Elseif "XAX" $ cRDDName
            ::cDriver   := "ADS"
            ::bKeyNo    := &( "{|| AX_KeyNo() }" )
            ::bLogicLen := If( ::lFilterMode,;
                               {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                               &( "{|cTag| AX_KeyCount( cTag ) }" ) )
            ::bLastTag  := &( "{|| OrdSetFocus()}" )
            ::bTagOrder := &( "{|uTag| OrdSetFocus( uTag ) }" )
            ::bScope    := &( "{|| AX_SetScope(0)}" )
         Elseif "ADS" $ cRDDName
            ::cDriver   := "ADS"
            ::bKeyNo    := &( "{|| ADSKeyNo() }" )
            ::bLogicLen := If( ::lFilterMode,;
                               {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                               &( "{|cTag| ADSKeyCount( cTag,, 1 ) }" ) )
            ::bLastTag  := &( "{|| OrdSetFocus()}" )
            ::bTagOrder := &( "{|uTag| OrdSetFocus( uTag ) }" )
         Elseif cRDDName $ "DBFNSX_SIXCDX_SIXNSX_SIXMDX"
			   ::cDriver   := "NSX"
            ::bKeyNo    := &( "{|| sx_KeyNo() }" )
            ::bLogicLen := If( ::lFilterMode,;
                               {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                               &( "{|cTag| Sx_KeyCount(cTag)}" ) )
            ::bGoToPos  := &( "{|n| sx_KeyGoTo( n ) }" )
            ::bLastTag := &( "{|| OrdSetFocus() }" )
            cType := Type( "sx_SetTagO()" )
            If cType == "C" .or. cType == "UI"
               ::bTagOrder := &( "{|cTag| sx_SetTagOrder( cTag ) }" )
            Else
               ::bTagOrder := &( "{|cTag| OrdSetFocus(cTag) }" )
            EndIf

			Else    // DBFNTX considered default RDD

            // Note: Harbour/xHarbour NTX now supports ord... functions -jbott
				::cDriver   := "NTX"
            #ifdef __HARBOUR__

               ::bKeyNo    := &( "{|| OrdKeyNo() }" )
               ::bLogicLen := If( ::lFilterMode,;
                                  {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                                  &( "{|cTag| OrdKeyCount( cTag ) }" ) )
               ::bGoToPos  := &( "{|n| OrdKeyGoTo( n ) }" )
               ::bTagOrder := &( "{ | uTag | OrdSetFocus( uTag ) }" )
               ::bLastTag  := &( "{|| OrdSetFocus() }" )
               ::bScope    := &( "{|x|x:=OrdScope(0),OrdScope(0,x)}" )

            #else  // Clipper NTX

               ::bLastTag := &( "{|| OrdSetFocus() }" )
               ::bTagOrder := &( "{|uTag| OrdSetFocus(uTag) }" )
               ::bGoToPos  := Nil
               ::bLogicLen := If( ::lFilterMode,;
                                  {||(::cAlias)->(Self:RecCount(::uValue1))}, ;
                                  {||(::cAlias)->(LastRec())} )

               If "5.3" $ Version()    // In Clipper 5.3x OrdKeyNo() is supported by NTX
                  ::bKeyNo := &( "{|| OrdKeyNo() }" )
               Else
                  ::bKeyNo := {|| ( cAlias )->( NtxPos( IndexOrd(), RecNo() - If( Eof(), 1, 0 ) ) ) }
               EndIf

            #endif

            //If ::lDbfObj
               //::bLogicLen := {|| ::oDbf:RecCount() }
            //EndIf
         EndIf

      Elseif lInit .and. Empty( ( cAlias )->( IndexKey() ) )
        ::bKeyNo    := { || ( cAlias )->( Recno() ) }
        ::bLogicLen := { || ( cAlias )->( LastRec() ) }
        ::bGoToPos  := { | n | ( cAlias )->( DbGoTo( n ) ) }
        ::bTagOrder := { || Nil }
      EndIf

		cOrderName := ( cAlias )->( OrdSetFocus() )  // only used by Comix/ClipMore RDD
      nLogicPos := ( cAlias )->( Eval( ::bKeyNo, cOrderName ) )
      ::nLen := ( cAlias )->( Eval( ::bLogicLen ) )

      If ::oVScroll != Nil
         ::oVScroll:SetRange( 1, Max( 1, Min( ::nLen, MAX_POS ) ) )
			::oVScroll:SetPos( nLogicPos )
         ::oVScroll:SetPage( Min( ::nRowCount(), ::nLen ), .T. )
      EndIf

      If nLogicPos > 0 .and. nLogicPos < ::nRowPos
         ::nRowPos := nLogicPos
      EndIf

   EndIf

Return Self


* ============================================================================
* METHOD TSBrowse:ResetSeek() Version 6.0 Apr/5/2002
* ============================================================================

METHOD ResetSeek() CLASS TSBrowse

   Local oColumn

   If ::nColOrder > 0
      If ::cOrderType == "D"
         ::cSeek := "  /  /    "
      Else
         ::cSeek := ""
      EndIf
   EndIf

   If ::bSeekChange != Nil
      Eval( ::bSeekChange )
   EndIf

Return ::cSeek

* ============================================================================
* METHOD TSBrowse:ReSize() Version 6.0 Apr/5/2002
* ============================================================================

METHOD ReSize( nSizeType, nWidth, nHeight ) CLASS TSBrowse

   ::nRowPos := Min( ::nRowPos, Max( ::nRowCount(), 1 ) )

Return Super:ReSize( nSizeType, nWidth, nHeight )

* ============================================================================
* METHOD TSBrowse:Seek() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Seek( nKey ) CLASS TSBrowse

    Local oColumn, nIdxLen, cPrefix, ;
          nLines    := ::nRowCount(), ;
          lFound    := .T., ;
          lEoF      := .F., ;
          lTrySeek  := .T., ;
          nRecNo    := 0, ;
          cSeek     := ::cSeek, ;
          xSeek     := cSeek

   If ( Seconds() - nLapsus ) > 5 .or. ( Seconds() - nLapsus ) < 0
      ::cSeek := cSeek := ""
   EndIf

   nLapsus := Seconds()

   cPrefix := If( ::cPrefix == Nil, "", If( ValType( ::cPrefix ) == "B", ;
                  Eval( ::cPrefix ), ::cPrefix ) )

   If ::nColOrder > 0 .and. ::lIsDbf
      lTrySeek := .T.

      If ::cOrderType == "C"
         If ::lDbfObj
            nIdxLen := ( ::oDbf:cAlias )->( Len( Eval( &( "{||" + OrdKey() + "}" ) ) )  )
         Else
            nIdxLen := ( ::cAlias )->( Len( Eval( &( "{||" + OrdKey() + "}" ) ) ) )
         EndIf
      EndIf

      If nKey == VK_BACK
         If ::cOrderType == "D"
            cSeek := DateSeek( cSeek, nKey )
         Else
            cSeek := Left( cSeek, Len( cSeek ) - 1 )
         EndIf
      Else
         If ::cOrderType == "D"
            cSeek := DateSeek( cSeek, nKey )
         ElseIf ::cOrderType == "N"
            /* only  0..9, minus and dot*/
            If ( nKey >= 48 .and. nKey <= 57 ) .or. ( nKey >= 45 .or. ;
                 nKey <= 46 )
                cSeek += Chr( nKey )
            Else
               Tone( 500, 1 )
               lTrySeek := .F.
            EndIf
         ElseIf ::cOrderType == "C"
            If Len( cSeek ) < nIdxLen
               cSeek += If( ::lUpperSeek, Upper( Chr( nKey ) ), Chr( nKey ) )
            Else
               Tone( 500, 1 )
               lTrySeek := .F.
            EndIf
         EndIf
      EndIf

      If ::cOrderType == "C"
         xSeek := cPrefix + cSeek
      ElseIf ::cOrderType == "N"
         xSeek := Val( cSeek )
      ElseIf ::cOrderType == "D"
         xSeek := cPrefix + DToS( CToD( cSeek ) )
      Else
         xSeek := cPrefix + cSeek
      EndIf

      If ! ( ::cOrderType == "D" .and. Len( RTrim( cSeek ) ) < Len( DToC( Date() ) ) ) ;
         .and. lTrySeek
         If ::lDbfObj
            nRecNo := ::oDbf:RecNo()
            lFound := ::oDbf:Seek( xSeek, .T. )
            lEof   := ::oDbf:Eof()

            If lEof .or. ( ::cOrderType == "C" .and. ! lFound )
               ::oDBf:GoTo( nRecNo )
            EndIf
         Else
            nRecNo := ( ::cAlias )->( RecNo() )
            lFound := ( ::cAlias )->( DbSeek( xSeek, .T. ) )
            lEoF   := ( ::cAlias )->( Eof() )

            If lEoF .or. ( ::cOrderType == "C" .and. ! lFound )
               ( ::cAlias )->( dbGoTo( nRecNo ) )
            EndIf
         EndIf

         If ( ::cOrderType == "C" .and. ! lFound ) .or. lEof

            Tone( 500, 1 )

            If ::cOrderType == "D"
               ::cSeek := DateSeek( cSeek, VK_BACK )
            Else
               ::cSeek := Left( cSeek, Len( cSeek ) - 1 )
            EndIf

            Return Self

         ElseIf ! lFound

            If ::cOrderType == "N"
               ( ::cAlias )->( DbSeek( Val( cSeek ) * 10, .T. ) )
               xSeek := ( ::cAlias )->( Eval( &( "{||" + OrdKey(0) + "}" ) ) )
               xSeek := Val( Right( LTrim( Str( xSeek ) ), Len( cSeek ) + 1 ) )
               If xSeek > ( ( Val( cSeek ) * 10 ) + 9 )
                  Tone( 500, 1 )
                  ( ::cAlias )->( dbGoTo( nRecNo ) )
                  ::cSeek := Left( cSeek, Len( cSeek ) - 1 )
                  ( ::cAlias )->( DbGoto( nRecNo ) )
                  Return Self
               EndIf
            EndIf

            ::cSeek := cSeek
            ( ::cAlias )->( DbGoto( nRecNo ) )
            Return Self

         Else
            // only refresh if record pointer was moved
            If ::lDbfObj
               If nRecNo != ::oDbf:RecNo()
                  ::Refresh( .F. )
                  If ::nLastPainted < ::nRowCount()
                     ::Refresh( .T. )
                  EndIf
						::ResetBarPos()
               EndIf
            Else
               If nRecNo != ( ::cAlias )->( RecNo() ) .and. ::nLen > nLines
                  nRecNo := ( ::cAlias )->( RecNo() )
                  ( ::cAlias )->( DbSkip( nLines - ::nRowPos ) )
                  If EoF()
                     Eval( ::bGoBottom )
                     ::nRowPos := nLines
                     While ::nRowPos > 1 .and. ( ::cAlias )->( RecNo() ) != nRecNo
                        ::Skip( -1 )
                        ::nRowPos --
                     EndDo
                  Else
                     ( ::cAlias )->( DbGoto( nRecNo ) )
                  EndIf
                  ::Refresh( .F. )
                  ::ResetBarPos()
               ElseIf nRecNo != ( ::cAlias )->( RecNo() )
                  nRecNo := ( ::cAlias )->( RecNo() )
                  Eval( ::bGoTop )
                  ::nAt := ::nRowPos := 1
                  While nRecNo != ( ::cAlias )->( RecNo() )
                     ::Skip( 1 )
                     ::nRowPos++
                  EndDo
                  ::Refresh( .F. )
                  ::ResetBarPos()
               EndIf
            EndIf

            If ::bChange != Nil
               Eval( ::bChange, Self, 0 )
            EndIf

         EndIf
      EndIf

      ::cSeek := cSeek

      If ::oCtx != Nil
         ::oCtx:Save()
      EndIf

      If ::bSeekChange != Nil
         Eval( ::bSeekChange )
      EndIf

   EndIf

   If ! lTrySeek
      ::ResetSeek()
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetAlign() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetAlign( nColumn, nLevel, nAlign ) CLASS TSBrowse

   Default nColumn := 0, ;
            nLevel := 0, ;
            nAlign := DT_LEFT

   If nColumn > 0
      If nLevel > 0
         Do Case
            Case nLevel = 1
               ::aColumns[ nColumn ]:nAlign := nAlign
            Case nLevel = 2
               ::aColumns[ nColumn ]:nHAlign := nAlign
            Otherwise
               ::aColumns[ nColumn ]:nFAlign := nAlign
         EndCase
      Else
         ::aColumns[ nColumn ]:nAlign := ::aColumns[ nColumn ]:nHAlign := ;
         ::aColumns[ nColumn ]:nFAlign := nAlign
      EndIf
   Else
      If nLevel > 0
         AEval( ::aColumns, { | oCol | If( nLevel = 1, oCol:nAlign := nAlign, ;
                                       If( nLevel = 2, oCol:nHAlign := nAlign, ;
                                           oCol:nFAlign := nAlign ) ) } )
      Else
         AEval( ::aColumns, { | oCol | oCol:nAlign := nAlign, ;
                                       oCol:nHAlign := nAlign, ;
                                       oCol:nFAlign := nAlign } )
      EndIf
   EndIf

   ::Refresh( .T. )

Return Self

* ============================================================================
* METHOD TSBrowse:SetAppendMode() Version 6.0 Apr/5/2002
* Enables append mode in TSBrowse for DBF's and arrays.
* At least one column in TSBrowse must have oCol:lEdit set to TRUE in order
* to work and like direct cell editing.
* ============================================================================

METHOD SetAppendMode( lMode ) CLASS TSBrowse

   Local lPrevMode := ::lCanAppend

   Default lMode := ! ::lCanAppend

   If ! Empty( ::cAlias ) .and. ! ( ::cAlias == "TEXT_" )
      ::lCanAppend := lMode
   EndIf

Return lPrevMode

* ============================================================================
* METHOD TSBrowse:SetArray() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetArray( aArray ) CLASS TSBrowse

   Local nColumns, nI, cType, nMin, nMax, nPage

   DEFAULT aArray := {}

   ::aArray    := aArray

   //            default values for array elements used during append mode
   //            The user MUST AIns() as element no. 1 to ::aDefValue
   //            a nil value when using the actual elemnt no (::nAt)
   //            when browsing arrays like this:
   //            AIns( ASize( ::aDefValue, Len( ::aDefValue ) + 1 ), 1 )
   //            AFTER calling ::SetArray()

   nColumns    := If( ! Empty( aArray ), Len( aArray[ 1 ] ), 0 )
   ::aDefValue := Array( nColumns )

   For nI := 1 To nColumns
      cType := ValType( ::aArray[ 1, nI ] )
      If cType $ "CM"
         ::aDefValue[ nI ] := Space( Len( ::aArray[ 1, nI ] ) )
      ElseIf cType == "N"
         ::aDefValue[ nI ] := 0
      ElseIf cType == "D"
         ::aDefValue[ nI ] := CToD( "" )
      ElseIf cType == "L"
         ::aDefValue[ nI ] := .F.
      Else                                // arrays, objects and codeblocks not allowed
         ::aDefValue[ nI ] := "???"       // not user editable data type
      EndIf
   Next

   ::nAt       := 1
   ::bKeyNo    := { || ::nAt }
   ::cAlias    := "ARRAY"  // don't change name, used in method Default()
   ::nLen := Eval( ::bLogicLen := { || Len( ::aArray ) + If( ::lAppendMode, 1, 0 ) } )
   ::bGoTop    := { || ::nAt := 1 }
   ::bGoBottom := { || ::nAt := Eval( ::bLogicLen ) }
   ::bSkip     := { | nSkip, nOld | nOld := ::nAt, ::nAt += nSkip,;
                   ::nAt := Min( Max( ::nAt, 1 ), Eval( ::bLogicLen ) ),;
                   ::nAt - nOld }

   ::lHitTop    := .F.
   ::lHitBottom := .F.
   ::nRowPos := 1
   ::nColPos := 1
	::nCell   := 1
	::HiliteCell(1)

   If ! ::lNoVScroll
      nMin  := Min( 1, ::nLen )
      nMax  := ::nLen
      nPage := Min( ::nRowCount(), ::nLen )
      ::oVScroll := TSBScrlBar():WinNew( nMin, nMax, nPage, .T., Self )
      ::oVScroll:SetPage( nPage, .T. )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetColor() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetColor( xColor1, xColor2, nColumn ) CLASS TSBrowse

   Local nEle, nI

   Default xColor1 := {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15}, ;
           nColumn := 0

   If ( Empty( ::aColumns ) .and. nColumn > 0 )
      Return nil
   End

   If Valtype( xColor1 ) == "N" .and. Valtype( xColor2 ) == "N" .and. nColumn == 0
      Return Super:SetColor( xColor1, xColor2 )  // FW SetColor Method only nClrText and nClrPane
   EndIf

   If Len( ::aColumns ) == 0 .and. ::oBrush == Nil
      ::oBrush := TBrush():New( , xColor2[ 2 ] )
   EndIf

   If nColumn == 0 .and. ValType ( xColor2[ 1 ] ) == "N" .and. ;
      ValType( xColor1 ) == "A" .and. xColor1[ 1 ] == 1 .and. ;
      Len( xColor1 ) > 1 .and. ValType( xColor2 ) == "A" .and. ;
      ValType( xColor2[ 2 ] ) == "N" .and. xColor1[ 2 ] == 2

      Super:SetColor( xColor2[ 1 ], xColor2[ 2 ] )

   EndIf

   If Valtype( xColor1 ) == "N"
      xColor1 := { xColor1 }
      xColor2 := { xcolor2 }
   EndIf

   For nEle := 1 TO Len( xColor1 )
      Do Case
         Case xColor1[ nEle ] == 1
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFore := xColor2[ nEle ]
               Next
               ::nClrText := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrFore := xColor2[ nEle ]
            EndIf
         Case xColor1[ nEle ] == 2
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrBack := xColor2[ nEle ]
               Next
               ::nClrPane := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrBack := xColor2[ nEle ]
            EndIf
         Case xColor1[ nEle ] == 3
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrHeadFore := xColor2[ nEle ]
               Next
               ::nClrHeadFore := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrHeadFore := xColor2[ nEle ]
            EndIf
         Case xColor1[ nEle ] == 4
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrHeadBack := xColor2[ nEle ]
               Next
               ::nClrHeadBack := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrHeadBack := xColor2[ nEle ]
            EndIf
         Case xColor1[ nEle ] == 5
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFocuFore := xColor2[ nEle ]
               Next
               ::nClrFocuFore := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrFocuFore := xColor2[ nEle ]
            EndIf
         Case xColor1[ nEle ] == 6
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFocuBack := xColor2[ nEle ]
               Next
               ::nClrFocuBack := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrFocuBack := xColor2[ nEle ]
            EndIf
         Case xColor1[ nEle ] == 7
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrEditFore := xColor2[ nEle ]
               Next
               ::nClrEditFore := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrEditFore := xColor2[ nEle ]
            EndIf
         Case xColor1[ nEle ] == 8
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrEditBack := xColor2[ nEle ]
               Next
               ::nClrEditBack := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrEditBack := xColor2[ nEle ]
            EndIf
         Case xColor1[ nEle ] == 9
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFootFore := xColor2[ nEle ]
               Next
               ::nClrFootFore := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrFootFore := xColor2[ nEle ]
            EndIf
         Case xColor1[ nEle ] == 10
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrFootBack := xColor2[ nEle ]
               Next
               ::nClrFootBack := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrFootBack := xColor2[ nEle ]
            EndIf
         Case xColor1[ nEle ] == 11
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrSeleFore := xColor2[ nEle ]
               Next
               ::nClrSeleFore := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrSeleFore := xColor2[ nEle ]
            EndIf
         Case xColor1[ nEle ] == 12
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrSeleBack := xColor2[ nEle ]
               Next
               ::nClrSeleBack := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrSeleBack := xColor2[ nEle ]
            EndIf
         Case xColor1[ nEle ] == 13
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrOrdeFore := xColor2[ nEle ]
               Next
               ::nClrOrdeFore := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrOrdeFore := xColor2[ nEle ]
            EndIf
         Case xColor1[ nEle ] == 14
            If nColumn == 0
               For nI := 1 TO Len( ::aColumns )
                   ::aColumns[ nI ]:nClrOrdeBack := xColor2[ nEle ]
               Next
               ::nClrOrdeBack := xColor2[ nEle ]
            Else
               ::aColumns[ nColumn ]:nClrOrdeBack := xColor2[ nEle ]
            EndIf
         Otherwise
            ::nClrLine := xColor2[ nEle ]
      EndCase
   Next

   ::Refresh( .T. )

Return 0

* ============================================================================
* METHOD TSBrowse:SetCols() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetColumns( aData, aHeaders, aColSizes ) CLASS TSBrowse

   Local aFields , nElements, n

   nElements   := Len( aData )

   ::aHeaders  := If( aHeaders  != Nil, aHeaders, ::aHeaders )
   ::aColSizes := If( aColSizes != Nil, aColSizes, {} )
   ::bLine     := {|| _aData( aData ) }
   ::aJustify  := AFill( Array( nElements ), .F. )

   If Len( ::GetColSizes() ) < nElements
      ::aColSizes := AFill( Array( nElements ), 0 )
      aFields := Eval( ::bLine )

      For n := 1 to nElements
          ::aColSizes[ n ] := If( ValType( aFields[ n ] ) != "C",;
                                   15,; // Bitmap handle
                                   GetTextWidth( 0, Replicate( "B", ;
                                   Max( Len( ::aHeaders[ n ] ), ;
                                        Len( aFields[ n ] ) ) + 1 ),;
                                   If( ! Empty( ::oFont ), ::oFont:hFont,) ) )
      Next
   EndIf

   If ::oHScroll != nil
      ::oHScroll:nMax := ::GetColSizes()
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetData() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetData( nColumn, bData, aList ) CLASS TSBrowse

   If Valtype( nColumn ) != "N" .or. nColumn <= 0
      Return Nil
   EndIf

   If bData != Nil
      If Valtype( bData ) == "B"
         ::aColumns[ nColumn ]:bData := bData
      Else
         ::aColumns[ nColumn ]:bData := { || bData }
      EndIf
   EndIf

   If aList != Nil
      ::aColumns[ nColumn ]:aList := aList
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetFilter() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetFilter( cField, uVal1, uVal2 ) CLASS TSBrowse

   Local cIndexType, cAlias, ;
         lWasFiltered := ::lFilterMode

   Default uVal2 := uVal1

   ::cField      := cField
   ::uValue1     := uVal1
   ::uValue2     := uVal2
   ::lFilterMode := ( uVal1 != Nil )

   If ::lDbfObj
      cAlias := ( ::oDbf:cAlias )
   Else
      cAlias := ::cAlias
   EndIf

   If ::lFilterMode
      ::lDescend := ::uValue2 < ::uValue1 // "DESCEND" $ Upper( ( cAlias )->( IndexKey( 0 ) ) )

      cIndexType := ( cAlias )->( ValType( &( IndexKey() ) ) )

      If ( ::cAlias )->( ValType( &cField ) ) != cIndexType .or. ;
         ValType( uVal1 ) != cIndexType .or. ;
         ValType( uVal2 ) != cIndexType

         MsgInfo( ::aMsg[ 27 ], ::aMsg[ 28 ] )

         ::lFilterMode := .F.

      EndIf

   EndIf

   // Posibility of using FILTERs based on INDEXES!!!
   ::bGoTop := If( ::lFilterMode, {|| ( cAlias )->( DbSeek( ::uValue1, .T. ) ) },;
                                      {|| ( cAlias )->( DbGoTop() ) } )

   ::bGoBottom := If( ::lFilterMode, {|| BrwGoBottom( uVal2, Self ) },;
                                      {|| ( cAlias )->( DbGoBottom() ) } )

   ::bSkip := If( ::lFilterMode, BuildSkip( ::cAlias, cField, uVal1, uVal2, Self ),;
					                       {| n | ::dbSkipper( n ) } )

   ::ResetBarPos( .T. )

   ::lHitTop    := .f.
   ::lHitBottom := .f.

   If ::lFilterMode .OR. lWasFiltered
      ::GoTop()
   EndIf

Return nil

* ============================================================================
* METHOD TSBrowse:SetIndexCols() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetIndexCols( nCol1, nCol2, nCol3, nCol4, nCol5 ) CLASS TSBrowse

   Local aCol

   Default nCol2 := 0, nCol3 := 0, nCol4 := 0, nCol5 := 0

   If Valtype( nCol1 ) == "A"
      AEval( nCol1, { | nCol | ::aColumns[ nCol ]:lIndexCol := .T. } )
   Else
      aCol := { nCol1, nCol2, nCol3, nCol4, nCol5 }
      AEval( aCol, { | nCol | If( nCol > 0, ;
                                 ::aColumns[ nCol ]:lIndexCol := .T., Nil ) } )
   EndIf

Return Nil

* ============================================================================
* METHOD TSBrowse:SetoDbf() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetoDbf( oDbf ) CLASS TSBrowse

   ::oDbf := oDbf

   If Upper( oDbf:ClassName() )== "TMULTIDBF"
     // setup for the parent as the controlling oDbf
     ::oCtx := oDbf:oCtx
     ::oDbf:oParent:bBof := {||Nil}
     ::oDbf:oParent:bEof := {||Nil}
     ::oDbf:oParent:bNetError := {||Nil}
   Else
     ::oDbf:bBof := {||Nil}
     ::oDbf:bEof := {||Nil}
     ::oDbf:bNetError := {||Nil}
   EndIf

   ::nRowPos    := 1  // reinitialize for multiple calls to this method
   ::nColPos    := 1
   ::nCell      := 1
   ::lHitTop    := .F.
   ::lHitBottom := .F.
   ::cAlias     := oDbf:cAlias
   ::lDbfObj    := .T.
   ::HiliteCell( 1 )

   //::bLogicLen := {|| ::oDbf:RecCount() }
   ::bLogicLen := {|| (::cAlias)->(ordkeycount()) }
   ::bGoTop    := {|| ::oDbf:GoTop() }
   ::bGoBottom := {|| ::oDbf:GoBottom() }
   ::bSkip     := {| nSkip | ::oDbf:Skipper( nSkip ) }

Return Self

* ============================================================================
* METHOD TSBrowse:SetOrder() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetOrder( nColumn, cPrefix ) CLASS TSBrowse

   Local nDotPos, cAlias, ;
         lReturn := .F., ;
         oColumn := ::aColumns[ nColumn ]

   If ! Empty( oColumn:cOrder ) .and. ::lIsDbf .and. nColumn != ::nColOrder

      cAlias := If( ::lDbfObj, ::oDbf:cAlias, ::cAlias )

      If ::cDriver == Nil
         ::ResetBarPos( .T. )     // dialogs initialize differently from windows!?
      EndIf

      If ( nDotPos := At( ".", oColumn:cOrder ) ) > 0 // in case TAG has an extension (ie .NTX)
			oColumn:cOrder := SubStr( oColumn:cOrder, 1, nDotPos - 1 )
      EndIf

      If ::lDbfObj
         If ::cDriver == "NSX"
            ( cAlias )->( Eval( ::bTagOrder, oColumn:cOrder ) )
			Else
			   ::oDbf:SetOrder( oColumn:cOrder )
         EndIf
		Else
         ( cAlias )->( Eval( ::bTagOrder, oColumn:cOrder ) )
      EndIf

      If Empty( ( cAlias )->( OrdSetFocus() ) )
		   ::cOrderType := ""
		Else
         ::cOrderType := ( cAlias )->( ValType( Eval( &( "{||" + OrdKey() + "}" ) ) ) )
      EndIf

      If ::oCtx != Nil
		   ::oCtx:ReNew()
      EndIf

      If( ! ::lDbfObj, ::UpStable(), Nil )    // ::UpStable() won't work with DBFOBJECT

      ::Refresh()
      ::ResetBarPos()
      ::nColOrder := nColumn
      ::ResetSeek()

      If ::bSetOrder != Nil
         Eval( ::bSetOrder, Self, ( cAlias )->( Eval( ::bTagOrder ) ) )
      EndIf

      ::SetFocus()
      lReturn := .T.

      If cPrefix != Nil
         ::cPrefix := cPrefix
      EndIf

   EndIf

Return lReturn

* ============================================================================
* METHOD TSBrowse:SetDeleteMode() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetDeleteMode( lOnOff, lConfirm, bDelete, bPostDel ) CLASS TSBrowse

   Default lOnOff   := .T., ;
           lConfirm := .T.

   ::lCanDelete := lOnOff
   ::lConfirm   := lConfirm
   ::bDelete    := bDelete
   ::bPostDel   := bPostDel

Return Self

* ============================================================================
* METHOD TSBrowse:SetHeaders() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetHeaders( nHeight, aCols, aTitles, aAlign , al3DLook, aFonts, ;
                   aActions ) CLASS TSBrowse

   Local nI

   If nHeight != Nil
      ::nHeightHead := nHeight
   EndIf

   If aCols == Nil

      aCols := {}

      Do Case

         Case aTitles != Nil
            For nI := 1 TO Len( aTitles )
                AAdd( aCols, nI )
            Next

         Case aAlign != Nil
            For nI := 1 TO Len( aAlign )
                AAdd( aCols, nI )
            Next

         Case al3DLook != Nil
            For nI := 1 TO Len( al3DLook )
                AAdd( aCols, nI )
            Next

         Case aFonts != Nil
            For nI := 1 TO Len( aFonts )
                AAdd( aCols, nI )
            Next

         Case aActions != Nil
            For nI := 1 TO Len( aActions )
                AAdd( aCols, nI )
            Next

         Otherwise
            Return Nil
      EndCase

   EndIf

   For nI := 1 TO Len( aCols )

      If aTitles != Nil
         ::aColumns[ aCols[ nI ] ]:cHeading := aTitles[ nI ]
      EndIf

      If aAlign != Nil
         ::aColumns[ aCols[ nI ] ]:nHAlign := aAlign[ nI ]
      EndIf

      If al3DLook != Nil
         ::aColumns[ aCols[ nI ] ]:l3DLookHead := al3DLook[ nI ]
      EndIf

      If aFonts != Nil
         ::aColumns[ aCols[ nI ] ]:cHeading := aFonts[ nI ]
      EndIf

      If aActions != Nil
         ::aColumns[ aCols[ nI ] ]:bAction := aActions[ nI ]
      EndIf

   Next

   ::DrawHeaders()

Return Self

* ============================================================================
* METHOD TSBrowse:SetColSize() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetColSize( nCol, nWidth ) CLASS TSBrowse

   Local nI, nSize

   If ValType( nCol ) == "A"
      For nI := 1 TO Len( nCol )
          nSize := If( ValType( nWidth ) == "A", nWidth[ nI ], nWidth )
          ::aColumns[ nCol[ nI ] ]:nWidth := nSize
          ::aColSizes[ nCol[ nI ] ] := ::aColumns[ nCol[ nI ] ]:nWidth
      Next
   Else
      ::aColumns[ nCol ]:nWidth := nWidth
      ::aColSizes[ nCol ] := ::aColumns[ nCol ]:nWidth
   EndIf

   If ::lPainted
      ::Refresh( .T. )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetTree() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetTree( oTree ) CLASS TSBrowse

   Local oItem := oTree:oFirst

   ::lMChange   := .F.
   ::bKeyNo     := { || ::nAt }
   ::bLine      := { || oItem:GetLabel() }
   ::aColSizes  := { || oItem:ColSizes() }
   ::bGoTop     := { || oItem := oTree:oFirst }
   ::bGoBottom  := { || oItem := oTree:GetLast() }
   ::bSkip      := { | n | oItem := oItem:Skip( @n ), ::nAt += n, ::oTree := oItem, n }
   ::bLogicLen  := { || ::nLen := oTree:nCount() }
   ::bLDblClick := { || If( oItem:oTree != nil,;
                          ( oItem:Toggle(), ::Refresh() ),) }
   ::oTree      := oItem
   ::bKeyChar   := { | nKey | If( nKey == VK_RETURN .and. oItem:oTree != nil,;
                          ( oItem:Toggle(), ::Refresh() ),) }

   If ::oHScroll != nil
      ::oHScroll := nil
      ::lNoHScroll := .T.
   EndIf

   oTree:Draw()

Return Self

* ============================================================================
* METHOD TSBrowse:SetTxtFile() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetTxtFile( uTxtFile, cTitle, lOemToAnsi ) CLASS TSBrowse

   Default lOemToAnsi := .F.

   If ValType( uTxtFile ) = "C"
      If ! File( uTxtFile )
         MsgStop( ::aMsg[ 29 ] + Space( 1 ) + uTxtFile + Space( 1 ) + ;
                  ::aMsg[ 30 ], ::aMsg[ 28 ] )
         Return Nil
      EndIf
      ::oTxtFile := TTxtFile():New(uTxtFile, 0)
   Else   // is a TTxtFile object
      ::oTxtFile := uTxtFile
   EndIf

   ::oTxtFile:nTLines ++         // for the last CRLF at eof()
   ::nOffset := 1                    // we'll use this as an offset marker

   ::AddColumn( TSColumn():New( cTitle, ;
       If( lOemToAnsi, {|| OemToAnsi( SubStr( ::oTxtFile:ReadLine(), ::nOffset ) ) }, ;
           {|| SubStr( ::oTxtFile:ReadLine(), ::nOffset ) } ),, ;
           {::nClrText,::nClrPane},, 1024 ) )


   ::lGridLine := .F.                            // don't want gridlines with text files
	::cAlias    := "TEXT_"                        // don't change this identifier
   ::bKeyNo    := {|| ::nAt }
   ::nLen      := Eval( ::bLogicLen := {|| ::oTxtFile:LastRec() } )
   ::bGoTop    := {|| ::oTxtFile:GoTop() }
   ::bGoBottom := {|| ::oTxtFile:GoBottom() }
   ::bSkip     := {|nSkip, nOld| nOld := ::oTxtFile:RecNo(),;
                   ::oTxtFile:Skip( nSkip ), ::nAt := ::oTxtFile:RecNo(), ;
                   ::oTxtFile:RecNo() - nOld }

   ::nRowPos := ::nAt := 1                                // reinitialize for multiple calls to this method
	::nColPos := 1
	::nCell   := 1
   ::HiliteCell( 1 )

Return Self

* ============================================================================
* METHOD TSBrowse:ShowSizes() Version 6.0 Apr/5/2002
* ============================================================================

METHOD ShowSizes() CLASS TSBrowse

   Local cText  := "", ;
         nTotal := 0, ;
         aTemp  := ::GetColSizes()

   AEval( aTemp, ;
          { | e, n | nTotal += e, ;
                     cText += ( If( ValType( ::aColumns[ n ]:cHeading ) == "C", ;
                     ::aColumns[ n ]:cHeading, ::aMsg[ 24 ] + Space( 1 ) + ;
                     Ltrim( Str( n ) ) ) + ": " + Str( e, 3 ) + ;
                     " Pixels" + CRLF ) } )

   cText += CRLF + "Total " + Str( nTotal, 4 ) + " Pixels" + CRLF + ;
            ::aMsg[ 25 ] + Space( 1) + Str( ::nWidth(), 4 ) + " Pixels" + CRLF

   MsgInfo( cText, ::aMsg[ 26 ] )

Return Self

* ============================================================================
* METHOD TSBrowse:Skip() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Skip( n ) CLASS TSBrowse

   If ::bSkip != Nil
      Return Eval( ::bSkip, n )
   EndIf

Return ::dbSkipper( n )

* ============================================================================
* METHOD TSBrowse:SwitchCols() Version 6.0 Apr/5/2002
* This method is dedicated to John Stolte by the 'arry
* ============================================================================

METHOD SwitchCols( nCol1, nCol2 ) CLASS TSBrowse

   Local oHolder, nHolder, nMaxCol := Len(::aColumns)

   If nCol1 > ::nFreeze .and. nCol2 > ::nFreeze .and. ;
      nCol1 <= nMaxCol .and. nCol2 <= nMaxCol

      oHolder := ::aColumns[ nCol1 ]
      nHolder := ::aColSizes[ nCol1 ]

      ::aColumns[ nCol1 ]  := ::aColumns[ nCol2 ]
      ::aColSizes[ nCol1 ] := ::aColSizes[ nCol2 ]

      ::aColumns[ nCol2 ]  := oHolder
      ::aColSizes[ nCol2 ] := nHolder

      If ::nColOrder == nCol1
         ::nColOrder := nCol2
      EndIf

   EndIf

   If ::lPainted
      ::Refresh( .F. )
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SyncChild() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SyncChild( aoChildBrw, abAction ) CLASS TSBrowse

   If aoChildBrw != Nil
		If ValType( aoChildBrw ) == "O"
			aoChildBrw := { aoChildBrw }
      EndIf

      Default abAction := Array( Len( aoChildBrw ) )

      If ValType( abAction ) == "B"
			abAction := { abAction }
      EndIf

      ::bChange := {|| ;
                       AEval( aoChildBrw, {|oChild,nI| If( ! Empty( oChild:cAlias ),;
                       ( oChild:lHitTop := .F., oChild:goTop(),;
                       If( abAction[nI] != Nil, Eval( abAction[nI], Self, oChild ), Nil ),;
                       oChild:reset() ), Nil ) } ) }
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:UpStable() Version 6.0 Apr/5/2002
* ============================================================================

METHOD UpStable() CLASS TSBrowse

   Local nRow := ::nRowPos, ;
         nRecNo := ( ::cAlias )->( RecNo() ), ;
         nRows := ::nRowCount(), ;
         n := 1, ;
         lSkip  := .T.

   If ::nLen > nRows

      ( ::cAlias )->( DbSkip( nRows - nRow ) )

      If EoF()
         Eval( ::bGoBottom )
         ::nRowPos := nRows
         While ::nRowPos > 1 .and. ( ::cAlias )->( RecNo() ) != nRecNo
            ::Skip( -1 )
            ::nRowPos --
         EndDo
         ::Refresh( .F. )
         ::ResetBarPos()
         Return Self
      Else
         ( ::cAlias )->( DbGoto( nRecNo ) )
      EndIf

   EndIf

   ::nRowPos    := 1
   ::GoTop()
   ::lHitTop    := .F.
   ::lHitBottom := .F.

   While ! ( ::cAlias )->( EoF() )

      If n > nRows
         ::nRowPos := nRow
         lSkip     := .F.
         Exit
      EndIf

      If nRecNo == ( ::cAlias )->( RecNo() )
         ::nRowPos := n
         Exit
      Else
         ::Skip( 1 )
      EndIf
      n++
   Enddo

   If lSkip
      ::Skip( -::nRowPos )
   EndIf

   ( ::cAlias )->( DbGoTo( nRecNo ) )                // restores Record position

   If ::oVScroll != Nil .and. ! Empty( ::bKeyNo )     // restore scrollbar thumb
      ::oVScroll:SetPos( ( ::cAlias )->( Eval( ::bKeyNo ) ) )
   EndIf

   If ::bChange != nil
      Eval( ::bChange, Self, ::oWnd:nLastKey )
   EndIf

   ::Refresh( If( ::nLen < nRows, .T., .F. ) )

Return Self

* ============================================================================
* METHOD TSBrowse:VertLine() Version 6.0 Apr/5/2002
* Thanks to Gianni Santamarina
* ============================================================================

METHOD VertLine( nColPixPos, nColInit, nGapp ) CLASS TSBrowse

   Local oRect := ::GetRect(), ;
         nRighe := 1, ;
         hRighe := GetTextHeight( ::hWnd, ::hDC ), ;
         bDestroy := If( ::lIsV22, { |o| o:DestroyToolTip() }, {||Nil} )

   If nColInit != Nil
      nsCol := nColInit
      nsWidth := nColPixPos
      nsOldPixPos := 0
      nGap := If( ! Empty( nGapp ), nGapp, 0)
      ::ncMouseMove()
      ::GetDC()
      InvertRect( ::hDC, { 0, nsWidth - ::aColSizes[ nsCol ] - 2, oRect:nBottom, nsWidth -	::aColSizes[ nsCol ] + 2} )
      ::ReleaseDC()
   EndIf

   If nColPixPos == Nil .and. nColInit == Nil   // We have finish draging
      ::aColSizes[ nsCol ] -= ( nsWidth - nsOldPixPos )
      ::aColumns[ nsCol ]:nWidth -= ( nsWidth - nsOldPixPos )
      ::ncMouseMove()
      ::Refresh()
   EndIf

   oRect := ::GetRect()
   ::GetDC()

   If nsOldPixPos != 0 .and. nColPixPos != nsOldPixPos
      InvertRect( ::hDC, { 0, nsOldPixPos - 2, oRect:nBottom, nsOldPixPos + 2 } )
      nsOldPixPos := 0
   EndIf

   If nColPixPos != Nil .and. nColPixPos != nsOldPixPos // ( nColPixPos - 2 ) > 0
      nColPixPos := Max( nColPixPos, 10 )
      Eval( bDestroy, Self )
      ::ShowToolTip( -( nRighe * hRighe ), nsWidth, ::aMsg[ 31 ] + ;
         PadL(::aColSizes[ nsCol ] - ( nsWidth - nColPixPos - nGap),5) )
      InvertRect( ::hDC, { 0, nColPixPos - 2 + nGap, oRect:nBottom, nColPixPos + 2 + nGap} )
      nsOldPixPos := nColPixPos + nGap
   EndIf

   ::ReleaseDC()

Return Nil

* ============================================================================
* METHOD TSBrowse:VScroll() Version 6.0 Apr/5/2002
* ============================================================================

METHOD VScroll( nWParam, nLParam ) CLASS TSBrowse

   Local nLen, nSkipped, nActualPos, nBottomPos, ;
         nLines := Min( ::nLen, ::nRowCount() )

   #ifdef __CLIPPER__
      local nScrHandle  := nHiWord( nLParam )
      local nScrollCode := nWParam
      local nPos        := nLoWord( nLParam )
   #else
      local nScrHandle  := nLParam
      local nScrollCode := nLoWord( nWParam )
      local nPos        := nHiWord( nWParam )
   #endif

   If GetFocus() != ::hWnd
      SetFocus( ::hWnd )
   EndIf

   ::lFirstFocus := .F.

   if nScrHandle == 0                   // Window ScrollBar
      if ::oVScroll != nil

         Do Case
            Case nScrollCode == SB_LINEUP
                 ::GoUp()

            Case nScrollCode == SB_LINEDOWN
                 If ! ::lHitBottom
                    ::GoDown()
                 EndIf

            Case nScrollCode == SB_PAGEUP
                 ::PageUp()

            Case nScrollCode == SB_PAGEDOWN
                 ::PageDown()

            Case nScrollCode == SB_TOP
                 ::GoTop()

            Case nScrollCode == SB_BOTTOM
                 ::GoBottom()

            Case nScrollCode == SB_THUMBPOSITION
                 nBottomPos := nPos + ::oVScroll:nPgStep - 1
                 ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                                Eval( ::bLogicLen ) )

                 If ::nLen < 1
                    Return 0
                 EndIf

                 If nLParam == 1
                    ::GoTop()
                    Return 0
                 ElseIf nBottomPos >= ::oVScroll:GetRange()[ 2 ]
                    ::GoBottom()
                    Return 0
                 Else
                    CursorWait()
                    If ::bGoToPos != Nil
                       //( ::cAlias )->( Eval( ::bGoToPos, nLParam ) )
                       (::cAlias)->( Eval( ::bGoToPos, nPos ) )
                    Else
                       nSkipped := ::Skip( ( ::GetRealPos( nPos ) - ::GetRealPos( ::oVScroll:GetPos() ) ) )
                    EndIf
                    CursorArrow()
				        ::lHitTop := .f.
                    ::lHitBottom := .f.
                 EndIf

                 ::oVScroll:SetPos( nPos )

                 If ( nBottomPos - ::oVScroll:nMin ) < nLines
                    ::nRowPos := 1
                 EndIf

                 If ( ::oVScroll:nMax - nLParam ) < Min( nLines, ::nLen )
                    ::nRowPos := Min( nLines, ::nLen ) - ( ::oVScroll:nMax - nPos )
                 EndIf

                 ::Refresh( .F. )

                 If ::bChange != nil
                    Eval( ::bChange, Self, 0 )
                 EndIf

            Otherwise
                 Return Nil
         Endcase
      endif
   endif

Return 0

* ============================================================================
*                    TSBrowse   Functions
* ============================================================================


* ============================================================================
* FUNCTION TSBrowse _aData() Version 6.0 Apr/5/2002
* Called from METHOD SetCols()
* ============================================================================

Static Function _aData( aFields )

  Local aFld, nFor, nLen

  nLen := Len( aFields )
  aFld := Array( nLen )

  For nFor := 1 to nLen
     aFld[ nFor ] := Eval( aFields[ nFor ] )
  Next

Return aFld

* ============================================================================
* FUNCTION TSBrowse AClone() Version 6.0 Apr/5/2002
* Only for Harbour since by now it isn't working correctly
* ============================================================================

#ifdef __HARBOUR__
Static Function AClone( aSource )

   Local aTarget := {}

   AEval( aSource, { |e| AAdd( aTarget, e ) } )

Return aTarget
#endif

* ============================================================================
* FUNCTION TSBrowse BrwGoBottom() Version 6.0 Apr/5/2002
* Used by METHOD SetFilter() to set the bottom limit in an "Index Based"
* filtered database
* ============================================================================

Static Function BrwGoBottom( uExpr, oBrw )

   If ValType( uExpr ) == "C"
      DbSeek( SubStr( uExpr, 1, Len( uExpr ) - 1 ) + ;
              Chr( Asc( SubStr( uExpr, Len( uExpr ) ) ) + ;
              If( ! oBrw:lDescend, 1, - 1 ) ), .T. )
   Else
      DbSeek( uExpr + If( ! oBrw:lDescend, 1, - 1 ), .T. )
   EndIf

   DbSkip( -1 )

Return Nil

* ============================================================================
* FUNCTION TSBrowse BuildSkip() Version 6.0 Apr/5/2002
* Used by METHOD SetFilter(). Returns a block to be used on skipping records
* in an "Index Based" filtered database
* ============================================================================

Static Function BuildSkip( cAlias, cField, uValue1, uValue2, oTb )

   Local bSkipBlock, lDescend := oTb:lDescend, ;
         cType := ValType( uValue1 )

   Do Case
      Case cType == "C"
           If ! lDescend
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + ">= '" + uValue1 + "' .and." + ;
              cField + "<= '" + uValue2 + "' }" ), oTb ) ) }
           Else
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + "<= '" + uValue1 + "' .and." + ;
              cField + ">= '" + uValue2 + "' }" ), oTb ) ) }
           EndIf
      Case cType == "D"
           If ! lDescend
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + ">= CToD( '" + DToC( uValue1 ) + "') .and." + ;
              cField + "<= CToD( '" + DToC( uValue2 ) + "') }" ), oTb ) ) }
           Else
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + "<= CToD( '" + DToC( uValue1 ) + "') .and." + ;
              cField + ">= CToD( '" + DToC( uValue2 ) + "') }" ), oTb ) ) }
           EndIf

      Case cType == "N"
           If ! lDescend
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + ">= " + cValToChar( uValue1 ) + " .and." + ;
              cField + "<= " + cValToChar( uValue2 ) + " }" ), oTb ) ) }
           Else
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + "<= " + cValToChar( uValue1 ) + " .and." + ;
              cField + ">= " + cValToChar( uValue2 ) + " }" ), oTb ) ) }
           EndIf

      Case cType == "L"
           If ! lDescend
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + ">= " + cValToChar( uValue1 ) + " .and." + ;
              cField + "<= " + cValToChar( uValue2 ) + " }" ), oTb ) ) }
           Else
              bSkipBlock := { | n | ( cAlias )->( BrwGoTo( n, ;
              &( "{||" + cField + "<= " + cValToChar( uValue1 ) + " .and." + ;
              cField + ">= " + cValToChar( uValue2 ) + " }" ), oTb ) ) }
           EndIf
   Endcase

Return bSkipBlock

* ============================================================================
* FUNCTION TSBrowse BrwGoto() Version 6.0 Apr/5/2002
* Executes the action defined into the block created with FUNCTION BuildSkip()
* ============================================================================

Static Function BrwGoTo( n, bWhile, oTb )

   Local nSkipped := 0, ;
         nDirection := If( n > 0, 1, -1 )

   While nSkipped != n .and. Eval( bWhile ) .and. ! EoF() .and. ! BoF()
      DbSkip( nDirection )
      nSkipped += nDirection
   Enddo

   Do Case
      Case EoF()
	      DbSkip( -1 )
			If ! oTb:lAppendMode
	         nSkipped += -nDirection
			Else
				If oTb:nPrevRec == Nil
					oTb:nPrevRec := RecNo()
            EndIf
				DbGoTo( 0 )                          // phantom record
         EndIf

      Case BoF()
         DbGoTo( RecNo() )
         nSkipped++

      Case ! Eval( bWhile )
			If nDirection == 1 .and. oTb:lAppendMode
				If oTb:nPrevRec == Nil
		         DbSkip( -1 )
					oTb:nPrevRec := RecNo()
            EndIf
				DbGoTo( 0 )                          // phantom record
			Else
	         DbSkip( -nDirection )
	         nSkipped += -nDirection
         EndIf
   Endcase

Return nSkipped

* ============================================================================
* FUNCTION TSBrowse CheckBmpPal() Version 6.0 Apr/5/2002
* ============================================================================

Static Function CheckBmpPal()

   Local xVar , ;
         oBmp   := TBitmap():Define( "Test" ), ;
         bError := ErrorBlock( { | x | Break( x ) } )

   Begin Sequence
      xVar := oBmp:hBmpPal
   Recover
      ErrorBlock( bError )
      oBmp:End()
      Return .T.
   End Sequence

   ErrorBlock( bError )
   oBmp:End()

Return .F.

* ============================================================================
* FUNCTION TSBrowse:DateSeek() Version 6.0 Apr/5/2002
* ============================================================================

Static Function DateSeek( cSeek, nKey )

    Local cChar  := Chr( nKey ), ;
          nSpace := At( " ", cSeek ), ;
          cTemp  := ""

    /* only  0..9 */
    If nKey >= 48 .and. nKey <= 57
       If nSpace <> 0
          cTemp := Left( cSeek, nSpace - 1 )
          cTemp += cChar
          cTemp += SubStr( cSeek, nSpace + 1, Len( cSeek ) )
          cSeek := cTemp
       Else
          cSeek := cSeek
          Tone(500, 1)
       EndIf
    ElseIf nKey == VK_BACK
        If nSpace == 4 .or. nSpace == 7
           cTemp := Left( cSeek, nSpace - 3 )
           cTemp += " "
           cTemp += SubStr( cSeek, nSpace - 1, Len( cSeek ) )
        ElseIf nSpace == 0
           cTemp := Left( cSeek, Len( cSeek ) - 1 )
        ElseIf nSpace == 1
           cTemp := cSeek
        Else
            cTemp := Left( cSeek, nSpace - 2 )
            cTemp += " "
            cTemp += SubStr( cSeek, nSpace, Len( cSeek ) )
        EndIf
        cSeek := PadR( cTemp, 10 )
    Else
       Tone( 500, 1 )
    EndIf

Return cSeek

* ============================================================================
* FUNCTION TSBrowse EditMemo() Version 6.0 Apr/5/2002
* ============================================================================

Static Function EditMemo( cText, cTitle, oBrw, nTop, nLeft, nBottom, nRight )

   Local oFont, oDlg, oMemo, oBtnOk, oBtnCancel, oBtnHelp, ;
         uTemp := cText, ;
         lOk   := .F.

   Default nTop := 9, nLeft := 9, nBottom := 22, nRight := 68.5,;
           cTitle := oBrw:aMsg[ 32 ]

   DEFINE FONT oFont NAME "Arial" SIZE 0, -13

   DEFINE DIALOG oDlg FROM nTop, nLeft TO nBottom, nRight ;
          TITLE oBrw:aMsg[ 33 ] + Space( 1 ) + cTitle ;
          FONT oFont

   @ 4,  3 GET oMemo VAR uTemp MEMO OF oDlg PIXEL

   @78, 90 BUTTON oBtnOk PROMPT oBrw:aMsg[ 34 ] ;
           SIZE 36, 13 PIXEL ;
           ACTION ( cText := uTemp, lOk := .T., oDlg:End() )

   @ 78, 134 BUTTON oBtnCancel PROMPT oBrw:aMsg[ 35 ] ;
             SIZE 36, 13 PIXEL ACTION oDlg:End()

   @ 78, 176 BUTTON oBtnHelp PROMPT oBrw:aMsg[ 36 ] ;
             SIZE 36, 13 PIXEL ACTION HelpTopic()

   ACTIVATE DIALOG oDlg ;
      ON INIT ( oMemo:SetSize( oDlg:nWidth() - 17, oDlg:nHeight() - 69 ),;
                oBtnOk:nTop      := oDlg:nHeight() - 57, ;
                oBtnOk:nLeft     := oDlg:nWidth() - 250, ;
                oBtnCancel:nTop  := oDlg:nHeight() - 57, ;
                oBtnCancel:nLeft := oDlg:nWidth() - 167, ;
                oBtnHelp:nTop    := oDlg:nHeight() - 57, ;
                oBtnHelp:nLeft   := oDlg:nWidth() -  84 ) ;
      VALID ( oFont:End(), .T. )

Return lOk

* ============================================================================
* FUNCTION TSBrowse EmptyAlias() Version 6.0 Apr/5/2002
* Returns .T. if cAlias is not a constant "ARRAY" (browsing an array),
* or a constant "TEXT_" (browsing a text file), or an active database alias.
* ============================================================================

Static Function EmptyAlias( cAlias )

   Local nArea, bErrorBlock, ;
         lEmpty := .T.

   If ! Empty( cAlias )
      If cAlias == "ARRAY" .or. cAlias == "TEXT_"
         lEmpty:= .F.
      Else
         bErrorBlock:= ErrorBlock( {|| Break( Nil ) } )
         BEGIN SEQUENCE
            If (cAlias)->( Used() )
               lEmpty:= .F.
            EndIf
         RECOVER
         END SEQUENCE
         ErrorBlock( bErrorBlock )
      EndIf

    EndIf

Return lEmpty

* ============================================================================
* FUNCTION TSBrowse FieldSetGetBlock() Version 6.0 Apr/5/2002
* Called from METHOD LoadFields() to assign data to columns
* ============================================================================

Static Function FieldSetGetBlock( cAlias, n )

Return { | u | If( PCount() == 0,;
                 ( cAlias )->( FieldGet( n ) ),;
                 ( cAlias )->( FieldPut( n, u ) ) ) }

* ============================================================================
* FUNCTION TSBrowse GenData() Version 6.0 Apr/5/2002
* ============================================================================

Static Function GenData( aArray, nPos )

Return If( ValType(Eval(aArray[nPos]:bData)) != "U", ;
           aArray[ nPos ]:bData, {|| "" } )  // check for "phantom" columns

* ============================================================================
* FUNCTION TSBrowse GenFoot() Version 6.0 Apr/5/2002
* ============================================================================

Static Function GenFoot( aArray, nPos )

Return {|| aArray[nPos]:cFooting }

* ============================================================================
* FUNCTION TSBrowse GenHead() Version 6.0 Apr/5/2002
* ============================================================================

Static Function GenHead( aArray, nPos )

Return {|| aArray[nPos]:cHeading }

* ============================================================================
* FUNCTION TSBrowse IsChar() Version 6.0 Apr/5/2002
* Used by METHOD KeyChar() to filter keys according to the field type
* Clipper's function IsAlpha() doesn't fit the purpose in some cases
* ============================================================================

STATIC FUNCTION IsChar( nKey )

Return ( nKey >= 32 .and. nKey <= 255 )

* ============================================================================
* FUNCTION TSBrowse IsNumeric() Version 6.0 Apr/5/2002
* Function used by METHOD KeyChar() to filter keys according to the field type
* Clipper's function IsDigit() doesn't fit the purpose in some cases
* ============================================================================

STATIC FUNCTION IsNumeric( nKey )

Return ( Chr( nKey ) $ ".+-0123456789" )

* ============================================================================
* FUNCTION TSBrowse MakeBlock() Version 6.0 Apr/5/2002
* Called from METHOD Default() to assign data to columns
* ============================================================================

Static Function MakeBlock( Self, nI )

Return {|| Eval(::bLine)[ nI ] }

* ============================================================================
* METHOD TSBrowse:DeleteRow() Version 6.0 Apr/5/2002
* ============================================================================

METHOD DeleteRow( ) CLASS TSBrowse

   Local lRecall, lUpStable, nAt, nRowPos, nRecNo, lRefresh, cAlias, ;
         lEval

   If ! ::lCanDelete
      Return Nil
   EndIf

   ::lFirstFocus := .F.

   If ::lDbfObj
      cAlias := ::oDbf:cAlias
   ElseIf ::lIsDbf
      cAlias := ::cAlias
   EndIf


   nRecNo := ( cAlias  )->( RecNo() )

   lRecall := ! Set( _SET_DELETED )
   lUpStable := ! lRecall

   ::lFirstFocus := .F.

   If cAlias != "TEXT_" .and. ::oTree == Nil

      If ::lConfirm .and. ;
         ! MsgYesNo( If( ::lIsDbf, ::aMsg[ 37 ], ::aMsg[ 38 ] ), ::aMsg[ 39 ] )
         Return Self
      EndIf

      If ::lAppendMode
         Return Self
      EndIf

      ::SetFocus()

      If ::lIsDbf
         ( cAlias )->( DbGoTo( nRecNo ) )
      EndIf

      Do Case
         Case ::lIsDbf .and. ::oDbf == Nil

              If ! ( cAlias )->( RLock() )

                 MsgStop( ::aMsg[ 40 ] , ::aMsg[ 28 ] )
                 Return Self
              EndIf

              lEval := .T.

              If ::bDelete != Nil
                 lEval := Eval( ::bDelete, nRecNo, Self )
              EndIf

              If ( ValType( lEval ) == "L" .and. ! lEval )
                 Return Self
              EndIf

              If ! ( cAlias )->( Deleted() )

                 ( cAlias )->( DbDelete() )
                 ( cAlias )->( DbUnlock() )
                 ::nLen := ( cAlias )->( Eval( ::bLogicLen ) )

                 If lUpStable
                    ( cAlias )->( DbSkip() )
                    lRefresh :=  ( cAlias )->( EOF() )
                    ( cAlias )->( DbSkip( -1 ) )
                    ::nRowPos -= If( lRefresh .and. ;
                                     ! ( cAlias )->( BOF() ), 1, 0 )
                    ::Refresh( .T. )
                 EndIf

              ElseIf lRecall
                 ( cAlias )->( DbRecall() )
                 ( cAlias )->( DbUnlock() )
              EndIf

              If ::lCanAppend .and. ::nLen == 0
                 ::nRowPos := ::nColPos := 1
                 ::PostMsg( WM_KEYDOWN, VK_DOWN, nMakeLong( 0, 0 ) )
              EndIf

              If ::bPostDel != Nil
                 Eval( ::bPostDel , Self )
              EndIf

         Case ::oDbf != Nil

              lEval := .T.

              If ::bDelete != Nil
                 lEval := Eval( ::bDelete, nRecNo, Self )
              EndIf

              If ( ValType( lEval ) == "L" .and. ! lEval )
                 Return Self
              EndIf

              If ! ( cAlias )->( Deleted() )

                 ::oDbf:Delete()
                 ::nLen := ( cAlias )->( Eval( ::bLogicLen ) )

                 If lUpStable
                    ( cAlias )->( DbSkip() )
                    lRefresh :=  ( cAlias )->( EOF() )
                    ( cAlias )->( DbSkip( -1 ) )
                    ::nRowPos -= If( lRefresh .and. ;
                                     ! ( cAlias )->( BOF() ), 1, 0 )
                    ::Refresh( .T. )
                 EndIf

              ElseIf lRecall
                 ::oDbf:Recall()
              EndIf

              If ::lCanAppend .and. ::nLen == 0
                 ::nRowPos := ::nColPos := 1
                 ::PostMsg( WM_KEYDOWN, VK_RETURN, nMakeLong( 0, 0 ) )
              EndIf

              If ::bPostDel != Nil
                 Eval( ::bPostDel , Self )
              EndIf

         Case ::cAlias == "ARRAY"

              nAt := ::nAt
              nRowPos := ::nRowPos

              lEval := .T.

              If ::bDelete != Nil
                 lEval := Eval( ::bDelete, nAt, Self )
              EndIf

              If ValType( lEval ) == "L" .and. ! lEval
                 Return Self
              EndIf

              ADel( ::aArray, nAt )
              ASize( ::aArray, Len( ::aArray ) - 1 )

              If Len( ::aArray ) == 0
                 ::aArray := { AClone( ::aDefValue ) }
                 If ::aArray[ 1, 1 ] == Nil
                    ADel( ::aArray[ 1 ], 1 )
                    ASize( ::aArray[ 1 ], Len( ::aArray[ 1 ] ) - 1 )
                 EndIf
              EndIf

              If ::bPostDel != Nil
                 Eval( ::bPostDel , Self )
              EndIf

              ::nLen := Len( ::aArray )
              ::nAt := Min( nAt, ::nLen )
              ::nRowPos := Min( nRowPos, ::nLen )
              ::Refresh( .T. )
              ::DrawSelect()

      Endcase

   Else
      ::SetFocus()
      ::DrawSelect()
   EndIf

Return Self

* ============================================================================
* METHOD TSBrowse:SetBtnGet() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetBtnGet( nColumn, cResName, bAction, nBmpWidth ) CLASS TSBrowse

   Default nBmpWidth := 16

   If nColumn == Nil .or. nColumn > Len( ::aColumns ) .or. nColumn <= 0
      Return Self
   EndIf

   ::aColumns[ nColumn ]:cResName  := cResName
   ::aColumns[ nColumn ]:bAction   := bAction
   ::aColumns[ nColumn ]:nBmpWidth := nBmpWidth

Return Self

* ============================================================================
* METHOD TSBrowse:SetSpinner() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetSpinner( nColumn, lOnOff, bUp, bDown, bMin, bMax ) CLASS TSBrowse

   Default lOnOff := .T., ;
           bUp := { | oGet | oGet++ }, ;
           bDown := { | oGet | oGet++ }

   If nColumn == Nil .or. nColumn > Len( ::aColumns ) .or. nColumn <= 0
      Return Self
   EndIf

   ::aColumns[ nColumn ]:lSpinner := lOnOff
   ::aColumns[ nColumn ]:bUp      := bUp
   ::aColumns[ nColumn ]:bDown    := bDown
   ::aColumns[ nColumn ]:bMin     := bMin
   ::aColumns[ nColumn ]:bMax     := bMin

Return Self

* ============================================================================
* METHOD TSBrowse:SetSelectMode() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetSelectMode( lOnOff, bSelected ) CLASS TSBrowse

   If lOnOff == Nil .or. bSelected == Nil
      Return Self
   Endif

   ::lCanSelect := lOnOff
   ::bSelected  := bSelected
   ::aSelected := {}

Return Self

* ============================================================================
* FUNCTION TSBrowse SetHeights() Version 6.0 Apr/5/2002
* ============================================================================

Static Function SetHeights( oBrw )

   Local nEle, nHeight, nHHeight, oColumn, nAt, cHeading, cRest, nOcurs, ;
         lDrawFooters := If( oBrw:lDrawFooters != Nil, oBrw:lDrawFooters, .F. )

   If oBrw:lDrawHeaders

      nHHeight := oBrw:nHeightHead

      For nEle := 1 TO Len( oBrw:aColumns )
          oColumn := oBrw:aColumns[ nEle ]
          cHeading := If( Valtype( oColumn:cHeading ) == "B", ;
                          Eval( oColumn:cHeading ), oColumn:cHeading )

          If Valtype( cHeading ) == "C" .and. ;
             ( nAt := At( Chr( 13 ), cHeading ) ) > 0

             nOcurs := 1
             cRest := Substr( cHeading, nAt + 2 )

             While ( nAt := At( Chr( 13 ), cRest ) ) > 0
                nOcurs++
                cRest := Substr( cRest, nAt + 2 )
             EndDo

             nHeight := SBGetHeight( oBrw:hWnd, If( oColumn:oFontHead != Nil, ;
                                     oColumn:oFontHead:hFont, ;
                                     oBrw:oFont:hFont ), 0 )
             nHeight *= ( nOcurs + 1 )

             If ( nHeight + 1 ) > nHHeight
                nHHeight := nHeight + 1
             EndIf

          ElseIf Valtype( cHeading ) == "C" .and. ;
             oBrw:aColumns[ nEle ]:nHAlign == DT_VERT

             nHeight := GetTextWidth( oBrw:hDC, cHeading, ;
                                      If( oBrw:aColumns[ nEle ]:oFontHead != Nil, ;
                                          oBrw:aColumns[ nEle ]:oFontHead:hFont, ;
                                          oBrw:oFont:hFont) )
             If nHeight > nHHeight
                nHHeight := nHeight
             EndIf

          EndIf

      Next

      oBrw:nHeightHead := nHHeight

   EndIf

   If oBrw:lFooting .and. lDrawFooters

      nHHeight := oBrw:nHeightFoot

      For nEle := 1 TO Len( oBrw:aColumns )
          oColumn := oBrw:aColumns[ nEle ]
          cHeading := If( Valtype( oColumn:cFooting ) == "B", ;
                          Eval( oColumn:cFooting ), oColumn:cFooting )

          If Valtype( cHeading ) == "C" .and. ;
             ( nAt := At( Chr( 13 ), cHeading ) ) > 0

             nOcurs := 1
             cRest := Substr( cHeading, nAt + 2 )

             While ( nAt := At( Chr( 13 ), cRest ) ) > 0
                nOcurs++
                cRest := Substr( cRest, nAt + 2 )
             EndDo

             nHeight := SBGetHeight( oBrw:hWnd, If( oColumn:oFontFoot != Nil, ;
                                     oColumn:oFontFoot:hFont, ;
                                     oBrw:oFont:hFont ), 0 )
             nHeight *= ( nOcurs + 1 )

             If ( nHeight + 1 ) > nHHeight
                nHHeight := nHeight + 1
             EndIf

          EndIf

      Next

      oBrw:nHeightFoot := nHHeight

   EndIf

   // Now for cells

   nHHeight := oBrw:nHeightCell

   For nEle := 1 TO Len( oBrw:aColumns )
       oColumn := oBrw:aColumns[ nEle ]
       cHeading := Eval( oColumn:bData )

       If Valtype( cHeading ) == "C" .and. ;
          ( nAt := At( Chr( 13 ), cHeading ) ) > 0

          nOcurs := 1
          cRest := Substr( cHeading, nAt + 2 )

          While ( nAt := At( Chr( 13 ), cRest ) ) > 0
             nOcurs++
             cRest := Substr( cRest, nAt + 2 )
          EndDo

          nHeight := SBGetHeight( oBrw:hWnd, If( oColumn:oFont != Nil, ;
                                  oColumn:oFont:hFont, oBrw:oFont:hFont ), 0 )
          nHeight *= ( nOcurs + 1 )

          If ( nHeight + 1 ) > nHHeight
             nHHeight := nHeight + If( oBrw:nLineStyle != 0 .and. ;
                                       oBrw:nLineStyle != 2, 1, 0 )
          EndIf

       EndIf
   Next

   oBrw:nHeightCell := nHHeight

Return Nil

Function fDebug( cMsg )

   Local nHand, cDebug

   Default cMsg := ""

   cMsg := cValToChar( cMsg )

   cDebug := ( ProcName( 1 ) + Space( 1 ) + LTrim( Str( ProcLine( 1 ) ) ) + ;
               Space( 1 ) + cMsg + CRLF )

   If ( nHand := FOpen( "Debug.log", 2 ) ) <= 0
      If ( nHand := FCreate( "Debug.log", 0 ) ) <= 0
         MsgInfo( "Unable to create debug.log" )
         Return Nil
      EndIf
   EndIf

   FSeek( nHand, 0, 2 )

   FWrite( nHand, cDebug, Len( cDebug ) )

   FClose( nHand )

Return Nil

* ============================================================================
* METHOD TSBrowse:SetFont() Version 6.0 Apr/5/2002
* ============================================================================

METHOD SetFont( oFont ) CLASS TSBrowse

   If ::lIsV22
      Super:SetFont( oFont )
      oFont:nCount++
      Return Nil
   EndIf

   If ::oFont != Nil .and. ValType( ::oFont ) == "O"
      If ::oFont:nCount != Nil .and. ::oFont:nCount > 0
         ::oFont:nCount--
      Else
         ::oFont:End()
      EndIf
   EndIf

   If oFont != Nil
      ::oFont = oFont
      Default oFont:nCount := 0   // Xbase++ requirement
      oFont:nCount++
      SendMessage( ::hWnd, WM_SETFONT, oFont:hFont )
   EndIf

Return 0

* ============================================================================
* METHOD TSBrowse:GetRealPos() Version 6.0 Apr/5/2002
* ============================================================================

METHOD GetRealPos( nRelPos ) CLASS TSBrowse

   Local nLen

   Default ::nLen := If( ::lIsDbf, ( ::cAlias )->( Eval( ::bLogicLen ) ), ;
                          Eval( ::bLogicLen ) )

   nLen := ::nLen

   nRelPos := If( nLen > MAX_POS, Int( ( nRelPos / MAX_POS ) * nLen ), nRelPos )

Return nRelPos

* ============================================================================
* METHOD TSBrowse:HandleEvent() Version 6.0 Apr/5/2002
* ============================================================================

METHOD HandleEvent( nMsg, nWParam, nLParam ) CLASS TSBrowse

   Local nDelta, nRow, nCol, aCoors

   If nMsg == WM_MOUSEWHEEL
      nCol := nLoWord( nLParam )
      nRow := nHiWord( nLParam )
      aCoors := ClientToScreen( ::hWnd, aCoors )

      If nRow >= aCoors[ 1 ] .and. nCol >= aCoors[ 2 ] .and. ;
         nRow <= ( aCoors[ 1 ] + ::nHeight() )  .and. ;
         nCol <= ( aCoors[ 2 ] + ::nWidth() )

         #ifndef __HARBOUR__
            nDelta := Bin2I( I2Bin( GetMsgInfo() ) ) / 120
         #else
            // This returns 1 for wheel up, -1 wheel down
            nDelta := Bin2I( I2Bin( nHiWord( nWParam ) ) ) / 120
            // nWheelScrollLines: if -1, then page up/down, else no. lines to scroll
            if ::nWheelScrollLines > 0
               nDelta:= ::nWheelScrollLines * nDelta
            endif
         #endif

         If ( nDelta ) > 0
            if ::nWheelScrollLines = -1
               nWParam := SB_PAGEUP
            else
               nWParam := SB_LINEUP
            endif
         Else
            if ::nWheelScrollLines = -1
               nWParam := SB_PAGEDOWN
            else
               nWParam := SB_LINEDOWN
            endif
            nDelta := abs( nDelta )
         EndIf

         While nDelta > 0
            ::VScroll( nWParam, 0 )
            nDelta--
         EndDo

         Return 0

      EndIf

   Endif  // mouse wheel

Return Super:HandleEvent( nMsg, nWParam, nLParam )

DLL32 FUNCTION GetMsgInfo() AS LONG PASCAL ;
      FROM "GetMessageExtraInfo" LIB "User32.dll"


* ============================================================================
* METHOD TSBrowse:Set3DText() Version 6.0 Apr/5/2002
* ============================================================================

METHOD Set3DText( lOnOff, lRaised, nColumn, nLevel, nClrLight, ;
                  nClrShadow ) CLASS TSBrowse

   Local nEle

   Default lOnOff     := .T., ;
           lRaised    := .T., ;
           nClrLight  := GetSysColor( COLOR_BTNHIGHLIGHT ), ;
           nClrShadow := GetSysColor( COLOR_BTNSHADOW )

   If Empty( ::aColumns ) .or. ;
      ( Len( ::aColumns ) == 1 .and. ::aColumns[ 1 ]:cHeading == "_Dummy" )
      Return Self
   EndIf

   If ! lOnOff
      If Empty( nColumn )
         If Empty( nLevel )
            For nEle := 1 To Len( ::aColumns )
               ::aColumns[ nEle ]:l3DTextCell := Nil
               ::aColumns[ nEle ]:l3DTextHead := Nil
               ::aColumns[ nEle ]:l3DTextFoot := Nil
            Next
         ElseIf nLevel == 1
            For nEle := 1 To Len( ::aColumns )
               ::aColumns[ nEle ]:l3DTextCell := Nil
            Next
         ElseIf nLevel == 2
            For nEle := 1 To Len( ::aColumns )
               ::aColumns[ nEle ]:l3DTextHead := Nil
            Next
         Else
            For nEle := 1 To Len( ::aColumns )
               ::aColumns[ nEle ]:l3DTextFoot := Nil
            Next
         EndIf

      ElseIf Empty( nLevel )
         ::aColumns[ nColumn ]:l3DTextCell := Nil
         ::aColumns[ nColumn ]:l3DTextHead := Nil
         ::aColumns[ nColumn ]:l3DTextFoot := Nil
      ElseIf nLevel == 1
         ::aColumns[ nColumn ]:l3DTextCell := Nil
      ElseIf nLevel == 2
         ::aColumns[ nColumn ]:l3DTextHead := Nil
      Else
         ::aColumns[ nColumn ]:l3DTextFoot := Nil
      EndIf

      Return Self

   EndIf

   If Empty( nColumn )
      If Empty( nLevel )
         For nEle := 1 To Len( ::aColumns )
            ::aColumns[ nEle ]:l3DTextCell  := lRaised
            ::aColumns[ nEle ]:l3DTextHead  := lRaised
            ::aColumns[ nEle ]:l3DTextFoot  := lRaised
            ::aColumns[ nEle ]:nClr3DLCell  := nClrLight
            ::aColumns[ nEle ]:nClr3DLHead  := nClrLight
            ::aColumns[ nEle ]:nClr3DLFoot  := nClrLight
            ::aColumns[ nEle ]:nClr3DSCell  := nClrShadow
            ::aColumns[ nEle ]:nClr3DSHead  := nClrShadow
            ::aColumns[ nEle ]:nClr3DSFoot  := nClrShadow
         Next
      ElseIf nLevel == 1
         For nEle := 1 To Len( ::aColumns )
            ::aColumns[ nEle ]:l3DTextCell  := lRaised
            ::aColumns[ nEle ]:nClr3DLCell  := nClrLight
            ::aColumns[ nEle ]:nClr3DSCell  := nClrShadow
         Next
      ElseIf nLevel == 2
         For nEle := 1 To Len( ::aColumns )
            ::aColumns[ nEle ]:l3DTextHead  := lRaised
            ::aColumns[ nEle ]:nClr3DLHead  := nClrLight
            ::aColumns[ nEle ]:nClr3DSHead  := nClrShadow
         Next

      Else
         For nEle := 1 To Len( ::aColumns )
            ::aColumns[ nEle ]:l3DTextFoot  := lRaised
            ::aColumns[ nEle ]:nClr3DLFoot  := nClrLight
            ::aColumns[ nEle ]:nClr3DSFoot  := nClrShadow
         Next
      EndIf
   Else
      If Empty( nLevel )
         ::aColumns[ nColumn ]:l3DTextCell  := lRaised
         ::aColumns[ nColumn ]:l3DTextHead  := lRaised
         ::aColumns[ nColumn ]:l3DTextFoot  := lRaised
         ::aColumns[ nColumn ]:nClr3DLCell  := nClrLight
         ::aColumns[ nColumn ]:nClr3DLHead  := nClrLight
         ::aColumns[ nColumn ]:nClr3DLFoot  := nClrLight
         ::aColumns[ nColumn ]:nClr3DSCell  := nClrShadow
         ::aColumns[ nColumn ]:nClr3DSHead  := nClrShadow
         ::aColumns[ nColumn ]:nClr3DSFoot  := nClrShadow
      ElseIf nLevel == 1
         ::aColumns[ nColumn ]:l3DTextCell  := lRaised
         ::aColumns[ nColumn ]:nClr3DLCell  := nClrLight
         ::aColumns[ nColumn ]:nClr3DSCell  := nClrShadow
      ElseIf nLevel == 2
         ::aColumns[ nColumn ]:l3DTextHead  := lRaised
         ::aColumns[ nColumn ]:nClr3DLHead  := nClrLight
         ::aColumns[ nColumn ]:nClr3DSHead  := nClrShadow
      Else
         ::aColumns[ nColumn ]:l3DTextFoot  := lRaised
         ::aColumns[ nColumn ]:nClr3DLFoot  := nClrLight
         ::aColumns[ nColumn ]:nClr3DSFoot  := nClrShadow
      EndIf
   EndIf

Return Self
